# Polygon Algorithms

Implementations of Polygon algorithms.

<p align="center">
  <img src="images/convex_hull.png" width="45%" style="padding:5px"/>
  <img src="images/spiral_star.png" width="45%"  style="padding:5px"/> 
</p>

## Description
### Representation

There are several ways to represent polygons:
- As a list of points (tuples). The last point is assumed to share an edge with the first: `n + 1 = 1`.
- With the internal `PolygonAlgorithms.Polygon` struct. This struct consists of an `exterior` and `holes`. Each sub-object must be a list of points (tuples). The holes should be properly contained in the polygon.
Validation is not performed by default. Pass `validate=true` to the constructor to enable it.
- As a list of segments. This representation naturally allows multi-polygons and holes. 
It is used internally for some algorithms including the `martinez_rueda_algorithm`.

For indexing use `x_coords` and `y_coords`. 
Common broadcasting operations are supplied such as `translate` and `rotate`.

An alternative representation for polygons is as 2&times;N matrices. 
This is not used here, but can be more efficient for indexing and broadcasting operations such as translation and rotation.
To convert to this representation and back, use `matrix_to_points` or `points_to_matrix`.

### Example

```julia
using PolygonAlgorithms
using PolygonAlgorithms: x_coords, y_coords

poly = [
    (0.4, 0.5), (0.7, 2.0), (5.3, 1.4), (4.0, -0.6)
]
area_polygon(poly) # 7.855
contains(poly, (2.0, 0.5)) # true
contains(poly, (10.0, 10.0)) # false

poly2 = [
    (3.0, 3.0), (4.0, 1.0), (3.0, 0.5), (2.0, -0.5), (1.5, 0.9)
]
intersection = intersect_geometry(poly, poly2)

using Plots
idxs = vcat(1:length(poly), 1)
plot(x_coords(poly, idxs), y_coords(poly, idxs))
```

## Polygon Functions

For all of the the following `n` and `m` are the number of vertices of the polygons.

1. `area_polygon`, `centroid_polygon`, `first_moment`, `is_clockwise`, `is_counter_clockwise`
    - Operations: area of polygon, centroid of polygon, polygon direction.
    - Algorithm: Shoe-lace formula.
    - Time complexity: `O(n)`.
    - Reference: [Wikipedia](https://en.wikipedia.org/wiki/Polygon#Area).
2. `bounds`
    - Operation: bounding rectangle of a polygon.
    - Algorithm: linear serach.
    - Time complexity: `O(n)`.
3. `contains`
    - Operation: point in polygon.
    - Algorithm: Ray casting with an extension from the following paper: "A Simple and Correct Even-Odd Algorithm for the Point-in-Polygon Problem for Complex Polygons" by Michael Galetzka and Patrick Glauner (2017).
    - Time complexity: `O(n)`. 
    - Reference: [Wikipedia](https://en.wikipedia.org/wiki/Point_in_polygon), [paper](https://arxiv.org/abs/1207.3502).
4. `convex_hull`
    - Operation: minimum convex hull around a set of points.
    - Gift-wrapping algorithm:
        - Time complexity: `O(nh)` where `h` is the number of points in the hull.
        - Reference: [Wikipedia](https://en.wikipedia.org/wiki/Gift_wrapping_algorithm).
    - Graham Scan algorithm:
        - Time complexity: `O(n*log(n))`.
5. `intersect_convex`
    - Operation: intersection of convex polygons (polygon clipping). 
    - Chasing edges algorithm (default):
        - Convex only.
        - From "A New Linear Algorithm for Intersecting Convex Polygons" (1981) by Joseph O'Rourke et. al.
        - Time complexity: `O(n+m)`.
        - Reference: https://www.cs.jhu.edu/~misha/Spring16/ORourke82.pdf
    -  Point search algorithm:
        - Convex only.
        - Combines point in polygon algorithm with intersection of edges.
        - Time complexity: `O(nm)`.
        - For general non-self-intersecting polygons, the intersection points are valid but the order is not.
    - Martinez-Rueda algorithm (default):
        - See point 7.
    - Weiler-Atherton algorithm:
        - See point 6.
6. `intersect_geometry`
    - Operation: Intersection of polygons (polygon clipping).
    - Martinez-Rueda algorithm (default).
        - See point 7.
    - Weiler-Atherton algorithm:
        - Concave and convex but not self-intersecting.
        - Time complexity: `O(nm)`. 
        - For a full explanation, see my [blog post](https://liorsinai.github.io/mathematics/2023/09/30/polygon-clipping.html).
7. `difference_geometry`, `intersect_geometry`, `union_geometry`, `xor_geometry`
    - Operation: boolean operations on polygons.
    - Algorithm: Martinez-Rueda.
    - Concave, convex and self-intersecting with holes. Can operate on multiple polygons at once.
    - Annotates each segments with 4 fill criteria: filled by itself above and/or below, and filled by the other polygon above and/or below. Once this has been accomplished, it is trivial to select segments which match the given operation. These segments are then combined to form the final polygon.
    - Time complexity: `O((n+m+k)log(n+m))`. 
    - Reference: https://www.researchgate.net/publication/220163820_A_new_algorithm_for_computing_Boolean_operations_on_polygons
    - Blog post: https://sean.fun/a/polygon-clipping-pt2/
    <p align="center">
    <img src="images/martinez_reuda.png" width="80%" style="padding:5px"/>
   </p>

## Robustness

Mathematically, the algorithms are infinitely precise.
Practically, this code works with floats that require a tolerance threshold.
The philosophy of this package is to define tolerances that can be passed down as keyword arguments throughout the entire algorithm.
The two main tolerances are the absolute tolerance `atol` and the relative tolerance `rtol`. 
They take the default values of `PolygonAlgorithms.default_atol` and `PolygonAlgorithms.default_rtol` respectively which are both set to `1e-6`.

Several core functions make use of `atol` including:
- `PolygonAlgorithms.is_same_point`: two points are the same if the straight line distance separating them is less than `atol`.
- `PolygonAlgorithms.get_orientation`: three points are colinear if the [cross product](https://mathworld.wolfram.com/CrossProduct.html) is less than `atol`.
- `PolygonAlgorithms.intersect_geometry`: for the line method, two lines are considered parallel if the absolute value of the determinant of the intersection matrix is less than `atol`.

Some functions make use of `rtol` including:
- `PolygonAlgorithms.intersect_geometry`: for the segment method, an intersection is considered valid even if the segments intersect a proportion `rtol` outside of the line length.

### Case studies

In the first example, the tolerances are essential to avoid failure:

<p align="center">
  <img src="images/robustness_star.png" width="45%" style="padding:5px"/>
</p>

The polygons are defined by:
```julia
polygon1 = [
    (0.0, 18.0), (3.0, 5.0), (15.0, 5.0), (5.0, 0.0), (10.0, -12.0), 
    (0.0, -2.0), (-10.0, -12.0), (-5.0, 0.0), (-15.0, 5.0), (-3.0, 5.0)
]
polygon2 = PolygonAlgorithms.rotate(poly1, π/1.0, (0.0, 0.0));
```

Note that the second polygon is computationally rotated. 
This is numerically accurate up to approximately `eps(Float64)=2.2e-16`.
Therefore, the points will not exactly align below this tolerance.
Because of this, running `intersect_geometry(polygon1, polygon2; atol=atol)` will only succeed for `atol>=1e-14`. 

In the next example, the tolerances are the cause of the failure:

<p align="center">
  <img src="images/robustness_segments.png" width="45%" style="padding:5px"/>
</p>

These segments are defined by:
```julia
segment1 = ((340.0, 710.0), (1450.0, 860.0))
segment2 = ((830.0, 1150.0), (1540.0, 600.0))
segment3 = ((1180.0, 170.0), (1260.0, 1040.0))
```

These segments look like they intersect at a single point. 
However, upon magnification by a factor of 1.5 million, it is evident that they intersect at 3 different points.
The two black segments - the top half of `segment3` (green) and a middle section of `segment1` (blue) - at this magnification do not intersect.
However, because the first segment is much larger than the first, they are considered to intersect for `rtol<=1e-6`.
Yet if we do use `rtol<=1e-6`, this will cause the Martinez-Rueda algorithm to fail.
This is because it maintains a precise order of segments and their intersections, and will fail if these are classified incorrectly.

This example is from [Clipper2: test 141](https://github.com/AngusJohnson/Clipper2/blob/main/Tests/Polygons.txt).
[Clipper2](https://www.angusj.com/clipper2/Docs/Robustness.htm) has a different approach to robustness: it casts all numbers to integers.
Hence for this example the intersections will be collapsed to a single point, and the segments adjusted slightly.
This means that the two halves of each segment will no longer lie perfectly on a straight line.

## Installation

In the Julia REPL:
```
julia> ] #enter package mode
(@v1.x) pkg> add PolygonAlgorithms
julia> using PolygonAlgorithms
```

Optionally, tests can be run with:
```
(@v1.x) pkg> test PolygonAlgorithms
```

For locally development: download the GitHub repository. Then in the Julia REPL:
```
julia> ] #enter package mode
(@v1.x) pkg> dev path\\to\\PolygonAlgorithms
julia> using Revise # allows dynamic edits to code
julia> using PolygonAlgorithms
```

## Related

- [PolygonOps](https://github.com/JuliaGeometry/PolygonOps.jl)
- [PolygonClipping](https://github.com/JuliaGeometry/PolygonClipping.jl)

@testset "DoublyLinkedList" begin

using PolygonAlgorithms: DoublyLinkedList, Node, collect_nodes

@testset "list basic" begin
    head = Node(1.0)
    list = DoublyLinkedList(head)
    push!(list, 2.0)
    push!(list, 3.0)

    node2 = head.next
    @test !isnothing(node2)
    @test node2.data == 2.0
    @test node2.prev == head
    
    node3 = node2.next
    @test !isnothing(node3)
    @test node3.data == 3.0
    @test node3.prev == node2
    @test node3.next == head

    nodes = collect_nodes(list)
    @test nodes == [head, node2, node3]

    expected = "1.0, 2.0, 3.0"
    result = join(list, ", ")
    @test result == expected
end

@testset "list insert" begin
    head = Node(1.0)
    list = DoublyLinkedList(head)
    node2 = push!(list, 2.0)
    node3 = push!(list, 3.0)

    node1_5 = insert!(head, 1.5)
    @test node1_5.data == 1.5
    @test node1_5 == head.next
    @test node1_5.prev == head
    @test node1_5 != node2
    @test node1_5 == node2.prev

    node2_5 = insert!(node2, 2.5)
    @test node2_5.data == 2.5
    @test node2_5 == node2.next
    @test node2_5 == node3.prev

    node3_5 = insert!(node3, 3.5)
    @test node3_5 == node3.next
    @test node3_5.prev == node3
    @test node3_5.next == head

    expected = "1.0, 1.5, 2.0, 2.5, 3.0, 3.5"
    result = join(list, ", ")
    @test result == expected
end

end

using PolygonAlgorithms: PointSet

@testset "edge intersections" begin

@testset "intersect segments" begin
    seg1 = ((1.0, 1.0), (2.0, 3.0));

    seg2 = ((1.0, 3.0), (4.0, 1.0));
    @test do_intersect(seg1, seg2)
    @test intersect_geometry(seg1, seg2) == (1.75, 2.5)

    seg2 = ((1.0, 1.0), (4.0, 3.0)); # point is on vertex
    @test do_intersect(seg1, seg2)
    @test intersect_geometry(seg1, seg2) == (1.0, 1.0)

    seg2 = ((1.0, 0.0), (4.0, 3.0));
    @test !do_intersect(seg1, seg2)
    @test isnothing(intersect_geometry(seg1, seg2))

    seg2 = ((2.0, 2.0), (5.0, 0.0)); # point is on seg1 but not seg2
    @test !do_intersect(seg1, seg2)
    @test isnothing(intersect_geometry(seg1, seg2))

    seg2 = ((1.0, 0.0), (2.0, 2.0)); # parallel
    @test !do_intersect(seg1, seg2)
    @test isnothing(intersect_geometry(seg1, seg2))

    seg2 = ((1.5, 2.0), (2.5, 4.0)); # parallel & overlap
    @test do_intersect(seg1, seg2)
    @test isnothing(intersect_geometry(seg1, seg2))
end;

@testset "intersect 90 degree segments" begin
    seg1 = ((1.0, 1.0), (1.0, 4.0));

    seg2 = ((-1.0, 2.0), (4.0, 2.0)); # horizontal
    @test do_intersect(seg1, seg2)
    @test intersect_geometry(seg1, seg2) == (1.0, 2.0)

    seg2 = ((1.0, 2.0), (4.0, 2.0)); # point is on vertex
    @test do_intersect(seg1, seg2)
    @test intersect_geometry(seg1, seg2) == (1.0, 2.0)

    seg2 = ((2.0, 2.0), (4.0, 2.0)); # point is on seg1 but not seg2
    @test !do_intersect(seg1, seg2)
    @test isnothing(intersect_geometry(seg1, seg2))

    seg2 = ((3.0, 1.0), (3.0, 4.0)); # parallel
    @test !do_intersect(seg1, seg2)
    @test isnothing(intersect_geometry(seg1, seg2))
end;

@testset "intersect floating point error" begin
    seg1 = ((-1.0, 0.25), (1.0, 0.25))
    seg2 = ((0.4, 0.4), (0.4, -0.4))

    @test do_intersect(seg1, seg2)
    @test all(intersect_geometry(seg1, seg2) .≈ (0.4, 0.25))
end

@testset "intersect rectangles" begin
    poly1 = [
        (0.0, 0.0), (0.0, 2.0), (2.0, 2.0), (2.0, 0.0)
    ]

    points = intersect_edges(poly1, poly1)
    @test PointSet(points) == PointSet(poly1)

    # overlap
    poly2 = translate(poly1, (1.0, 1.0))
    expected = [
        (1.0, 2.0), (2.0, 1.0)
        ]
    points = intersect_edges(poly1, poly2)
    @test PointSet(points) == PointSet(expected)

    # overlap along edges
    poly2 = translate(poly1, (1.0, 0.0))
    expected = [
        (1.0, 2.0), (2.0, 2.0), (2.0, 0.0), (1.0, 0.0)
        ]
    points = intersect_edges(poly1, poly2)
    @test PointSet(points) == PointSet(expected)

    # single point of itersection
    poly2 = translate(poly1, (2.0, 2.0))
    expected = [(2.0, 2.0)]
    points = intersect_edges(poly1, poly2)
    @test PointSet(points) == PointSet(expected)

    # intersect along edge
    poly2 = translate(poly1, (2.0, 1.0))
    expected = [
        (2.0, 2.0),
        (2.0, 1.0)
        ]
    points = intersect_edges(poly1, poly2)
    @test PointSet(points) == PointSet(expected)

    # no intersection
    poly2 = translate(poly1, (3.0, 3.0))
    expected = []
    points = intersect_edges(poly1, poly2)
    @test isempty(points)
end

@testset "cross" begin
    poly1 = [
        (0.0, 0.0), (0.0, 2.0), (1.0, 2.0), (1.0, 0.0)
    ]
    poly2 = [
        (-1.0, 1.5), (2.0, 1.5), (2.0, 0.5), (-1.0, 0.5)
    ]
    expected = [
        (0.0, 1.5), (0.0, 0.5), (1.0, 1.5), (1.0, 0.5)
    ]
    points = intersect_edges(poly1, poly2)
    @test PointSet(points) == PointSet(expected)
end

@testset "star of david" begin
    h = sqrt(3)
    poly1 = translate([
        (-1.0, 0.0), (0.0, h), (1.0, 0.0)
        ], (0.0, -h/3)
    )
    poly2 = translate([
        (-1.0, 0.0), (0.0, -h), (1.0, 0.0)
        ], (0.0, h/3)
    )
    
    expected = [
        (-2/3, 0.0), 
        (+2/3, 0.0),
        (-1/3, -h/3),
        (-1/3, +h/3),
        (+1/3, -h/3),
        (+1/3, +h/3),
        ]
    points = intersect_edges(poly1, poly2)
    @test PointSet(points) == PointSet(expected)
end

@testset "generic convex" begin
    poly1 = [
        (0.0, 0.4),
        (0.3, 0.2),
        (0.7, 0.3),
        (0.9, 0.7),
        (0.4, 0.7),
    ]
    poly2 = [
        (0.3, 0.4),
        (0.9, 0.1),
        (0.7, 0.4),
        (0.2, 0.9),
        (0.1, 0.6),
    ]

    expected = 
    [
        (0.4, 0.7),
        (0.566667, 0.266667),
        (0.171429, 0.528571),
        (0.728571, 0.357143),
    ]
    points = intersect_edges(poly1, poly2)
    @test PointSet(points) == PointSet(expected)
end

end

"""
    bounds(polygon)

A rectangle which bounds the polygon, given as `(xmin, ymin, xmax, ymax)`.
"""
function bounds(polygon::Polygon2D)
    start = polygon[1]
    xmin = start[1]
    xmax = start[1]
    ymin = start[2]
    ymax = start[2]
    for (x, y) in polygon
        xmin = min(xmin, x)
        xmax = max(xmax, x)
        ymin = min(ymin, y)
        ymax = max(ymax, y)
    end
    (xmin, ymin, xmax, ymax)
end

"""
    bounds(polygons)

A rectangle which bounds all the polygons, given as `(xmin, ymin, xmax, ymax)`.
"""
function bounds(polygons::Vector{<:Polygon2D})
    start = polygons[1][1]
    xmin = start[1]
    xmax = start[1]
    ymin = start[2]
    ymax = start[2]
    for polygon in polygons
        x0, y0, x1, y1 = bounds(polygon)
        xmin = min(xmin, x0, x1)
        xmax = max(xmax, x0, x1)
        ymin = min(ymin, y0, y1)
        ymax = max(ymax, y0, y1)
    end
   (xmin, ymin, xmax, ymax)
end

function box(xmin::T, ymin::T, xmax::T, ymax::T) where T
    [(xmin, ymin), (xmin, ymax), (xmax, ymax), (xmax, ymin)]
end

using Test
using PolygonAlgorithms: SegmentEvent, SegmentAnnotations
using PolygonAlgorithms: add_annotated_segment!, compare_events, convert_to_event_queue
using PolygonAlgorithms: check_and_divide_intersection!, event_loop!
using PolygonAlgorithms: chain_segments
using PolygonAlgorithms: is_hole, match_holes_polygons, Polygon
using PolygonAlgorithms: BLANK

@testset "Martinez-Rueda algorithm" verbose=false begin

    @testset "almost vertical" begin
        # the original segment was ((0.5345889348336309, 0.9626445530693036), (0.5346819812512368, 0.7153822809806809))
        # it was not vertical, but the two intersecting lines make a tiny vertical segment
        event_queue = [
            SegmentEvent(((0.5346362515873916, 0.8369046444971744), (0.5346819812512368, 0.7153822809806809)), true),
            SegmentEvent(((0.5346362515873916, 0.8369046444971744), (0.702057739662388, 0.63591526606886130)), true),
            SegmentEvent(((0.5346358170779485, 0.8380593132624886), (0.5346362515873916, 0.8369046444971744)), true),
            SegmentEvent(((0.5346358170779485, 0.8380593132624886), (0.6336845198791616, 0.7251516629897194)), true),
        ]
        # the event_loop! modified event_queue[3] with update_end!
        # now, the tail should be inserted after it.
        tail = SegmentEvent(event_queue[3].segment, false)
        idx = searchsortedfirst(event_queue, tail; lt=compare_events)
        @test_broken idx == 5
    end

    @testset "divide" begin
        @testset "divide no intersection" begin
            # setup
            ev1_start = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true)
            ev1_end = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), false)
            ev1_start.other = ev1_end
            ev1_end.other = ev1_start
            ev2_start = SegmentEvent(((4.0, 5.0), (8.0, 3.0)), true)
            ev2_end = SegmentEvent(((4.0, 5.0), (8.0, 3.0)), false)
            ev2_start.other = ev2_end
            ev2_end.other = ev2_start
            queue = [ev1_start, ev2_start, ev1_end, ev2_end]
            # test
            check_and_divide_intersection!(queue, ev1_start, ev2_start, false)
            @test length(queue) == 4
        end

        @testset "divide intersection" begin
            # setup
            ev1_start = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true)
            ev1_end = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), false)
            ev1_start.other = ev1_end
            ev1_end.other = ev1_start
            ev2_start = SegmentEvent(((4.0, 0.0), (7.0, 3.0)), true)
            ev2_end = SegmentEvent(((4.0, 0.0), (7.0, 3.0)), false)
            ev2_start.other = ev2_end
            ev2_end.other = ev2_start
            queue = [ev1_start, ev2_start, ev1_end, ev2_end]
            # test
            check_and_divide_intersection!(queue, ev1_start, ev2_start, false)
            expected = [
                ev1_start,
                ev2_start,
                ev2_end,
                ev1_end,
                SegmentEvent(((5.0, 1.0), (7.0, -1.0)), true),
                SegmentEvent(((5.0, 1.0), (7.0, 3.0)), true),
                SegmentEvent(((5.0, 1.0), (7.0, -1.0)), false),
                SegmentEvent(((5.0, 1.0), (7.0, 3.0)), false),
            ]
            @test queue == expected
        end

        @testset "divide along1" begin
            # setup
            ev1_start = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true)
            ev1_end = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), false)
            ev1_start.other = ev1_end
            ev1_end.other = ev1_start
            ev2_start = SegmentEvent(((4.0, 2.0), (7.0, 5.0)), true)
            ev2_end = SegmentEvent(((4.0, 2.0), (7.0, 5.0)), false)
            ev2_start.other = ev2_end
            ev2_end.other = ev2_start
            queue = [ev1_start, ev2_start, ev1_end, ev2_end]
            # test
            check_and_divide_intersection!(queue, ev1_start, ev2_start, false)
            expected = [
                ev1_start,
                ev1_end,
                SegmentEvent(((4.0, 2.0), (7.0, -1.0)), true), 
                ev2_start,
                SegmentEvent(((4.0, 2.0), (7.0, -1.0)), false), 
                ev2_end
            ]
            @test queue == expected
        end

        @testset "divide coincident" begin
            # setup
            ev1_start = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), true)
            ev1_end = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), false)
            ev1_start.other = ev1_end
            ev1_end.other = ev1_start
            ev2_start = SegmentEvent(((4.0, 2.0), (7.0, -1.0)), true)
            ev2_end = SegmentEvent(((4.0, 2.0), (7.0, -1.0)), false)
            ev2_start.other = ev2_end
            ev2_end.other = ev2_start
            queue = [ev1_start, ev2_start, ev1_end, ev2_end]
            # test
            check_and_divide_intersection!(queue, ev1_start, ev2_start, false)
            @test length(queue) == 4 # no change because ev1 is processed before ev2
            check_and_divide_intersection!(queue, ev2_start, ev1_start, false)
            expected = [
                ev1_start,
                ev1_end,
                SegmentEvent(((4.0, 2.0), (5.0, 1.0)), true),
                ev2_start,
                SegmentEvent(((4.0, 2.0), (5.0, 1.0)), false),
                ev2_end,
                SegmentEvent(((5.0, 1.0), (7.0, -1.0)), true),
                SegmentEvent(((5.0, 1.0), (7.0, -1.0)), false),
            ]
            @test queue == expected
        end

        @testset "divide coincident same start" begin
            # setup
            ev1_start = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), true)
            ev1_end = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), false)
            ev1_start.other = ev1_end
            ev1_end.other = ev1_start
            primary = true
            self_annotations = SegmentAnnotations(true, false)
            ev2_start = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true, primary, self_annotations)
            ev2_end = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), false, primary, self_annotations)
            ev2_start.other = ev2_end
            ev2_end.other = ev2_start
            queue = [ev1_start, ev2_start, ev1_end, ev2_end]
            # test
            check_and_divide_intersection!(queue, ev1_start, ev2_start, true)
            expected = [
                ev2_start,
                ev2_end,
                SegmentEvent(((5.0, 1.0), (7.0, -1.0)), true, true, self_annotations),
                SegmentEvent(((5.0, 1.0), (7.0, -1.0)), false, true, self_annotations),
            ]
            @test queue == expected
        end

        @testset "divide same intersection" begin
            # setup
            ev1_start = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), true)
            ev1_end = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), false)
            ev1_start.other = ev1_end
            ev1_end.other = ev1_start
            primary = true
            self_annotations = SegmentAnnotations(true, false)
            ev2_start = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), true, primary, self_annotations)
            ev2_end = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), false, primary, self_annotations)
            ev2_start.other = ev2_end
            ev2_end.other = ev2_start
            queue = [ev1_start, ev2_start, ev1_end, ev2_end]
            # test
            check_and_divide_intersection!(queue, ev1_start, ev2_start, true)
            @test queue == [ev2_start, ev2_end]
        end
    end

    @testset "annotations" begin
        @testset "rectangle self annotations" begin
            rectangle = [
                (3.0, 3.0), (7.0, -1.0), (4.0, -4.0), (0.0, 0.0)
            ];
            event_queue = convert_to_event_queue(rectangle)
            annotated_segments = event_loop!(event_queue; self_intersection=true)
            expected = [
                SegmentEvent(((0.0, 0.0), (3.0, 3.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((0.0, 0.0), (4.0, -4.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((4.0, -4.0), (7.0, -1.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true, true, SegmentAnnotations(false, true)),
            ]
            @test annotated_segments == expected
        end

        @testset "rectangle horiz self annotations" begin
            rectangle_horiz = [
                (-1.0, 0.0), (-1.0, 3.0), (12.0, 3.0), (12.0, 0.0)
            ];
            event_queue = convert_to_event_queue(rectangle_horiz)
            annotated_segments = event_loop!(event_queue; self_intersection=true)
            expected = [
                SegmentEvent(((-1.0, 0.0), (-1.0, 3.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((-1.0, 0.0), (12.0, 0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((12.0, 0.0), (12.0, 3.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((-1.0, 3.0), (12.0, 3.0)), true, true, SegmentAnnotations(false, true)),
            
            ]
            @test annotated_segments == expected
        end

        @testset "self-intersect self annotations" begin
            self_intersect = [
                (0.0, 0.0), (2.0, 2.0), (6.0, -2.0), (11.0, 2.0), (11.0, 0.0)
            ]
            event_queue = convert_to_event_queue(self_intersect)
            annotated_segments = event_loop!(event_queue; self_intersection=true)
            expected = [
                SegmentEvent(((0.0, 0.0), (2.0, 2.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((0.0, 0.0), (4.0, 0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((2.0, 2.0), (4.0, 0.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((4.0, 0.0), (6.0, -2.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((6.0, -2.0), (8.5, -0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((4.0, 0.0), (8.5, -0.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((8.5, -0.0), (11.0, 0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((11.0, 0.0), (11.0, 2.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((8.5, -0.0), (11.0, 2.0)), true, true, SegmentAnnotations(false, true)),
            ]
            @test annotated_segments == expected
        end

        @testset "pentagram self annotations" begin
            pentagon = [
                (-0.8, 0.0), (0.0, 0.6), (0.8, 0.0), (0.5, -1.0), (-0.5, -1.0)
            ]
            pentagram = pentagon[[1, 3, 5, 2, 4]]
            event_queue = convert_to_event_queue(pentagram)
            annotated_segments = event_loop!(event_queue; self_intersection=true)
            expected = [
                SegmentEvent(((-0.5, -1.0), (-0.3062015503875969, -0.3798449612403101)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((-0.8, 0.0), (-0.3062015503875969, -0.3798449612403101)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((-0.3062015503875969, -0.3798449612403101), (-0.18749999999999997, 5.551115123125783e-17)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((-0.8, 0.0), (-0.18749999999999997, 5.551115123125783e-17)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((-0.5, -1.0), (0.0, -0.6153846153846154)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((-0.3062015503875969, -0.3798449612403101), (0.0, -0.6153846153846154)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((-0.18749999999999997, 5.551115123125783e-17), (0.0, 0.6)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((-0.18749999999999997, 5.551115123125783e-17), (0.18749999999999997, 0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((0.0, 0.6), (0.18749999999999997, 0.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((0.0, -0.6153846153846154), (0.3062015503875969, -0.37984496124031014)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((0.18749999999999997, 0.0), (0.3062015503875969, -0.37984496124031014)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((0.0, -0.6153846153846154), (0.5, -1.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((0.3062015503875969, -0.37984496124031014), (0.5, -1.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((0.3062015503875969, -0.37984496124031014), (0.8, 0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((0.18749999999999997, 0.0), (0.8, 0.0)), true, true, SegmentAnnotations(false, true)),
                ]
            @test annotated_segments == expected
        end

        @testset "rectangles intersect annotations" begin
            rectangle = [
                SegmentEvent(((0.0, 0.0), (3.0, 3.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((0.0, 0.0), (4.0, -4.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((4.0, -4.0), (7.0, -1.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true, true, SegmentAnnotations(false, true)),
            ]
            rectangle_horiz = [
                SegmentEvent(((-1.0, 0.0), (-1.0, 3.0)), true, false, SegmentAnnotations(false, true)),
                SegmentEvent(((-1.0, 0.0), (12.0, 0.0)), true, false, SegmentAnnotations(true, false)),
                SegmentEvent(((12.0, 0.0), (12.0, 3.0)), true, false, SegmentAnnotations(true, false)),
                SegmentEvent(((-1.0, 3.0), (12.0, 3.0)), true, false, SegmentAnnotations(false, true)),
            ]
            queue = SegmentEvent{Float64}[]
            for ev in vcat(rectangle, rectangle_horiz)
                add_annotated_segment!(queue, ev)
            end
            annotated_segments = event_loop!(queue; self_intersection=false)
            expected = [
                SegmentEvent(((-1.0, 0.0), (-1.0, 3.0)), true, false, SegmentAnnotations(false, true), SegmentAnnotations(false, false)),
                SegmentEvent(((-1.0, 0.0), (0.0, 0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((0.0, 0.0), (3.0, 3.0)), true, true, SegmentAnnotations(false, true), SegmentAnnotations(true, true)),
                SegmentEvent(((-1.0, 3.0), (3.0, 3.0)), true, false, SegmentAnnotations(false, true), SegmentAnnotations(false, false)),
                SegmentEvent(((0.0, 0.0), (4.0, -4.0)), true, true, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((0.0, 0.0), (6.0, 0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(true, true)),
                SegmentEvent(((3.0, 3.0), (6.0, 0.0)), true, true, SegmentAnnotations(false, true), SegmentAnnotations(true, true)),
                SegmentEvent(((4.0, -4.0), (7.0, -1.0)), true, true, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((6.0, 0.0), (7.0, -1.0)), true, true, SegmentAnnotations(false, true), SegmentAnnotations(false, false)),
                SegmentEvent(((6.0, 0.0), (12.0, 0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((12.0, 0.0), (12.0, 3.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((3.0, 3.0), (12.0, 3.0)), true, false, SegmentAnnotations(false, true), SegmentAnnotations(false, false)),
            ]
            @test annotated_segments == expected
        end

        @testset "rectangle self-intersect annotations" begin
            self_intersect = [
                SegmentEvent(((0.0, 0.0), (2.0, 2.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((0.0, 0.0), (4.0, 0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((2.0, 2.0), (4.0, 0.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((4.0, 0.0), (6.0, -2.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((6.0, -2.0), (8.5, -0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((4.0, 0.0), (8.5, -0.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((8.5, -0.0), (11.0, 0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((11.0, 0.0), (11.0, 2.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((8.5, -0.0), (11.0, 2.0)), true, true, SegmentAnnotations(false, true)),
            ]
            rectangle_horiz = [
                SegmentEvent(((-1.0, 0.0), (-1.0, 3.0)), true, false, SegmentAnnotations(false, true)),
                SegmentEvent(((-1.0, 0.0), (12.0, 0.0)), true, false, SegmentAnnotations(true, false)),
                SegmentEvent(((12.0, 0.0), (12.0, 3.0)), true, false, SegmentAnnotations(true, false)),
                SegmentEvent(((-1.0, 3.0), (12.0, 3.0)), true, false, SegmentAnnotations(false, true)),
            ]
            queue = SegmentEvent{Float64}[]
            for ev in vcat(self_intersect, rectangle_horiz)
                add_annotated_segment!(queue, ev)
            end
            annotated_segments = event_loop!(queue; self_intersection=false)
            expected = [
                SegmentEvent(((-1.0, 0.0), (-1.0, 3.0)), true, false, SegmentAnnotations(false, true), SegmentAnnotations(false, false)),
                SegmentEvent(((-1.0, 0.0), (0.0, 0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((0.0, 0.0), (2.0, 2.0)), true, true, SegmentAnnotations(false, true), SegmentAnnotations(true, true)),
                SegmentEvent(((0.0, 0.0), (4.0, 0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(true, false)),
                SegmentEvent(((2.0, 2.0), (4.0, 0.0)), true, true, SegmentAnnotations(false, true), SegmentAnnotations(true, true)),
                SegmentEvent(((4.0, 0.0), (6.0, -2.0)), true, true, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((6.0, -2.0), (8.5, -0.0)), true, true, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((4.0, 0.0), (8.5, -0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(false, true)),
                SegmentEvent(((8.5, -0.0), (11.0, 0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(true, false)),
                SegmentEvent(((11.0, 0.0), (11.0, 2.0)), true, true, SegmentAnnotations(true, false), SegmentAnnotations(true, true)),
                SegmentEvent(((8.5, -0.0), (11.0, 2.0)), true, true, SegmentAnnotations(false, true), SegmentAnnotations(true, true)),
                SegmentEvent(((11.0, 0.0), (12.0, 0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((12.0, 0.0), (12.0, 3.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((-1.0, 3.0), (12.0, 3.0)), true, false, SegmentAnnotations(false, true), SegmentAnnotations(false, false)),
            ]
            @test annotated_segments == expected
        end
    end

    @testset "selection criteria" begin
        function check_selection_criteria(calc_criteria, criteria::Vector)
            for idx in 0:15
                above1 = idx > 7
                below1 = (idx % 8) > 3
                above2 = (idx % 4) > 1
                below2 = (idx % 2) > 0
                expect_filled = calc_criteria(above1, below1, above2, below2)
                #println(idx + 1, " $above1 $below1 $above2 $below2 - ", expect_filled)
                @assert expect_filled ? criteria[idx + 1] != BLANK : criteria[idx + 1] == BLANK
            end
            true
        end

        @testset "intersection" begin
            function is_intersect(above1, below1, above2, below2)
                is_intersect = ((above1 & above2) ⊻ (below1 & below2))
                is_intersect_segments = (above1 & below2) ⊻ (below1 & above2)
                (is_intersect || is_intersect_segments)
            end

            @test check_selection_criteria(
                is_intersect,
                PolygonAlgorithms.INTERSECTION_CRITERIA
            )
        end
        @testset "union" begin
            @test check_selection_criteria(
                (above1, below1, above2, below2) -> (above1 | above2) ⊻ (below1 | below2),
                PolygonAlgorithms.UNION_CRITERIA
            )
        end

        @testset "difference" begin
            @test check_selection_criteria(
                (above1, below1, above2, below2) -> (above1 & !above2) ⊻ (below1 & !below2),
                PolygonAlgorithms.DIFFERENCE_CRITERIA
            )
        end

        @testset "xor" begin
            @test check_selection_criteria(
                (above1, below1, above2, below2) -> (above1 ⊻ above2) ⊻ (below1 ⊻ below2),
                PolygonAlgorithms.XOR_CRITERIA
            )
        end
    end

    @testset "chain segments" begin
        @testset "chain segments - rectangle" begin
            segments = [
                SegmentEvent(((0.0, 0.0), (4.0, -4.0)), true),
                SegmentEvent(((0.0, 0.0), (3.0, 3.0)), true),
                SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true),
                SegmentEvent(((4.0, -4.0), (7.0, -1.0)), true),
            ]
            regions = chain_segments(segments)
            expected = [[
                    SegmentEvent(((3.0, 3.0), (7.0, -1.0)), false),
                    SegmentEvent(((0.0, 0.0), (3.0, 3.0)),  false),
                    SegmentEvent(((0.0, 0.0), (4.0, -4.0)), true),
                    SegmentEvent(((0.0, 0.0), (4.0, -4.0)), false),
            ]]
            @test regions == expected
        end

        @testset "close fuzzy" begin
            segments = [
                SegmentEvent(((0.0, 0.0), (4.0, -4.0)), true),
                SegmentEvent(((0.0, 0.0), (3.0, 3.0)), true),
                SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true),
                SegmentEvent(((3.999, -3.999), (7.0, -1.0)), true),
            ]
            regions = chain_segments(segments)
            expected = [[
                SegmentEvent(((3.999, -3.999), (7.0, -1.0)), true),
                SegmentEvent(((3.0, 3.0), (7.0, -1.0)), false),
                SegmentEvent(((0.0, 0.0), (3.0, 3.0)), false),
                SegmentEvent(((0.0, 0.0), (4.0, -4.0)), true),
                SegmentEvent(((0.0, 0.0), (4.0, -4.0)), false),
            ]]
            @test regions == expected
        end

        @testset "chain segments - improper" begin
            segments = [
                SegmentEvent(((0.0, 0.0), (2.0, 2.0)), true),
                SegmentEvent(((2.0, 2.0), (5.0, 1.0)), true),
                SegmentEvent(((2.0, 2.0), (3.0, 5.0)), true),
                SegmentEvent(((3.0, 5.0), (5.0, 1.0)), true),
            ]
            @test_throws AssertionError chain_segments(segments)
        end

        @testset "chain segments - improper hole" begin
            segments = [
                SegmentEvent(((0.0, 0.0), (0.0, 4.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((2.0, 1.0), (2.0, 2.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((0.0, 4.0), (2.0, 2.0)), true, true, SegmentAnnotations(true, true) ),
                SegmentEvent(((2.0, 1.0), (3.0, 3.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((2.0, 2.0), (3.0, 3.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((0.0, 0.0), (5.0, 1.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((5.0, 1.0), (5.0, 4.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((0.0, 4.0), (5.0, 4.0)), true, true, SegmentAnnotations(false, true)),
            ]
            @test_throws AssertionError chain_segments(segments)
        end
    end

    @testset "holes" begin
        @testset "two squares with holes" begin
            regions = [
                [
                    SegmentEvent(((2.0, 1.0), (2.0, 2.0)), false, true, SegmentAnnotations(false, true)),
                    SegmentEvent(((1.0, 1.0), (2.0, 1.0)), false, true, SegmentAnnotations(false, true)),
                    SegmentEvent(((1.0, 1.0), (1.0, 2.0)), true,  true, SegmentAnnotations(true, false)),
                    SegmentEvent(((1.0, 1.0), (1.0, 2.0)), false, true, SegmentAnnotations(true, false)),
                ],
                [
                    SegmentEvent(((3.0, 0.0), (3.0, 3.0)), false, true, SegmentAnnotations(true, false)),
                    SegmentEvent(((0.0, 0.0), (3.0, 0.0)), false, true, SegmentAnnotations(true, false)),
                    SegmentEvent(((0.0, 0.0), (0.0, 3.0)), true,  true, SegmentAnnotations(false, true)),
                    SegmentEvent(((0.0, 0.0), (0.0, 3.0)), false, true, SegmentAnnotations(false, true)),
                ],
                [
                    SegmentEvent(((6.0, 1.0), (6.0, 2.0)), false, true, SegmentAnnotations(false, true)),
                    SegmentEvent(((5.0, 1.0), (6.0, 1.0)), false, true, SegmentAnnotations(false, true)),
                    SegmentEvent(((5.0, 1.0), (5.0, 2.0)), true,  true, SegmentAnnotations(true, false)),
                    SegmentEvent(((5.0, 1.0), (5.0, 2.0)), false, true, SegmentAnnotations(true, false)),
                ],
                [
                   SegmentEvent(((7.0, 0.0), (7.0, 3.0)), false, true, SegmentAnnotations(true, false))
                    SegmentEvent(((4.0, 0.0), (7.0, 0.0)), false, true, SegmentAnnotations(true, false))
                    SegmentEvent(((4.0, 0.0), (4.0, 3.0)), true,  true, SegmentAnnotations(false, true))
                    SegmentEvent(((4.0, 0.0), (4.0, 3.0)), false, true, SegmentAnnotations(false, true))
                ]
            ]
            classification = map(is_hole, regions)
            expected = [true, false, true, false]
            @test classification == expected
            polygons = [
                Polygon([(3.0, 3.0), (3.0, 0.0), (0.0, 0.0), (0.0, 3.0)]),
                Polygon([(7.0, 3.0), (7.0, 0.0), (4.0, 0.0), (4.0, 3.0)]),
            ]
            holes = [
                [(2.0, 2.0), (2.0, 1.0), (1.0, 1.0), (1.0, 2.0)],
                [(6.0, 2.0), (6.0, 1.0), (5.0, 1.0), (5.0, 2.0)],
            ]
            parents = match_holes_polygons(polygons, holes)
            @test parents == [1, 2]
        end

        @testset "nested squares with holes" begin
            poly1 = Polygon(
                [(0.0, 0.0), (0.0, 7.0), (7.0, 7.0), (7.0, 0.0)]
            )
            poly2 = Polygon(
                [(2.0, 2.0), (2.0, 5.0), (5.0, 5.0), (5.0, 2.0)];
            )
            holes = [
                [(1.0, 1.0), (1.0, 6.0), (6.0, 6.0), (6.0, 1.0)],
                [(3.0, 3.0), (3.0, 4.0), (4.0, 4.0), (4.0, 3.0)],
            ]
            # order does not matter
            parents = match_holes_polygons([poly1, poly2], holes)
            @test parents == [1, 2]
            parents = match_holes_polygons([poly2, poly1], holes)
            @test parents == [2, 1]
        end
    end
end

abstract type ConvexHullAlgorithm end

struct GiftWrappingAlg <: ConvexHullAlgorithm end
struct GrahamScanAlg   <: ConvexHullAlgorithm end

"""
    convex_hull(points, alg=GiftWrappingAlg())

Determine the indices of the convex hull for a set of points.

`alg` can either be `GiftWrappingAlg()` or `GrahamScanAlg()`.

For  `n` input vertices and `h` resultant vertices on the convex hull:
- `GiftWrappingAlg` runs in `O(nh)` time.
- `GrahamScanAlg` runs in `O(n*log(n))` time.
"""
convex_hull(points::Polygon2D; options...) = convex_hull(points, GiftWrappingAlg(); options...)

function convex_hull(points::Polygon2D, ::GiftWrappingAlg; rtol::AbstractFloat=1e-4)
    # https://www.geeksforgeeks.org/convex-hull-using-jarvis-algorithm-or-wrapping/    
    topleft = left_topmost(points)
    hull_idxs = Int[]
    n = length(points)

    p = topleft
    q = 1
    while true
        push!(hull_idxs, p)
        q = (p % n + 1)

        point_p = points[p]
        point_q = points[q]
        # find more counter-clockwise point than q
        for i in eachindex(points)
            point_i = points[i]
            turn = get_orientation(point_p, point_i, point_q; rtol=rtol)
            if turn == COUNTER_CLOCKWISE
                q = i
                point_q = point_i
            elseif turn == COLINEAR
                dq = norm2(point_q, point_p)
                di = norm2(point_i, point_p)
                if di > dq
                    q = i
                    point_q = point_i
                end
            end
        end
        p = q

        if (p == topleft)
            break
        end
    end
    hull_idxs
end

function left_topmost(points::Polygon2D)
    idx = 1
    for i in eachindex(points)
        if points[i][1] < points[idx][1]
            idx = i
        elseif (points[i][1] == points[idx][1]) && (points[i][2] > points[idx][2])
            idx = i
        end
    end
    idx
end

function convex_hull(points::Polygon2D, ::GrahamScanAlg; rtol::AbstractFloat=1e-4)
    # https://www.geeksforgeeks.org/convex-hull-using-graham-scan/
    idx = bottom_leftmost(points)
    p0 = points[idx]
    idxs = sortperm(points, lt=(p, q) -> isless_orientation(p, q, p0))

    hull = idxs[[1, 2, 3]]
    if get_orientation(points[hull[1]], points[hull[2]], points[hull[3]]; rtol=rtol) == COLINEAR
        deleteat!(hull, 2)
    end
    for idx in idxs[4:end]
        while length(hull) > 1 &&
            get_orientation(points[hull[end-1]], points[hull[end]], points[idx]; rtol=rtol) != COUNTER_CLOCKWISE
            pop!(hull)
        end
        push!(hull, idx)
    end
    hull
end

function bottom_leftmost(points::Polygon2D)
    idx = 1
    for i in eachindex(points)
        if points[i][2] < points[idx][2]
            idx = i
        elseif (points[i][2] == points[idx][2]) && (points[i][1] < points[idx][1])
            idx = i
        end
    end
    idx
end

"""
    contains(vertices, point; on_border_is_inside=true; rtol=1e-10)

Runs in `O(n)` time where `n=length(vertices)`.

This algorithm is an an extension of the odd-even ray algorithm.
It is based on "A Simple and Correct Even-Odd Algorithm for the Point-in-Polygon Problem for Complex Polygons" 
by Michael Galetzka and Patrick Glauner (2017). 
It skips vertices that are on the ray. To compensate, the ray is projected backwards (to the left) so that an 
intersection can be found for a skipped vertex if needed.

`rtol` should be small because of the extreme points used in the algorithm.
"""
function contains(vertices::Polygon2D, point::Point2D{T}; on_border_is_inside::Bool=true, rtol::AbstractFloat=1e-10) where T
    n = length(vertices)
    num_intersections = 0

    x = x_coords(vertices)
    extreme_left =  (minimum(x) - T(1e3), point[2])
    extreme_right = (maximum(x) + T(1e3), point[2])

    # step 1: point intersects a vertex or edge
    for i in 1:n
        next_i = (i % n) + 1
        segment = (vertices[i], vertices[next_i])
        if (point == segment[1]) || on_segment(point, segment)
            return on_border_is_inside
        end
    end

    # step 3: check intersections with vertices
    s = 1
    while s <= n
        # step 2: find a vertex not on the same horizontal ray as the point
        while (s <= n) && (vertices[s][2] == point[2])
            s += 1
        end
        if s > n
            break
        end
        # step 3a: find the next vertex not on the horizontal ray
        next_s = s
        skipped_right = false
        for i in 0:n
            next_s = (next_s) % n + 1
            if (vertices[next_s][2] != point[2]) && 
                (vertices[s] != vertices[next_s]) # TODO tolerance
                break
            end
            skipped_right = skipped_right || (vertices[next_s][1] > point[1])
        end
        # step 3b: edge intersect with the ray
        edge = (vertices[s], vertices[next_s])
        intersect = false
        if (next_s - s) == 1 || (s == n && next_s ==1) # 3b.i
            intersect = do_intersect(edge, (point, extreme_right); rtol=rtol)
        elseif skipped_right # 3b.ii
            intersect = do_intersect(edge, (extreme_left, extreme_right); rtol=rtol)
        end
        num_intersections += intersect
        if next_s <= s  # gone in a full loop
            break
        end
        s = next_s
    end
    return (num_intersections % 2) == 1
end

@enum AnnotationFill BLANK=0 ABOVE=1 BELOW=2 EMPTY=3

"""
    martinez_rueda_algorithm(
    selection_criteria, subject, others...
    ; atol=default_atol, rtol=default_rtol, fuzzy_rtol=1.0
    )

The Martínez-Rueda-Feito polygon clipping algorithm.
Returns regions and edges of intersection.
It runs in `O((n+m+k)log(n+m))` time where `n` and `m` are the number of vertices of `polygon1` 
and `polygon2` respectively and `k` is the total number of intersections between all segments.
Use `intersect_convex` for convex polygons for an `O(n+m)` algorithm.

The input polygons can be:
- A list of points: `Vector{Tuple{Float64, Float64}}`.
- Polygons: `Vector{Polygon{T}}`.
- A Segment event queue: `Vector{<:SegmentEvent{Float64}}`. The core algorithm uses this representation.
- The `subject` can also be a list of polygons. This enables the output to be an input. 
    Note that in this case the `subject` list is treated as a single polygon.
    If any of the polygons overlap, this is equivalent to passing a self-intersecting polygon and
    some areas might be classified as holes according to the even-odd rule

Description:
- Operates at a segment level and is an extension of the Bentley-Ottman line intersection algorithm.
    Segments are scanned from left to right, bottom to top. 
- The key assumption is that only the segments immediately above and below the current segment need to be inspected for intersections.
    This makes the algorithm fast but also sensitive to determining these segments correctly.
- The segment that is immediately below (or empty space) is used to determine the fill annotations for the current segment.
- Once all annotations are done, the desired segments can be selected that match a given criteria.
- These segments are then chained together to form the polygons.

Limitations
1. It can fail for improper polygons: polygons with lines sticking out.
2. It is sensitive to numeric inaccuracies e.g. a line that is almost vertical or tiny regions 
    of intersection.
3. Sometimes the segment chaining can fail. This might happen if the polygons are improper.
    For some cases when the segment chaining fails it is possible to "fuzzy" close them.
    The criteria is that the ratio of the remaining gap to the mean segment length is less than `fuzzy_rtol`.

References 
- paper: https://www.researchgate.net/publication/220163820_A_new_algorithm_for_computing_Boolean_operations_on_polygons
- article: https://sean.fun/a/polygon-clipping-pt2/
- article source code: https://github.com/velipso/polybooljs
"""
function martinez_rueda_algorithm(
    selection_criteria::Vector{AnnotationFill},
    subject::Path2D{T},
    others::Vararg{Path2D{T}},
    ; atol::AbstractFloat=default_atol, options...
    ) where T
    event_queue_base = convert_to_event_queue(subject; primary=true, atol=atol)
    event_queue_others = map(p -> convert_to_event_queue(p; primary=false, atol=atol), others)
    region_segments = martinez_rueda_algorithm(
        selection_criteria, event_queue_base, event_queue_others...; atol=atol, options...
    )
    map(segments -> map(event -> event.point, segments), region_segments)
end

function martinez_rueda_algorithm(
    selection_criteria::Vector{AnnotationFill},
    subjects::AbstractVector{<:Path2D{T}},
    others::Vararg{Path2D{T}},
    ; atol::AbstractFloat=default_atol, options...
    ) where T
    subject_queue = SegmentEvent{T}[]
    map(p -> convert_to_event_queue!(subject_queue, p; primary=true, atol=atol), subjects)
    event_queue_others = map(p -> convert_to_event_queue(p; primary=false, atol=atol), others)
    region_segments = martinez_rueda_algorithm(
        selection_criteria, subject_queue, event_queue_others...; atol=atol, options...
    )
    map(segments -> map(event -> event.point, segments), region_segments)
end

# Polygon with hole input

function martinez_rueda_algorithm(
    selection_criteria::Vector{AnnotationFill},
    subject::Polygon{T},
    others::Vararg{Polygon{T}},
    ; atol::AbstractFloat=default_atol, options...
    ) where T
    event_queue_base = convert_to_event_queue(subject.exterior; primary=true, atol=atol)
    for hole in subject.holes
        convert_to_event_queue!(event_queue_base, hole; primary=true, atol=atol)
    end
    event_queue_others = map(p -> convert_to_event_queue(p.exterior; primary=false, atol=atol), others)
    for (queue, other) in zip(event_queue_others, others)
        for hole in other.holes
            convert_to_event_queue!(queue, hole; primary=false, atol=atol)
        end
    end
    region_segments = martinez_rueda_algorithm(
        selection_criteria, event_queue_base, event_queue_others...; atol=atol, options...
    )
    convert_segments_to_polygons(region_segments; atol=atol)
end

function martinez_rueda_algorithm(
    selection_criteria::Vector{AnnotationFill},
    subjects::AbstractVector{<:Polygon{T}},
    clips::Vararg{Polygon{T}},
    ; atol::AbstractFloat=default_atol, options...
    ) where T
    subject_queue = SegmentEvent{T}[]
    map(p -> convert_to_event_queue!(subject_queue, p.exterior; primary=true, atol=atol), subjects)
    for subject in subjects
        for hole in subject.holes
            convert_to_event_queue!(subject_queue, hole; primary=true, atol=atol)
        end
    end
    event_queue_clips = map(p -> convert_to_event_queue(p.exterior; primary=false, atol=atol), clips)
    for (queue, other) in zip(event_queue_clips, clips)
        for hole in other.holes
            convert_to_event_queue!(queue, hole; primary=false, atol=atol)
        end
    end
    region_segments = martinez_rueda_algorithm(
        selection_criteria, subject_queue, event_queue_clips...; atol=atol, options...
    )
    convert_segments_to_polygons(region_segments; atol=atol)
end

# Core algorithm: SegmentEvent input

function martinez_rueda_algorithm(
    selection_criteria::Vector{AnnotationFill},
    subject::Vector{<:SegmentEvent{T}},
    polygons::Vararg{Vector{<:SegmentEvent{T}}},
    ; atol::AbstractFloat=default_atol, rtol::AbstractFloat=default_rtol, fuzzy_rtol::AbstractFloat=1.0
    ) where T
    base_annotated_segments = event_loop!(subject; self_intersection=true, atol=atol, rtol=rtol)
    for polygon in polygons
        annotated_segments = event_loop!(polygon; self_intersection=true, atol=atol, rtol=rtol)
        queue = SegmentEvent{T}[]
        for ev in vcat(base_annotated_segments, annotated_segments)
            add_annotated_segment!(queue, ev)
        end
        combined_annotated_segments = event_loop!(queue; self_intersection=false, atol=atol, rtol=rtol)
        # for consistent reporting, swap annotations so that self annotations are always the primary
        for ev in combined_annotated_segments
            if !ev.primary
                temp = ev.self_annotations
                ev.self_annotations = ev.other_annotations
                ev.other_annotations = temp
            end
        end
        base_annotated_segments = apply_selection_criteria(combined_annotated_segments, selection_criteria)
    end
    empty_segments, region_segments = separate(is_empty_segment, base_annotated_segments)
    regions = chain_segments(region_segments; atol=atol, check_closes=true, fuzzy_rtol=fuzzy_rtol)
    segment_chains = chain_segments(empty_segments; atol=atol, check_closes=false)
    # It is also possible to attach some segment_chains to regions.
    # This will give consistent results with the Weiler-Atherton implementation.
    # For now, skipping this step.
    vcat(regions, segment_chains)
end

function add_annotated_segment!(queue::Vector{<:SegmentEvent}, ev::SegmentEvent)
    pt1 = ev.segment[1]
    pt2 = ev.segment[2]
    forward = _compare_points(pt1, pt2)
    if forward == 0
        return queue # zero length segment
    end
    start = forward < 0 ? pt1 : pt2
    end_ = forward < 0 ? pt2 : pt1
    segment = (start, end_)
    add_segment_event!(queue, segment, ev.primary, ev.self_annotations, ev.other_annotations)
end

#############################################################
##                    Event Loop                           ##
#############################################################

function event_loop!(
    queue::Vector{SegmentEvent{T}}
    ; self_intersection::Bool, atol::AbstractFloat=default_atol, rtol::AbstractFloat=default_atol
    ) where T # eventLoop
    annotated_segments = SegmentEvent{T}[]
    sweep_status = SegmentEvent{T}[] # current events in a vertical line, top to bottom.
    while !(isempty(queue))
        head = queue[1]
        queue_length = length(queue)
        status_length = length(sweep_status)
        @debug("[event_loop!] ($(queue_length), $(status_length)): $(head)")
        if head.is_start # then check for intersections and add to sweep status
            idx = find_transition(sweep_status, head; atol=atol)
            above = idx == 1 ? nothing : sweep_status[idx - 1]
            below = (idx > length(sweep_status)) ? nothing : sweep_status[idx]
            @debug("[event_loop!] transition idx=$idx")
            @debug("[event_loop!] above=$above")
            @debug("[event_loop!] below=$below")
            check_and_divide_intersection!(queue, head, above, self_intersection; atol=atol, rtol=rtol)
            if queue[1] != head
                continue # either head was removed or something was inserted ahead of it
            end
            check_and_divide_intersection!(queue, head, below, self_intersection; atol=atol, rtol=rtol)
            if queue[1] != head
                continue # either head was removed or something was inserted ahead of it
            end
            if self_intersection
                calculate_self_annotations!(head, below)
            else
                calculate_other_annotations!(head, below)
            end
            insert!(sweep_status, idx, head)
        else # event is ending, so remove it from the status
            idx = find_transition(sweep_status, head.other; atol=atol)
            if !(0 < idx <= length(sweep_status) && sweep_status[idx] === head.other)
                @warn "$(head.other) was not in the expected location in the sweep status. " * 
                    "Falling back to linear search. This might result in incorrect annotations and hence open chains."
                idx = findfirst(x -> x === head.other, sweep_status)
                @assert(
                    !isnothing(idx),
                    "$(head.other) is missing from the sweep_status. The start event should always be processed before the end event."
                )
            end
            if (idx != 1) && (idx != length(sweep_status))
                # there will be 2 new adjacent edges, so check the intersection between them
                check_and_divide_intersection!(
                    queue, sweep_status[idx - 1], sweep_status[idx + 1], self_intersection
                    ; atol=atol, rtol=rtol)
            end
            push!(annotated_segments, copy_segment(head.other, head.other.primary))
            popat!(sweep_status, idx)
        end
        popfirst!(queue)
    end
    annotated_segments
end

function check_and_divide_intersection!(
    queue::Vector{<:SegmentEvent}, ev1::SegmentEvent, ev2::Nothing, self_intersection::Bool
    ; atol::AbstractFloat=default_atol, rtol::AbstractFloat=default_rtol
    )
    queue
end

function check_and_divide_intersection!(
    queue::Vector{<:SegmentEvent},
    ev1::SegmentEvent,
    ev2::SegmentEvent,
    self_intersection::Bool
    ; atol::AbstractFloat=default_atol, rtol::AbstractFloat=default_rtol
    )
    pt = intersect_geometry(ev1.segment, ev2.segment; atol=atol, rtol=rtol)
    if isnothing(pt)
        @debug("no intersection or parallel lines at $ev1 -- $ev2")
        # Lines might be on top of each other 
        ori2_start = get_orientation(ev1.segment[1], ev1.segment[2], ev2.segment[1]; atol=atol)
        ori2_end = get_orientation(ev1.segment[1], ev1.segment[2], ev2.segment[2]; atol=atol)
        if (ori2_start == COLINEAR) && (ori2_end == COLINEAR)
            divide_coincident_intersection!(queue, ev1, ev2, self_intersection; atol=atol)
        end
        return queue
    else
        divide_intersection!(queue, ev1, ev2, pt; atol=atol)
    end
end

function divide_intersection!(queue::Vector{<:SegmentEvent}, ev1::SegmentEvent, ev2::SegmentEvent, pt::Nothing; atol=1e-6)
    queue
end

function divide_intersection!(
    queue::Vector{<:SegmentEvent},
    ev1::SegmentEvent,
    ev2::SegmentEvent,
    pt::Point2D
    ; atol::AbstractFloat=default_atol
    ) # checkIntersection
    @debug("[divide_intersection!] $(ev1.segment) -- $(ev2.segment) at $(pt)")
    at_start1, at_end1, along1 = classify_intersection(ev1.segment, pt; atol=atol)
    at_start2, at_end2, along2 = classify_intersection(ev2.segment, pt; atol=atol)
    @debug("[divide_intersection!] $at_start1 $at_end1 $along1")
    @debug("[divide_intersection!] $at_start2 $at_end2 $along2")
    if along1 && along2
        divide_event!(queue, ev1, pt; atol=atol)
        divide_event!(queue, ev2, pt; atol=atol)
    elseif along1
        if at_start2
            divide_event!(queue, ev1, ev2.segment[1]; atol=atol)
        elseif at_end2
            divide_event!(queue, ev1, ev2.segment[2]; atol=atol)
        end
    elseif along2
        if at_start1
            divide_event!(queue, ev2, ev1.segment[1]; atol=atol)
        elseif at_end1
            divide_event!(queue, ev2, ev1.segment[2]; atol=atol)
        end
    end
    queue
end

function divide_coincident_intersection!(
    queue::Vector{<:SegmentEvent}, ev1::SegmentEvent, ev2::SegmentEvent, self_intersection::Bool
    ; atol::AbstractFloat=default_atol
    )
    # This assumes:
    # - ev1 is on top of or to the right of ev2, because events are processed left to right.
    # - both points of ev2 are colinear with ev1 .
    @debug("[divide_coincident_intersection!] $(ev1) -- $ev2")
    start1_on_end2 = is_same_point(ev1.segment[1], ev2.segment[2]; atol=atol)
    end1_on_start2 = is_same_point(ev1.segment[2], ev2.segment[1]; atol=atol)
    if start1_on_end2 || end1_on_start2
        return queue # segments touch at endpoints, so no further divisions
    end
    starts_equal = is_same_point(ev1.segment[1], ev2.segment[1]; atol=atol)
    ends_equal = is_same_point(ev1.segment[2], ev2.segment[2]; atol=atol)
    @debug("[divide_coincident_intersection!] starts_equal=$starts_equal")
    @debug("[divide_coincident_intersection!] ends_equal=$ends_equal")
    if starts_equal && ends_equal
        # segments are equal. Keep the second one
        return merge_same_segments!(queue, ev1, ev2, self_intersection)
    end
    start1_between = !starts_equal && on_segment(ev1.segment[1], ev2.segment; atol=atol)
    end1_between = !ends_equal && on_segment(ev1.segment[2], ev2.segment; atol=atol)
    end2_between = !ends_equal && on_segment(ev2.segment[2], ev1.segment; atol=atol)
    if starts_equal
        if end1_between
            # (a1)---(a2)
            # (b1)----x------(b2)
            divide_event!(queue, ev2, ev1.segment[2]; atol=atol)
        elseif end2_between
            # (a1)----x-----(a2)
            # (b1)---(b2)
            divide_event!(queue, ev1, ev2.segment[2]; atol=atol)
        else # are these segment colinear?
            return queue
        end
        # duplicate a1->x, so remove ev1
        return merge_same_segments!(queue, ev1, ev2, self_intersection)
    elseif start1_between
        if !ends_equal # then make a2 equal to b2
            if end1_between
                #         (a1)---(a2)
                #  (b1)-----------x-----(b2)
                divide_event!(queue, ev2, ev1.segment[2]; atol=atol)
            elseif end2_between
                #         (a1)----x-----(a2)
                #  (b1)----------(b2)
                divide_event!(queue, ev1, ev2.segment[2]; atol=atol);
            else # are these segments colinear?
                return queue
            end
        end
        #         (a1)---(a2)
        #  (b1)----x-----(b2)
        # equal segment a1-b2 isn't in the status stack yet, so don't return it
        divide_event!(queue, ev2, ev1.segment[1]; atol=atol);
    end
    queue
end

"""
    divide_event!(queue, ev, pt; atol=1e-6)

Divide an event `ev` and `ev.other` in `queue` into 4:
```
--x-->  to  --> x-->
```
"""
function divide_event!(queue::Vector{<:SegmentEvent}, ev::SegmentEvent, pt::Point2D; atol::AbstractFloat=default_atol) # eventDivide
    # assumes pt lies on ev.segment
    new_segment = (pt, ev.segment[2])
    @debug("[divide_event!] new_segment=$(new_segment)")
    e1, e2 = update_end!(ev, pt; atol=atol)
    # fix position of end in queue
    pop_key!(queue, e2)
    insert_in_order!(queue, e2; lt=compare_events)
    # add new segment at the end. Reset other_annotations
    add_segment_event!(queue, new_segment, ev.primary, ev.self_annotations, SegmentAnnotations())
end

"""
    update_end!(queue, ev, pt; atol=1e-6)

Slides an end backwards.
```
    (start)------------(end)    to:
    (start)---(end)
```
"""
function update_end!(ev::SegmentEvent, end_point::Point2D; atol::AbstractFloat=default_atol)
    # Assumes ev is a start event.        
    @assert ev.is_start
    ev.segment = (ev.segment[1], end_point)
    ev.other_point = end_point
    other = ev.other
    other.segment = (ev.segment[1], end_point)
    other.point = end_point
    if abs(ev.segment[1][1] - end_point[1]) <= atol &&
        (ev.segment[1][2] > end_point[2]) && ev.is_start
        @warn "Reversing direction for new vertical segment: $(ev.segment)."
        ev.is_start = false
        other.is_start = true
    end
    ev, other
end

function merge_same_segments!(queue::Vector{<:SegmentEvent}, discard::SegmentEvent, survive::SegmentEvent, self_intersection::Bool)
    @debug("[merge_same_segments!] discard=$discard")
    @debug("[merge_same_segments!] survive=$survive")
    pop_key!(queue, discard)
    pop_key!(queue, discard.other)
    if self_intersection
        # fill status is calculated bottom to top, so surviving's fill_below cannot change
        # however, surviving fill_above will be whatever the discarded's one would have been
        toggle = isnothing(discard.self_annotations.fill_below) ? true : discard.self_annotations.fill_above != discard.self_annotations.fill_below
        if toggle
            @assert !isnothing(survive.self_annotations.fill_above) "missing self_annotations in surviving segment: $(survive)" # preempt !nothing error
            survive.self_annotations.fill_above = !survive.self_annotations.fill_above
        end
    elseif discard.primary != survive.primary # merge two segments that belong to different polygons
        # each segment has distinct knowledge, so no special logic is needed
        # note that this can only happen once per segment in this phase, because we are guaranteed that all self-intersections are gone
        survive.other_annotations = discard.self_annotations
    else # merge two segments that belong to the same polygon
        if isnothing(survive.other_annotations.fill_above)
            @assert !isnothing(dicard.self_annotations.fill_above) "missing self_annotations in discarded segment: $(dicard)"
            survive.other_annotations = discard.other_annotations
        end
    end
    @debug("[merge_same_segments!] survive=$survive")
    queue
end

function calculate_self_annotations!(ev::SegmentEvent, below::Union{Nothing, SegmentEvent})
    # if a new segment, than toggle, else use existing knowledge
    @debug("[calculate_self_annotations!] event: $(ev)")
    @debug("[calculate_self_annotations!] below: $(below)")
    toggle = isnothing(ev.self_annotations.fill_below) ? true : ev.self_annotations.fill_above != ev.self_annotations.fill_below
    if isnothing(below)
        ev.self_annotations.fill_below = false
    else
        @assert !isnothing(below.self_annotations.fill_above) "missing annotations below: $(below)" # preempt !nothing error
        ev.self_annotations.fill_below = below.self_annotations.fill_above # below should already be filled
    end
    if toggle
        ev.self_annotations.fill_above = !ev.self_annotations.fill_below
    else
        ev.self_annotations.fill_above = ev.self_annotations.fill_below
    end
    @debug("[calculate_self_annotations!] self_annotations: $(ev.self_annotations)")
    ev.self_annotations
end

function calculate_other_annotations!(ev::SegmentEvent, below::Nothing)
    @debug("[calculate_other_annotations!] ev=$ev")
    @debug("[calculate_other_annotations!] below=$below")
    if isnothing(ev.other_annotations.fill_above)
        # if nothing is below the event, it cannot be in the other polygon
        inside = false
        ev.other_annotations.fill_above = inside
        ev.other_annotations.fill_below = inside
    end
    @debug("[calculate_other_annotations!] ev.other_annotations=$(ev.other_annotations)")
    ev.other_annotations
end
    
function calculate_other_annotations!(ev::SegmentEvent, below::SegmentEvent)
    @debug("[calculate_other_annotations!] ev=$ev")
    @debug("[calculate_other_annotations!] below=$below")
    if isnothing(ev.other_annotations.fill_above)
        # something is below ev, so copy the below segment's other polygon's above
        inside = (ev.primary == below.primary) ? 
            below.other_annotations.fill_above : below.self_annotations.fill_above
        ev.other_annotations.fill_above = inside
        ev.other_annotations.fill_below = inside
    end
    @debug("[calculate_other_annotations!] ev.other_annotations=$(ev.other_annotations)")
    ev.other_annotations
end

#############################################################
##                 Segment Selection                       ##
#############################################################

#=
Table
    Above1  Below1 Above2 Below2
01. No      No     No     No
02. No      No     No     Yes
03. No      No     Yes    No
04. No      No     Yes    Yes
05. No      Yes    No     No
06. No      Yes    No     Yes
07. No      Yes    Yes    No
08. No      Yes    Yes    Yes
09. Yes     No     No     No
10. Yes     No     No     Yes
11. Yes     No     Yes    No
12. Yes     No     Yes    Yes
13. Yes     Yes    No     No
14. Yes     Yes    No     Yes
15. Yes     Yes    Yes    No
16. Yes     Yes    Yes    Yes
=#

# For the 16 rows, indicate if (1) in the output shape (non-blank) and (2) which side is filled in that output shape

INTERSECTION_CRITERIA = [
    BLANK, BLANK, BLANK, BLANK,
    BLANK, BELOW, EMPTY, BELOW,
    BLANK, EMPTY, ABOVE, ABOVE,
    BLANK, BELOW, ABOVE, BLANK,
] # both below, both above, but not all 4

INTERSECTION_SEGMENT_CRITERIA = [
    BLANK, BLANK, BLANK, BLANK,
    BLANK, BLANK, EMPTY, BLANK,
    BLANK, EMPTY, BLANK, BLANK,
    BLANK, BLANK, BLANK, BLANK,
] # above and below different segments

UNION_CRITERIA = [
    BLANK, BELOW, ABOVE, BLANK,
    BELOW, BELOW, BLANK, BLANK,
    ABOVE, BLANK, ABOVE, BLANK,
    BLANK, BLANK, BLANK, BLANK,
] # filled only above/only below. (above1 | above2) ⊻ (below1 | below2)

DIFFERENCE_CRITERIA = [
    BLANK, BLANK, BLANK, BLANK,
    BELOW, BLANK, BELOW, BLANK,
    ABOVE, ABOVE, BLANK, BLANK,
    BLANK, ABOVE, BELOW, BLANK,
] # primary - secondary. (above1 && !above2) ⊻  (below1 && !below2)

XOR_CRITERIA = [
    BLANK, BELOW, ABOVE, BLANK,
    BELOW, BLANK, BLANK, ABOVE,
    ABOVE, BLANK, BLANK, BELOW,
    BLANK, ABOVE, BELOW, BLANK,
] # (above1 ⊻ above2) ⊻ (below1 ⊻ below2)

function apply_selection_criteria(annotated_segments::Vector{<:SegmentEvent{T}}, criteria::Vector{AnnotationFill}) where T
    result = SegmentEvent{T}[]
    for ev in annotated_segments
        index = (ev.self_annotations.fill_above ? 9 : 1) +
                (ev.self_annotations.fill_below ? 4 : 0) + 
                (ev.other_annotations.fill_above ? 2 : 0) + 
                (ev.other_annotations.fill_below ? 1 : 0)
        if criteria[index] != BLANK
            new_segment = copy_segment(ev, true)
            new_segment.self_annotations.fill_above = criteria[index] == ABOVE
            new_segment.self_annotations.fill_below = criteria[index] == BELOW
            new_segment.other_annotations.fill_above = nothing
            new_segment.other_annotations.fill_below = nothing
            push!(result, new_segment)
        end
    end
    result
end

#############################################################
##                 Segment Chaining                        ##
#############################################################

is_empty_segment(ev::SegmentEvent) = (ev.self_annotations.fill_above == false) && (ev.self_annotations.fill_below == false)
struct SegmentChainCandidate{T}
    chain_idx::Int
    match_chain_start::Bool
    segment_event::SegmentEvent{T}
end

function chain_segments(
    segments::AbstractVector{SegmentEvent{T}}
    ; atol::AbstractFloat=default_atol, check_closes::Bool=true, fuzzy_rtol::AbstractFloat=1.0
    ) where T
    # Note: if any of the regions intersect at a vertex, than this is not guaranteed to give consistent results
    # They might be joined into one region or presented as separate regions.
    # This algorithm can fail if the polygon is improper (it has lines jutting out)
    chains = Vector{SegmentEvent{T}}[]
    regions = Vector{SegmentEvent{T}}[]
    processed = Set{Segment2D{T}}()
    for event in segments
        if event.segment in processed
            continue
        end
        push!(processed, event.segment)
        candidates = SegmentChainCandidate{T}[]
        @debug("[chain_segment]: event=$event")
        @debug("[chain_segment]: candidates=$candidates")
        for (chain_idx, chain) in enumerate(chains)
            insert_matching_candidate!(candidates, chain, chain_idx, event; atol=atol)
        end
        if length(candidates) == 0 # start a new open chain
            chain = [
                SegmentEvent(event.segment, true, true, deepcopy(event.self_annotations)),
                SegmentEvent(event.segment, false, true, deepcopy(event.self_annotations))
            ]
            @debug("[chain_segment]: new chain")
            push!(chains, chain)
        elseif length(candidates) == 1 # check if it closes else append to chain
            candidate = candidates[1]
            chain = chains[candidate.chain_idx]
            if check_closes && closes_chain(chain, candidate; atol=atol)
                popat!(chains, candidate.chain_idx)
                push!(regions, chain)
                @debug("[chain_segment]: closed chain")
            else
                append_candidate!(chain, candidate)
                @debug("[chain_segment]: appended chain")
            end
        elseif length(candidates) == 2 # join two chains together
            cand1 = candidates[1]
            cand2 = candidates[2]
            chain1 = chains[cand1.chain_idx]
            chain2 = chains[cand2.chain_idx]
            append_candidate!(chain1, cand1)
            new_chain = join_chains!(chain1, chain2, cand1.match_chain_start, cand2.match_chain_start)
            chains[cand1.chain_idx] = new_chain
            @debug("[chain_segment]: combined chains")
            deleteat!(chains, cand2.chain_idx)
        else # confused
            throw("Matched segment $(candidate.segment) to more than 2 chains.")
        end
    end
    # TODO: it might be possible to close some open chains
    # - it is improper: the beginning and end is a segment(s) jutting out, so it can be closed with a segment in processing
    if check_closes
        if !isempty(chains)
            fuzzy_close!(chains, regions; atol=atol, rtol=fuzzy_rtol)
        end
        @assert isempty(chains) "There are still open chains at the end of processing all segments."
        return regions
    else
        return chains
    end
end

function insert_matching_candidate!(
    candidates::Vector{<:SegmentChainCandidate},
    chain::Vector{<:SegmentEvent},
    chain_idx::Int,
    event::SegmentEvent
    ; atol::AbstractFloat=default_atol
    )
    segment = event.segment
    is_match = false
    if is_same_point(chain[1].point, segment[1]; atol=atol)
        is_match = true
        match_chain_start = true
        match_idx = 1
    elseif is_same_point(chain[1].point, segment[2]; atol=atol)
        is_match = true
        match_chain_start = true
        match_idx = 2
    elseif is_same_point(chain[end].point, segment[1]; atol=atol)
        is_match = true
        match_chain_start = false
        match_idx = 1
    elseif is_same_point(chain[end].point, segment[2]; atol=atol)
        is_match = true
        match_chain_start = false
        match_idx = 2
    end
    if is_match
        is_start = match_idx == 1
        candidate = SegmentChainCandidate(
            chain_idx,
            match_chain_start,
            # add segment for the other point
            SegmentEvent(segment, !is_start, true, deepcopy(event.self_annotations))
        )
        push!(candidates, candidate)
    end
end

function append_candidate!(
    chain::Vector{<:SegmentEvent},
    candidate::SegmentChainCandidate
    ; atol::AbstractFloat=default_atol
    )
    if candidate.match_chain_start
        if length(chain) > 1 && 
            get_orientation(
                candidate.segment_event.point,
                chain[1].point,
                chain[2].point
                ; atol=atol
            ) == COLINEAR
            popfirst!(chain)
        end
        insert!(chain, 1, candidate.segment_event)
    else
        if length(chain) > 1 && 
            get_orientation(
                chain[end-1].point,
                chain[end].point,
                candidate.segment_event.point
                ; atol=atol
            ) == COLINEAR
            pop!(chain)
        end
        push!(chain, candidate.segment_event)
    end
end

function closes_chain(chain::Vector{<:SegmentEvent}, candidate::SegmentChainCandidate; atol::AbstractFloat=default_atol)
    candidate_point = candidate.segment_event.point
    if candidate.match_chain_start
        return is_same_point(chain[end].point, candidate_point; atol=atol)
    else
        return is_same_point(chain[1].point, candidate_point; atol=atol)
    end
end

function fuzzy_close!(
    chains::Vector{<:Vector{<:SegmentEvent}},
    regions::Vector{<:Vector{<:SegmentEvent}}
    ; atol::AbstractFloat, rtol::AbstractFloat=1.0
    )
    for idx in reverse(eachindex(chains))
        if is_fuzzy_closed(chains[idx], length(regions) + 1; atol=atol, rtol=rtol)
            push!(regions, popat!(chains, idx))
        end
    end
    regions
end

function is_fuzzy_closed(chain::Vector{<:SegmentEvent}, idx::Int; atol::AbstractFloat, rtol::AbstractFloat=1.0)
    if is_same_point(chain[1].point, chain[end].point; atol=atol)
        return true
    end
    gap = norm(chain[1].point, chain[end].point)
    path = map(event -> event.point, chain)
    gaps = norm.(path[1:(end-1)], path[2:end])
    mean_gap = sum(gaps) / length(gaps)
    if gap / mean_gap <= rtol
        @warn("Region $idx was not closed, but it has a relatively small gap and will be considered closed.
        |gap| / |mean_segment| = $gap / $mean_gap < $rtol.")
        return true
    end
    false
end

function join_chains!(chain1::Vector{<:SegmentEvent}, chain2::Vector{<:SegmentEvent}, match_chain1_start, match_chain2_start)
    # Note: with clever use of reverse! can change this to always modify chain1 in place for the same output
    if match_chain1_start && match_chain2_start
        # <--- --->
        return push!(reverse!(chain2), chain1...)
    elseif match_chain1_start && !match_chain2_start
        # <--- <----
        return push!(chain2, chain1...)
    elseif !match_chain1_start && match_chain2_start
        # ---> --->
        return push!(chain1, chain2...) 
    else # !match_chain1_start && !match_chain2_start
        # ----> <-----
        return push!(chain1, reverse!(chain2)...) 
    end
end

#############################################################
##                  Polygons and Holes                     ##
#############################################################

function convert_segments_to_polygons(
    regions::Vector{<:Vector{<:SegmentEvent}}
    ; atol::AbstractFloat=default_rtol
    )
    candidates, exteriors  = separate(p -> is_hole(p; atol=atol), regions)
    polygons = map(segments -> Polygon(map(event -> event.point, segments)), exteriors)
    holes = map(segments -> map(event -> event.point, segments), candidates)
    parents = match_holes_polygons(polygons, holes; atol=atol)
    for (idx, hole) in zip(parents, holes)
        if idx == 0
            compact_vec = "[$(hole[1])...$(hole[end])]"
            @debug "Hole $(compact_vec) has no parent. Casting to Polygon."
            push!(polygons, Polygon(hole))
        else
            push!(polygons[idx].holes, hole)
        end
    end
    polygons
end

"""
    is_hole(polygon::Vector{<:SegmentEvent}; atol=default_atol)

A necessary and sufficient condition for a polygon to be classified as a hole is that
at its lowest point it must be filled below and not above.

The `self_annotations` must therefore not be `nothing`.

Note: if the direction of the polygon was known (clockwise/counter-clockwise) then any point could be used.
"""
function is_hole(polygon::Vector{<:SegmentEvent}; atol::AbstractFloat=default_atol)
    # instead of sorting the whole vector, get the lowest segments first
    y = minimum(event -> event.point[2], polygon)
    lowest_segments = filter(event -> event.point[2] == y || event.other_point[2] == y, polygon)
    # sort and check annotations
    sort!(lowest_segments, lt=(x, y) -> is_above(x, y; atol=atol))
    annotations = lowest_segments[end].self_annotations
    annotations.fill_below && !annotations.fill_above
end

"""
    match_holes_polygons(polygons::Vector{<:Polygon}, holes::Vector{<:Tuple})

An algorithm for matching holes to polygons.
Returns the index of each parent for each hole.

For every hole, match to a polygon that contains the hole.
If there are multiple polygons possible, the polygon with the least area is chosen.
If no polygons are found, return the hole as a `Polygon`.

In the best case there is one polygon or one hole. Then this runs in `O(1)` time.
In the worst case, none of the holes match to a polygon.
Then this runs in `O(phn)` time where `p` is the number polygons,
`h` is the number of holes and `n` is the average number of vertices defining each polygon.
"""
function match_holes_polygons(
    polygons::Vector{<:Polygon},
    holes::Vector{<:Path2D}
    ; atol::AbstractFloat=default_atol
    )
    if length(polygons) == 1
        return fill(1, length(holes))
    elseif isempty(holes)
        return Int[]
    end
    areas = map(area_polygon, polygons)
    # sort by ascending areas. Therefore smallest parent is matched first.
    # Trade off is the hole may be tried in many smaller polygons first.
    idxs = sortperm(areas)
    parents = zeros(Int, length(holes))
    for (idx_h, candidate) in enumerate(holes)
        found = false
        for (idx_p, parent) in zip(idxs, polygons[idxs])
            # Assume that no segments intersect after the Martínez-Rueda algorithm.
            # Then only need to check a point not on the exterior.
            j = 1
            while (j < length(candidate)) && on_border(parent.exterior, candidate[j])
                j += 1
            end
            found = contains(parent.exterior, candidate[j]; atol=atol, on_border_is_inside=false)
            if found
                parents[idx_h] = idx_p
                break
            end
        end
    end
    parents
end

function chasing_edges_algorithm(
    polygon1::Polygon2D{T}, polygon2::Polygon2D{T}
    ; atol::AbstractFloat=1e-6
    ) where T
    n = length(polygon1)
    m = length(polygon2)
    points = Point2D{T}[]
    if is_clockwise(polygon1)
        polygon1 = reverse(polygon1)
    end
    if is_clockwise(polygon2)
        polygon2 = reverse(polygon2)
    end
    poly1_in_2 = false
    poly2_in_1 = false
    i = 1
    j = 1
    for k in 1:(2 * (m + n))
        i_prev = i == 1 ? n : i - 1
        j_prev = j == 1 ? m : j - 1
        edge1 = (polygon1[i_prev], polygon1[i])
        edge2 = (polygon2[j_prev], polygon2[j])
        inter = intersect_geometry(edge1, edge2; atol)
        is_colinear = isapprox(cross_product(edge1, edge2), 0.0; atol=atol)
        if !isnothing(inter) && !is_colinear
            is_second_iter = k > (m + n)
            if length(points) > 1 && (all(inter .≈ points[1]) && is_second_iter)
                poly1_in_2 = false
                poly2_in_1 = false
                break
            end
            push!(points, inter)
            poly1_in_2 = in_half_plane(edge2, polygon1[i])
            poly2_in_1 = !poly1_in_2
        end
        advance_1 = false 
        if cross_product(edge2, edge1) >= 0
            advance_1 = !(in_half_plane(edge2, polygon1[i], ))
        else
            advance_1 = in_half_plane(edge1, polygon2[j])
        end
        if advance_1
            if poly1_in_2
                push!(points, polygon1[i])
            end
            i = i % n + 1
        else # advance_2
            if poly2_in_1
                push!(points, polygon2[j])
            end
            j = j % m + 1
        end
    end
    if isempty(points)
        if contains(polygon2, polygon1[1])
            return polygon1
        elseif contains(polygon1, polygon2[1])
            return polygon2
        end
    end
    points
end

# see DataStrctures.jl for a full implementation

mutable struct Node{T}
    data::T
    prev::Node{T}
    next::Node{T}
    function Node(data::T) where T
        node = new{T}(data)
        node.next = node
        node.prev = node
        return node
    end
end

function Node(data::T, prev::Node{T}, next::Node{T}) where T
    node = Node(data)
    node.prev = prev
    node.next = next
    node
end

"""
    insert!(node, data)

Insert a new node `Node(data)` after `node`.
"""
function Base.insert!(node::Node{T}, data::T) where {T}
    middle = Node(data, node, node.next)
    node.next.prev = middle
    node.next = middle
    middle
end

function Base.show(io::IO, node::Node)
    print(io, typeof(node), '(')
    print(io, node.data)
    print(io, ')')
end

mutable struct DoublyLinkedList{T}
    head::Union{Node{T}, Nothing}
end

function Base.push!(list::DoublyLinkedList{T}, data::T) where {T}
    if isnothing(list.head)
        list.head = Node(data)
        return list.head
    end
    head = list.head
    tail = head.prev
    node = Node(data, tail, head)
    head.prev = node
    tail.next = node
    node
end

Base.iterate(list::DoublyLinkedList) = (list.head.data, list.head.next)
Base.iterate(list::DoublyLinkedList, state::Node) = state == list.head ? nothing : (state.data, state.next)

function Base.show(io::IO, list::DoublyLinkedList)
    print(io, typeof(list), "(")
    print(io, isnothing(list.head) ? nothing : join(list, ", "))
    print(io, ")")
end

function Base.show(io::IO, m::MIME"text/plain", list::DoublyLinkedList)
    if isnothing(list.head)
        print(io, typeof(list), "(", nothing, ")")
    else
        print(io, typeof(list), "(\n   ")
        print(io, join(list, ",\n   "))
        print(io, "\n)")
    end
end

function Base.length(list::DoublyLinkedList)
    count = 1
    next = list.head.next
    while next != list.head
        count += 1
        next = next.next
    end
    count
end

function collect_nodes(list::DoublyLinkedList{T}) where T
    # A standard collect(list) will return the data, not the nodes themselves
    vec = Node{T}[]
    node = list.head
    push!(vec, node)
    while node.next != list.head
        node = node.next
        push!(vec, node)
    end
    vec
end

"""
    area_polygon(vertices::Vector{<:Point2D})

Uses the shoelace formula: Σ(xᵢyᵢ₊₁ - yᵢxᵢ₊₁)
"""
function area_polygon(vertices::Polygon2D)
    abs(first_moment(vertices))
end

function first_moment(vertices::Polygon2D)
    # first moment of a simple polygon
    n = length(vertices)
    moment = 0.0
    for i in 1:n
        pt1 = vertices[i]
        pt2 = vertices[(i % n) + 1]
        moment += pt1[1] * pt2[2] - pt1[2] * pt2[1]
    end
    moment *= 0.5
    moment
end

is_clockwise(vertices::Polygon2D) = first_moment(vertices) <= 0.0
is_counter_clockwise(vertices::Polygon2D) = first_moment(vertices) >= 0.0

"""
  centroid_polygon(vertices::Vector{<:Point2D})

Uses the following formulas:
- Cx = (1/6A)Σ(xᵢ + xᵢ₊₁)(xᵢyᵢ₊₁ - yᵢxᵢ₊₁)
- Cy = (1/6A)Σ(yᵢ + yᵢ₊₁)(xᵢyᵢ₊₁ - yᵢxᵢ₊₁)   
"""
function centroid_polygon(vertices::Polygon2D)
    area = first_moment(vertices)
    n = length(vertices)
    Cx = 0.0
    Cy = 0.0
    for i in 1:n
        pt1 = vertices[i]
        pt2 = vertices[(i % n) + 1]
        Cx += (pt1[1] + pt2[1]) * (pt1[1] * pt2[2] - pt1[2] * pt2[1])
        Cy += (pt1[2] + pt2[2]) * (pt1[1] * pt2[2] - pt1[2] * pt2[1])
    end
    centroid = (Cx/(6 * area), Cy/(6 * area))
    centroid 
end

import Base: ==

"""
    Polygon(exterior, holes)
    Polygon(exterior; holes=holes)

A representation of a Polygon with holes.
"""
struct Polygon{T<:AbstractFloat}
    exterior::Path2D{T}
    holes::Vector{<:Path2D{T}}
end

==(polygon1::Polygon, polygon2::Polygon) = 
    (polygon1.exterior == polygon2.exterior) && (polygon1.holes == polygon2.holes)

"""
    validate_polygon(polygon::Polygon)
    validate_polygon(exterior::Path2D; holes=Path2D{T}[]; atol=default_atol)
    
The following checks are done:
1. The exterior and each hole has 3 or more points.
2. The exterior and none of its holes self-intersect.
3. All the holes are contained within the exterior. They can touch at the vertex.

The following additional checks are not done:
1. Holes should not intersect each other.
2. No nested holes: holes should not be inside other holes.
"""
function validate_polygon(exterior::Path2D{T}; holes::Vector{<:Path2D}=Vector{Point2D{T}}[], atol::AbstractFloat=default_atol) where T
    @assert length(exterior) > 2 "exterior requires at least 3 points."
    queue = convert_to_event_queue(exterior)
    @assert !any_intersect(queue; atol=atol, include_vertices=false) "Invalid exterior: edges self-intersect."
    for (idx, hole) in enumerate(holes)
        @assert length(hole) > 2 "Invalid hole $(idx): requires at least 3 points."
        queue_h = convert_to_event_queue(hole)
        @assert !any_intersect(queue_h; atol=atol, include_vertices=false) "Invalid hole $(idx): edges self-intersect."
        for event in queue
            insert_in_order!(queue_h, event; lt=compare_events)
        end
        @assert !any_intersect(queue_h; atol=atol, include_vertices=false) "Hole $(idx) intersects with the exterior."
        j = 1
        while (j < length(hole)) && on_border(exterior, hole[j])
            j += 1
        end
        @assert contains(exterior, hole[j]; atol=atol, on_border_is_inside=false) "Hole $(idx) is outside the polygon."
    end
    true
end

validate_polygon(polygon::Polygon) = validate_polygon(polygon.exterior; holes=polygon.holes)

function Polygon(
    exterior::Path2D{T}
    ; holes::Vector{<:Path2D}=Vector{Point2D{T}}[],
    validate::Bool=false,
    atol::AbstractFloat=default_atol) where T
    if validate
        validate_polygon(exterior; holes=holes, atol=atol)
    end
    Polygon{T}(exterior, holes)
end


"""
    fully_contains(polygon1::Path2D, polygon2::Path2D)

A `polygon1` fully contains another `polygon2` if:
    1. None of their segments intersect. However, they can touch.
    2. At least one point of `polygon2` is inside `polygon1`.

The polygons are assumed to not self-intersect.

The algorithm runs in `O((n+m+k)log(n+m))` time where `n` and `m` are the number of vertices of `polygon1` 
and `polygon2` respectively and `k` is the total number of intersections 
"""
function fully_contains(polygon1::Path2D, polygon2::Path2D; atol::AbstractFloat=default_atol)
    queue = convert_to_event_queue(polygon1; atol=atol)
    events2 = convert_to_event_queue(polygon2; primary=false, atol=atol)
    for event in events2
        insert_in_order!(queue, event; lt=compare_events)
    end
    if any_intersect(queue; include_vertices=false)
        return false
    end
    j = 1
    while (j < length(polygon2)) && on_border(polygon1, polygon2[j])
        j += 1
    end
    contains(polygon1, polygon2[j]; atol=atol, on_border_is_inside=false)
end

"""
    bounds(polygon::Polygon)

A rectangle which bounds the polygon, given as `(xmin, ymin, xmax, ymax)`.
"""
bounds(polygon::Polygon) = bounds(polygon.exterior)

"""
    bounds(polygons::Polygon)

A rectangle which bounds all the polygons, given as `(xmin, ymin, xmax, ymax)`.
"""
bounds(polygons::Vector{<:Polygon}) = bounds(map(p -> p.exterior), polygons)

first_moment(polygon) = first_moment(polygon.exterior) + sum(first_moment, polygon.holes, init=0.0)

"""
    area_polygon(polygon::Polygon)

Uses the shoelace formula: Σ(xᵢyᵢ₊₁ - yᵢxᵢ₊₁). 

Holes are counted as negative area.
"""
function area_polygon(polygon::Polygon)
    area_polygon(polygon.exterior) - sum(map(area_polygon, polygon.holes), init=0.0)
end

is_clockwise(polygon::Polygon) = is_clockwise(polygon.exterior)
is_counter_clockwise(polygon::Polygon) = is_counter_clockwise(polygon.exterior)

"""
    centroid_polygon(polygon::Polygon)

Uses the following formulas:
- Cxⱼ = (1/6Aⱼ)Σ(xᵢ + xᵢ₊₁)(xᵢyᵢ₊₁ - yᵢxᵢ₊₁)
- Cyⱼ = (1/6Aⱼ)Σ(yᵢ + yᵢ₊₁)(xᵢyᵢ₊₁ - yᵢxᵢ₊₁)
- Cx = ΣCxⱼAⱼ/ΣAⱼ
- Cy = ΣCyⱼAⱼ/ΣAⱼ

Holes are counted as negative area.
"""
function centroid_polygon(polygon::Polygon)
    e_area = first_moment(polygon.exterior)
    Cex, Cey = _centroid_loop(polygon.exterior)
    Cx = Cex/(6 * e_area) * abs(e_area)
    Cy = Cey/(6 * e_area) * abs(e_area)
    area = abs(e_area)
    for hole in polygon.holes
        Chx, Chy = _centroid_loop(hole)
        h_area = first_moment(hole)
        Cx -= Chx/(6 * h_area) * abs(h_area)
        Cy -= Chy/(6 * h_area) * abs(h_area)
        area -= abs(h_area)
    end
    Cx /= area
    Cy /= area
    (Cx, Cy)
end

"""
    contains(polygon::Polygon, point; options...)

Inside the polygon's exterior but not in any of its holes. 
"""
function contains(polygon::Polygon, point::Point2D; on_border_is_inside::Bool=true, options...)
    hole_border = !on_border_is_inside
    contains(polygon.exterior, point; on_border_is_inside=on_border_is_inside, options...) && 
        !any(
            hole -> contains(hole, point; on_border_is_inside=hole_border, options...),
            polygon.holes
        )
end

"""
    translate(polygon::Polygon, t::Point2D)

Translate a set of polygon by delta `t`.
"""
function translate(polygon::Polygon, t::Point2D)
    # no type inference if holes is empty
    holes = isempty(polygon.holes) ? polygon.holes : map(p->translate(p, t), polygon.holes)
    Polygon(
        translate(polygon.exterior, t),
        holes,
    )
end

"""
    rotate(polygon::Polygon, θ, p0=(0, 0))

Rotate a polygon by `θ` radians about `p0`.
"""
function rotate(polygon::Polygon, θ::AbstractFloat)
    # no type inference if holes is empty
    holes = isempty(polygon.holes) ? polygon.holes : map(p->rotate(p, θ), polygon.holes)
    Polygon(
        rotate(polygon.exterior, θ),
        holes
    )
end

function rotate(polygon::Polygon, θ::AbstractFloat, p0::Point2D)
    holes = isempty(polygon.holes) ? polygon.holes : map(p->rotate(p, θ, p0), polygon.holes)
    Polygon(
        rotate(polygon.exterior, θ, p0),
        holes
    )
end

x_coords(polygon::Polygon) = 
    vcat([x_coords(polygon.exterior)], map(x_coords, polygon.holes))
y_coords(polygon::Polygon) = 
    vcat([y_coords(polygon.exterior)], map(y_coords, polygon.holes))

"""
    weiler_atherton_algorithm(polygon1, polygon2; atol=1e-6)

The Weiler-Atherton polygon clipping algorithm.
Returns regions, edges and single points of intersection. 
Only returns the larger type if one is within another e.g. an edge is also part of a region.

It runs in `O(nm)` time where `n` and `m` are the number of vertices of `polygon1` and `polygon2` respectively.
Use `intersect_convex` for convex polygons for an `O(n+m)` algorithm.

Description: operates at a point level. Walks from point to point along `polygon2`. 
It starts recording loops at "entry points" - crossings from `polygon2` to `polygon1` - and 
stops recording when it gets back to the same entry point. Then it continues walking along `polygon2`
until it reaches the start point.

Limitations
1. This version does not cater for holes.
2. It can fail completely for self-intersecting polygons.

For a more general algorithm see the Martinez-Rueda polygon clipping algorithm.
"""
function weiler_atherton_algorithm(
    polygon1::Polygon2D{T}, polygon2::Polygon2D{T}
    ; atol::AbstractFloat=1e-6
    ) where T
    if polygon1 == polygon2
        return [polygon1]
    end
    n = length(polygon1)
    m = length(polygon2)
    @assert n > 2 &&  m > 2 "require at least 3 points per polygons; lengths are $n and $m"
    if is_counter_clockwise(polygon1)
        polygon1 = reverse(polygon1)
    end
    if is_counter_clockwise(polygon2)
        polygon2 = reverse(polygon2)
    end
    list1 = convert_to_linked_list(polygon1)
    list2 = convert_to_linked_list(polygon2)
    find_and_insert_intersections!(list1, list2; atol=atol)
    regions, visited = walk_linked_lists(list2)
    # special cases
    if isempty(regions)
        p1 = get_first_non_intersection_point(list1)
        p2 = get_first_non_intersection_point(list2)
        if contains(polygon2, p1)
            return [polygon1]
        elseif contains(polygon1, p2)
            return [polygon2]
        end
    end
    not_visited = get_unvisited_intercepts(list2, visited)
    push!(regions, not_visited...)
    regions
end

@enum IntersectionType NONE ENTRY EXIT VERTEX

mutable struct PointEvent{T}
    point::Point2D{T}
    intersection::Bool
    link::Union{Nothing,Node{PointEvent{T}}}
    type::IntersectionType
end

function convert_to_linked_list(polygon::Polygon2D{T}) where T
    data = PointEvent{T}(polygon[1], false, nothing, NONE)
    head = Node(data)
    list = DoublyLinkedList(head)
    for point in polygon[2:end]
        data = PointEvent{T}(point, false, nothing, NONE)
        push!(list, data)
    end
    list
end

function get_first_non_intersection_point(polygon::DoublyLinkedList{<:PointEvent})
    start = polygon.head
    node = start
    while node.data.intersection && node.next != start
        node = node.next
    end
    node.data.point
end

function find_and_insert_intersections!(
        polygon1::DoublyLinkedList{PointEvent{T}}, 
        polygon2::DoublyLinkedList{PointEvent{T}};
        atol::AbstractFloat=1e-6
        ) where T
    ## collect original nodes before mutating in place
    vec1 = collect_nodes(polygon1)
    vec2 = collect_nodes(polygon2)
    ## find intersections
    for (node2, next2) in zip(vec2, vcat(vec2[2:end], vec2[1]))
        edge2 = (node2.data.point, next2.data.point)
        for (node1, next1) in zip(vec1, vcat(vec1[2:end], vec1[1]))
            edge1 = (node1.data.point, next1.data.point) 
            p = intersect_geometry(edge1, edge2; atol=atol)
            if !isnothing(p)
                i1 = insert_intersection_in_order!(p, node1, next1; atol=atol)
                i2 = insert_intersection_in_order!(p, node2, next2; atol=atol)
                link_intersections!(i1, i2, edge1, edge2; atol=atol)
            end
        end
    end
end

function insert_intersection_in_order!(
    point::Point2D, tail::Node{<:PointEvent}, head::Node{<:PointEvent}
    ; atol::AbstractFloat=1e-6
    )
    node = tail
    while node != head.next
        d1 = norm(point, node.data.point)
        d2 = norm(node.next.data.point, node.data.point)
        if d1 < atol # either on tail or intersection here already
            node.data.intersection = true
            return node
        elseif abs(d1 - d2) < atol # either on head or intersection here already
            node.next.data.intersection = true
            return node.next
        elseif d1 < d2
            break
        end
        node = node.next
    end
    info = PointEvent(point, true, nothing, NONE)
    insert!(node, info)
end

function link_intersections!(
        inter1::Node{<:PointEvent}, 
        inter2::Node{<:PointEvent}, 
        edge1::Segment2D, 
        edge2::Segment2D; 
        atol::AbstractFloat=1e-6
    )
    point = inter1.data.point
    on_edge1 = (is_same_point(point, edge1[1]; atol=atol) || is_same_point(point, edge1[2]; atol=atol))
    head2_on_edge = is_same_point(point, edge2[2]; atol=atol)
    tail2_on_edge = is_same_point(point, edge2[1]; atol=atol)
    on_edge2 = head2_on_edge || tail2_on_edge
    if on_edge1 && on_edge2 # case 1: intersect at common vertex
        prev1 = inter1.prev.data.point
        next1 = inter1.next.data.point
        next2 = inter2.next.data.point
        prev2 = inter2.prev.data.point
        next2_on_edge1, prev2_on_edge1 = has_edge_overlap(point, prev1, next1, prev2, next2)
        tail2_in_1, head2_in_1 = in_plane((prev1, point, next1), prev2, next2)
        tail2_in_1 = tail2_in_1 || prev2_on_edge1
        head2_in_1 = head2_in_1 || next2_on_edge1
        if head2_in_1 == tail2_in_1
            # vertex between edges or lone inner/outer vertex 
            set_vertex_intercept!(inter1, inter2)  
        else 
            set_link!(inter1, inter2, head2_in_1)
        end
    elseif head2_on_edge # case 2: edge2 hitting edge
        tail_in_1 = in_half_plane(edge1, edge2[1], false)
        set_link!(inter1, inter2, !tail_in_1)
    elseif tail2_on_edge # case 3: edge2 leaving edge
        head_in_1 = in_half_plane(edge1, edge2[2], false)
        set_link!(inter1, inter2, head_in_1)  
    else # case 4: cross or edge1 hitting/leaving edge
        entering_1_from_2 = in_half_plane(edge1, edge2[2], false)
        set_link!(inter1, inter2, entering_1_from_2)
    end
    if is_vertex_intercept(inter2) # bounces off (case 2+3) or cycles back (case 2/3+4)
        inter1.data.type = VERTEX
        inter2.data.type = VERTEX
    end
    inter1, inter2
end

function set_link!(inter1::Node{<:PointEvent}, inter2::Node{<:PointEvent}, entering_1_from_2::Bool)
    if entering_1_from_2 # edge of polygon 2 is entering poylgon 1 
        inter1.data.link = inter2
        inter2.data.type = ENTRY
    else 
        inter2.data.link = inter1
        inter2.data.type = EXIT
    end 
end

function set_vertex_intercept!(inter1::Node{<:PointEvent}, inter2::Node{<:PointEvent})
    inter1.data.link = inter2
    inter2.data.link = inter1
    inter2.data.type = VERTEX
    inter1.data.type = VERTEX
end

function walk_linked_lists(polygon::DoublyLinkedList{PointEvent{T}}) where T
    regions = Vector{Point2D{T}}[]
    node = polygon.head
    visited = PointSet()
    while !isnothing(node)
        if !(node.data.point in visited) && node.data.type == ENTRY
            loop, visited_in_loop = walk_loop(node)
            if !isempty(visited_in_loop)
                visited_points = [p.data.point for p in visited_in_loop]
                push!(visited, visited_points...)
            end
            push!(regions, loop)
        end
        node = node.next == polygon.head ? nothing : node.next
    end
    regions, visited
end

function walk_loop(start::Node{PointEvent{T}}) where T
    loop = Point2D{T}[]
    visited = Set{Node{PointEvent{T}}}()
    push!(loop, start.data.point)
    push!(visited, start)
    node = start.next
    from_link = false # for debugging purposes
    while (node != start) && (node.data.point != start.data.point)
        push!(loop, node.data.point)
        if (node in visited) && # can go to the same point on different nodes!
            (node.data.type != VERTEX) &&  # many edges can hit the same vertex
            (node.prev.data.point != node.data.point) # exception for repeated nodes
            @warn "Cycle detected: start node: $start; repeated node: $node"
            break
        end
        push!(visited, node)
        if !isnothing(node.data.link) && node.data.type != VERTEX 
            if (node.data.link == start)
                break
            end
            from_link = true
            node = node.data.link.next
        else
            from_link = false
            node = node.next
        end
    end
    loop, visited
end

function is_vertex_intercept(node::Node{<:PointEvent})
    node2 = node.data.link
    !isnothing(node2) && !isnothing(node2.data.link) && node2.data.link == node
end

function get_unvisited_intercepts(polygon::DoublyLinkedList{PointEvent{T}}, visited::PointSet{T}) where T
    regions = Vector{Point2D{T}}[]
    node = polygon.head
    while !isnothing(node)
        if node.data.intersection && !(node.data.point in visited) 
            push!(regions, [node.data.point])
        end
        node = node.next == polygon.head ? nothing : node.next
    end
    regions
end

function has_edge_overlap(vertex::Point2D, prev1::Point2D, next1::Point2D, prev2::Point2D, next2::Point2D)
    tail_edge1 = (prev1, vertex)
    head_edge1 = (vertex, next1)
    tail_edge2 = (prev2, vertex)
    head_edge2 = (vertex, next2)
    mid_tail1 = segment_midpoint(tail_edge1)
    mid_head1 = segment_midpoint(head_edge1)
    mid_tail2 = segment_midpoint(tail_edge2)
    mid_head2 = segment_midpoint(head_edge2)
    # check both because one edge might be shorter
    prev2_on_tail1 = on_segment(mid_tail2, tail_edge1) || on_segment(mid_tail1, tail_edge2)
    prev2_on_head1 = on_segment(mid_tail2, head_edge1) || on_segment(mid_head1, tail_edge2)
    next2_on_tail1 = on_segment(mid_head2, tail_edge1) || on_segment(mid_tail1, head_edge2)
    next2_on_head1 = on_segment(mid_head1, head_edge2) || on_segment(mid_head2, head_edge1)
    # check both because unsure of directions
    prev2_on_edge1 = prev2_on_head1 || prev2_on_tail1
    next2_on_edge1 = next2_on_tail1 || next2_on_head1
    next2_on_edge1, prev2_on_edge1
end

function segment_midpoint(segment::Segment2D)
    x = (segment[1][1] + segment[2][1])/2
    y = (segment[1][2] + segment[2][2])/2
    (x, y)
end

function in_plane(edge::NTuple{3, Point2D}, point1::Point2D, point2::Point2D)
    # assume half-plane is clockwise of the edge
    # if in half-planes of edge[1:2] && edge[2:3] then definitely in the plane.
    # But if in one half-plane it can be either in or out. 
    # A better strategy is to check angles instead.
    vertex = edge[2]
    angle_tail = atan_pos(edge[1][2] - vertex[2], edge[1][1] - vertex[1])
    angle_head = atan_pos(edge[3][2] - vertex[2], edge[3][1] - vertex[1])
    angle1 = atan_pos(point1[2] - vertex[2], point1[1] - vertex[1])
    angle2 = atan_pos(point2[2] - vertex[2], point2[1] - vertex[1])
    if angle_tail < angle_head
        tail2_in_1 = (angle_tail < angle1 < angle_head) 
        head2_in_1 = (angle_tail < angle2 < angle_head) 
    else
        tail2_in_1 = (angle1 > angle_tail) || (angle1 < angle_head)
        head2_in_1 = (angle2 > angle_tail) || (angle2 < angle_head)
    end
    tail2_in_1, head2_in_1
end

function atan_pos(y::Real, x::Real)
    angle = atan(y, x)
    angle < 0 ? angle + 2π : angle
end

module PolygonAlgorithms

import Base: contains, insert!, iterate, merge!, push!, ==
import Base: length, show

include("definitions.jl")
include("utils.jl")
include("orientation.jl")
include("data_structures/linked_list.jl")
include("data_structures/point_set.jl")

include("bounds.jl")
include("convex_hull.jl")
include("intersect.jl")
include("moments.jl")

include("point_in_polygon.jl")
include("polygon_boolean.jl")
include("deprecations.jl")

export Point2D, Polygon2D, Segment2D, Line2D
export get_orientation, Orientation, on_segment
export bounds, convex_hull
export area_polygon, first_moment, centroid_polygon, is_counter_clockwise, is_clockwise
export do_intersect, intersect_geometry, intersect_edges
export difference_geometry, union_geometry, xor_geometry 
export intersect_convex

end

@enum Orientation COLINEAR=0 CLOCKWISE=1 COUNTER_CLOCKWISE=2

"""
    get_orientation(p, q, r; rtol=1e-4, atol=1e-6)

Determine orientation of three points. 

Colinear is returned if `cross(pq, qr) <= atol`.
The relative tolerance `rtol` is no longer used and will be removed in the future.

Clockwise is returned if `cross(pq, qr)` is positive, else counter-clockwise.
"""
function get_orientation(p::Point2D, q::Point2D, r::Point2D; rtol::AbstractFloat=1e-4, atol::AbstractFloat=1e-6)
    pq = (q[1] - p[1], q[2] - p[2])
    qr = (r[1] - q[1], r[2] - q[2])
    cross_product = pq[2] * qr[1] - qr[2] * pq[1]
    orientation = abs(cross_product) <= atol ? COLINEAR : 
        cross_product >= 0 ?  CLOCKWISE : 
        COUNTER_CLOCKWISE
    orientation
end

"""
    on_segment(point, segment, [on_line]; atol=1e-6)

Determine if a point lies on the segment. 
"""
function on_segment(q::Point2D, segment::NTuple{2, Point2D};
    atol::AbstractFloat=1e-6, on_line::Union{Nothing, Bool}=nothing
    )
    Base.depwarn("`on_segment(q, segment; on_line)` is deprecated, use `on_segment(q, segment, on_line)` instead.", :on_segment)
    p, r = segment
    if isnothing(on_line)
        on_line = get_orientation(p, q, r) == COLINEAR
    end
    on_segment(q, segment, on_line; atol=atol)
end

function on_segment(
    q::Point2D, segment::NTuple{2, Point2D}, on_line::Bool
    ; atol::AbstractFloat=1e-6
    )
    p, r = segment
    return on_line && (
        (q[1] <= max(p[1] + atol, r[1] + atol)) &&
        (q[1] >= min(p[1] - atol, r[1] - atol)) &&
        (q[2] <= max(p[2] + atol, r[2] + atol)) &&
        (q[2] >= min(p[2] - atol, r[2] - atol))
        )
end

function isless_orientation(p::Point2D, q::Point2D, p0::Point2D; rtol::AbstractFloat=1e-4)
    # a point p is "less than" another if it has a smaller angle from p0 in a counter-clockwise direction
    # or if the angle is the same, if is closer
    # instead of calculating the angle atan(p[2]-p0[2], p[1]-p0[1]), determine if (p0, p, q) is counter-clockwise
    # doesn't seem to work properly for on a circle
    ori = get_orientation(p0, p, q; rtol=rtol)
    if ori == COLINEAR
        dp = norm2(p, p0)
        dq = norm2(q, p0)
        val = dp <= dq
    else
        val = ori == COUNTER_CLOCKWISE
    end
    val
end

function isless_polar_angle(p::Point2D, q::Point2D, p0::Point2D)
    angle_p = atan(p[2] - p0[2], p[1] - p0[1])
    angle_q = atan(q[2] - p0[2], q[1] - p0[1])
    if angle_p == angle_q
        dp = norm2(p, p0)
        dq = norm2(q, p0)
        val = dp <= dq
    else
        val = angle_p < angle_q
    end
    val
end

function sort_counter_clockwise(points::Vector{<:Point2D})
    middle = reduce(.+, points, init=(0.0, 0.0)) ./ length(points)
    sort(points, lt=(p, q) -> isless_polar_angle(p, q, middle))
end

function sort_clockwise(points::Vector{<:Point2D})
    middle = reduce(.+, points, init=(0.0, 0.0)) ./ length(points)
    sort(points, lt=(p, q) -> !isless_polar_angle(p, q, middle))
end

# orientation between two lines
function cross_product(edge1::Segment2D, edge2::Segment2D)
    a = (edge1[2][1] - edge1[1][1], edge1[2][2] - edge1[1][2])
    b = (edge2[2][1] - edge2[1][1], edge2[2][2] - edge2[1][2])
    a[1] * b[2] - a[2] * b[1]
end

# angle between two lines
function dot_product(p::Point2D, q::Point2D, r::Point2D)
    (p[1] - q[1]) * (r[1] - q[1]) + (p[2] - q[2]) * (r[2] - q[2])
end

function inner_angle(p::Point2D, q::Point2D, r::Point2D)
    dot = dot_product(p, q, r)
    mag1 = dot_product(p, q, p)
    mag2 = dot_product(r, q, r)
    acos(dot / (sqrt(mag1 * mag2)))
end

# the half-plane is drawn by extending the edge to ±infinity and back into the polygon
function in_half_plane(edge::Segment2D, x::Point2D, is_counter_clockwise::Bool=true; on_border_is_inside=true)
    c = cross_product(edge, (edge[1], x))
    (c == 0.0 && on_border_is_inside) || (is_counter_clockwise ? c > 0 : c < 0)
end

"""
    is_above_or_on(point, segment)

Is `point` above or on `segment`?

In the general case, checks if the point `(xp, yp)` is above or on the line through the segment
`((x₁, y₁), (x₂, y₂))`:
```
yp ≥ (y₂-y₁)/(x₂-x₁) * (xp-x₁) + y₁
```

This is equivalent to checking if the three points `((x₁, y₁), (x₂, y₂), (xp, yp))` are orientated counter-clockwise or are co-linear:
```
0  ≥ (y₂-y₁) * (xp-x₁) - (yp-y₁) * (x₂-x₁)
```

In the special case of a vertical segment (`x₂=x₁`), this compares `y` values:
```
yp ≥ max(y₂, y₁)
```
"""
function is_above_or_on(point::Point2D, segment::Segment2D; atol::AbstractFloat=1e-6, rtol::AbstractFloat=1e-4)
    if abs(segment[2][1] - segment[1][1]) <= atol # vertical segment
        return point[2] >= max(segment[1][2], segment[2][2])
    end
    cmp = get_orientation(segment[1], segment[2], point; atol=atol, rtol=rtol)
    cmp != CLOCKWISE # is counter-clockwise or co-linear
end

using Plots
using PolygonAlgorithms
using PolygonAlgorithms: x_coords, y_coords
using PolygonAlgorithms: SegmentEvent, event_loop!, convert_to_event_queue, add_annotated_segment!
using PolygonAlgorithms: apply_selection_criteria

function plot_segment_event!(
    canvas,
    event::SegmentEvent
    ; 
    d::Float64=0.2,
    color::Union{Colorant, Symbol},
    self_color::Union{Colorant, Symbol},
    other_color::Union{Colorant, Symbol},
    options...
    )
    segment = event.segment
    plot!(canvas, [segment[1][1], segment[2][1]], [segment[1][2], segment[2][2]]; arrow=true, label="", color=color, options...)
    midpoint = ((segment[1][1]+segment[2][1])/2, (segment[1][2]+segment[2][2])/2)
    # Vectors
    Δx = (segment[2][1] - segment[1][1])
    Δy = (segment[2][2] - segment[1][2])
    Δr = sqrt(Δx * Δx + Δy *Δy )
    n = (d * Δy/Δr,  d * Δx/Δr) # normal vector to the segment
    u = (d * Δx/Δr,  d * Δy/Δr) # unit vector to the segment
    # self annotations
    annotations = event.self_annotations
    filled = isnothing(annotations.fill_above) ? :black : (annotations.fill_above ? self_color : :white)
    scatter!(canvas, [midpoint[1] - n[1] + u[1]], [midpoint[2] + n[2] + u[2]], marker=:circle, color=filled, label="")
    filled = isnothing(annotations.fill_below) ? :black : (annotations.fill_below ? self_color : :white)
    scatter!(canvas, [midpoint[1] + n[1] + u[1]], [midpoint[2] - n[2] + u[2]], marker=:circle, color=filled, label="")
    # other annotations
    annotations = event.other_annotations
    filled = isnothing(annotations.fill_above) ? :black : (annotations.fill_above ? other_color : :white)
    scatter!(canvas, [midpoint[1] - n[1] - u[1]], [midpoint[2] + n[2] - u[2]], marker=:diamond, color=filled, label="")
    filled = isnothing(annotations.fill_below) ? :black : (annotations.fill_below ? other_color : :white)
    scatter!(canvas, [midpoint[1] + n[1] - u[1]], [midpoint[2] - n[2] - u[2]], marker=:diamond, color=filled, label="")
end

function plot_segment!(
    canvas,
    segment::Segment2D
    ;
    color::Union{Colorant, Symbol}, options...
    )
    plot!(canvas, [segment[1][1], segment[2][1]], [segment[1][2], segment[2][2]]; label="", color=color, options...)
end

function calc_annotation_distance(canvas, polygon)
    (xmin, ymin, xmax, ymax) = bounds(polygon)
    width = max(xmax-xmin, ymax-ymin)
    d = width/canvas.attr[:size][2] * 4 # 4 pixels
    d
end

self_intersect = [
    (0.0, 0.0), (2.0, 2.0), (6.0, -2.0), (11.0, 2.0), (11.0, 0.0)
]
rectangle_horiz = [
    (-1.0, 0.0), (-1.0, 3.0), (12.0, 3.0), (12.0, 0.0)
]
polygon1 = self_intersect
polygon2 = rectangle_horiz

# martinez_rueda_algorithm
event_queue1 = convert_to_event_queue(polygon1; primary=true)
annotated_segments1 = event_loop!(event_queue1, self_intersection=true)
event_queue2 = convert_to_event_queue(polygon2; primary=false)
annotated_segments2 = event_loop!(event_queue2, self_intersection=true)
queue = SegmentEvent{Float64}[]
for ev in vcat(annotated_segments1, annotated_segments2)
    add_annotated_segment!(queue, ev)
end
annotated_segments3 = event_loop!(deepcopy(queue), self_intersection=false)
# for consistent reporting, swap annotations so that self annotations are always the primary
for ev in annotated_segments3
    if !ev.primary
        temp = ev.self_annotations
        ev.self_annotations = ev.other_annotations
        ev.other_annotations = temp
    end
end

# plot
colors = palette(:default)
idxs1 = vcat(1:length(polygon1), 1)
canvas_shapes = plot(x_coords(polygon1[idxs1]), y_coords(polygon1[idxs1]), aspectratio=:equal, arrow=false, fill=(0, 0.5))
idxs2 = vcat(1:length(polygon2), 1)
plot!(canvas_shapes, x_coords(polygon2[idxs2]), y_coords(polygon2[idxs2]), arrow=false, fill=(0, 0.5))

canvas_annotations = plot(aspect_ratio=:equal)
d = calc_annotation_distance(canvas_annotations, polygon2)
# for (i, event) in enumerate(annotated_segments1)
#     plot_segment_event!(canvas_annotations, event; color=colors[1], d=d, self_color=colors[1], other_color=colors[2])
# end
# for (i, event) in enumerate(annotated_segments2)
#     plot_segment_event!(canvas_annotations, event; color=colors[2], d=d, self_color=colors[2], other_color=colors[2])
# end
for (i, event) in enumerate(annotated_segments3)
    col = event.primary ? colors[1] : colors[2]
    plot_segment_event!(canvas_annotations, event; color=col, d=d, self_color=colors[1], other_color=colors[2])
end
canvas_annotations

## Selections
selected = apply_selection_criteria(annotated_segments3, PolygonAlgorithms.INTERSECTION_CRITERIA)

canvas_selected = deepcopy(canvas_shapes)
for (i, event) in enumerate(selected)
    plot_segment_event!(canvas_selected, event; color=:red, self_color=:red, other_color=colors[2], d=d)
end
canvas_selected

plot(canvas_annotations, canvas_selected)

function points_to_matrix(v::Vector{<:Point2D{T}}) where {T}
    X = Matrix{T}(undef, 2, length(v))
    for i in 1:length(v)
        X[1, i] = v[i][1]
        X[2, i] = v[i][2]
    end
    X
end

function matrix_to_points(m::AbstractMatrix{T}) where {T}
    N = size(m, 1)
    points = NTuple{N,T}[]
    for col in eachcol(m)
        push!(points, tuple(col...))
    end
    points
end

function separate(f, v::Vector)
    idxs = findall(f, v)
    other_idxs = setdiff(eachindex(v), idxs)
    (@view(v[idxs]), @view(v[other_idxs]))
end
  

using Test
using PolygonAlgorithms
using PolygonAlgorithms: translate, rotate, PointSet

function are_regions_equal(r1::Vector{<:Vector{<:Point2D}}, r2::Vector{<:Vector{<:Point2D}})
    if length(r1) != length(r2)
        return false
    end
    r1_sets = [PointSet(r) for r in r1]
    r2_sets = [PointSet(r) for r in r2]
    issetequal(r1_sets, r2_sets)
end

@testset verbose = true "PolygonAlgorithms" begin
    include("linked_list.jl")
    include("point_set.jl")
    include("area-centroid.jl")
    include("bounds.jl")
    include("intersect.jl")
    include("point_in_polygon.jl")
    include("martinez_rueda.jl")
    include("intersect_convex.jl")
    include("intersect_concave.jl")
    include("convex_hull.jl")
end

const Point2D{T<:AbstractFloat} = NTuple{2,T}
const Segment2D{T<:AbstractFloat} = NTuple{2,Point2D{T}}
const Polygon2D{T<:AbstractFloat} = Vector{<:Point2D{T}}

"""
    Line2D(a, b, c)

Equation of line is `ax + by = c`.
"""
struct Line2D{T<:AbstractFloat}
    a::T
    b::T
    c::T
end

function Base.getindex(line::Line2D, ind::Int)
    if ind > 3 || ind < 1
        throw(DomainError(Line2D, "Attempted to access 3-element Line2D at ind=$ind"))
    end
    ind == 1 ? line.a : ind == 2 ? line.b : line.c
end

"""
    line_from_segment(segment)

Equation of line is `ax + by = c`.
"""
function line_from_segment(segment::Segment2D)
    a = segment[1][2] - segment[2][2]
    b = segment[2][1] - segment[1][1] 
    c = a * segment[1][1] + b * segment[1][2]
    Line2D(a, b, c)
end

### basic operations on points
norm2(p::Point2D, q::Point2D) = (p[1] - q[1]) * (p[1] - q[1]) + (p[2] - q[2]) * (p[2] - q[2])
norm(p::Point2D, q::Point2D) = sqrt(norm2(p, q))

is_same_point(p::Point2D, q::Point2D; atol::AbstractFloat=1e-6) = norm(p, q) <= atol
translate(points::Vector{<:Point2D}, t::Point2D) = [(p[1] + t[1], p[2] + t[2]) for p in points]

"""
    rotate(points, θ, p0=(0, 0))

Rotate a set of points `θ` radians about `p0`.
"""
function rotate(points::Vector{<:Point2D}, θ::AbstractFloat)
    s = sin(θ)
    c = cos(θ)
    [(p[1] * c - p[2] * s, p[1] * s + p[2] * c) for p in points]
end

rotate(points::Vector{<:Point2D}, θ::AbstractFloat, p0::Point2D) = 
    translate(rotate(translate(points, (-p0[1], -p0[2])), θ), p0)

x_coords(points::Polygon2D) = [p[1] for p in points]
x_coords(points::Polygon2D, idxs::AbstractVector{Int}) = [p[1] for p in points[idxs]]
y_coords(points::Polygon2D) = [p[2] for p in points]
y_coords(points::Polygon2D, idxs::AbstractVector{Int}) = [p[2] for p in points[idxs]]

using PolygonAlgorithms: GiftWrappingAlg, GrahamScanAlg

@testset "convex hulls - $alg" for alg in [
    GiftWrappingAlg(),
    GrahamScanAlg(),
]

@testset "convex hull rectangle" begin
    h, w = 2.0, 3.0
    poly = [
        (0.0, 0.0), (0.0, h), (w, h), (w, 0.0)
    ]
    hull = convex_hull(poly, alg)
    expected = 1:4
    @test issetequal(hull, expected)

    poly = [
        (0.0, 0.0), (0.0, h/2), 
        (0.0, h), (w/2, h),
        (w, h), (w, h/2), 
        (w, 0.0), (w/2, 0.0),
    ]
    hull = convex_hull(poly, alg)
    expected = [1, 3, 5, 7]
    @test issetequal(hull, expected)

    interior = [(w * rand(), h * rand()) for i in 1:10]
    push!(poly, interior...)
    @test issetequal(hull, expected)
end;

@testset "convex hull H" begin
    poly = [
        (2.0, 10.0), (4.0, 10.0), (4.0, 6.0), (6.0, 6.0), (6.0, 10.0), (8.0, 10.0), 
        (8.0, 1.0), (6.0, 1.0), (6.0, 4.0), (4.0, 4.0), (4.0, 1.0), (2.0, 1.0)
    ]
    hull = convex_hull(poly, alg)
    expected = [1, 6, 7, 12]
    @test issetequal(hull, expected)
end;

@testset "convex hull grid" begin
    points = [(i, j) for i in 1.0:10.0 for j in 1.0:10.0]
    hull = convex_hull(points, alg)
    expected = [1, 10, 91, 100]
    @test issetequal(hull, expected)
end

@testset "generic" begin
    points = [
        (0.5, 0.7),
        (0.3, 0.4),
        (0.4, 0.4),
        (0.6, 1.0),
        (0.6, 0.4),
        (0.5, 0.9),
        (0.4, 0.3),
        (0.0, 0.3),
        (0.8, 0.1),
        (0.3, 0.9),
        (0.8, 0.8),
        (0.9, 0.2),
        (0.5, 0.2),
        (0.7, 0.6),
    ]
    ;
    hull = convex_hull(points, alg)
    expected = [4, 8, 9, 10, 11, 12]
    @test issetequal(hull, expected)
end

@testset "convex hull circle" begin
    # worst case for GiftWrappingAlg
    n = 10
    angles = 2π * rand(n)
    points = [(sin(t), cos(t)) for t in angles]
    hull = convex_hull(points, alg)
    expected = 1:n
    @test issetequal(hull, expected)
end

end

"""
    do_intersect(segment1, segment2; rtol=1e-4)

Determine if the segments intersect. For the intersection point, use `intersect_geometry`. 
"""
function do_intersect(segment1::Segment2D, segment2::Segment2D; rtol::AbstractFloat=1e-4)
    o1 = get_orientation(segment1[1], segment1[2], segment2[1]; rtol=rtol)
    o2 = get_orientation(segment1[1], segment1[2], segment2[2]; rtol=rtol)
    o3 = get_orientation(segment2[1], segment2[2], segment1[1]; rtol=rtol)
    o4 = get_orientation(segment2[1], segment2[2], segment1[2]; rtol=rtol)

    # general case
    if (o1 != o2) && (o3 != o4)
        return true
    end

    # special cases -> co-linear points on the segment
    return ((o1 == COLINEAR && on_segment(segment2[1], segment1)) ||
        (o2 == COLINEAR && on_segment(segment2[2], segment1)) ||
        (o3 == COLINEAR && on_segment(segment1[1], segment2)) || 
        (o4 == COLINEAR && on_segment(segment1[2], segment2))
        )
end
    
"""
    intersect_geometry(segment1, segment2; atol=1e-6)

Returns the intersection point if it exists or nothing otherwise.
Use `do_intersect` for a quicker boolean test.
"""
function intersect_geometry(
        segment1::Segment2D, segment2::Segment2D; atol::AbstractFloat=1e-6
    )
    line1 = line_from_segment(segment1)
    line2 = line_from_segment(segment2)

    point = intersect_geometry(line1, line2; atol=atol)
    if isnothing(point)
        return nothing
    end
    
    on_segment1 = on_segment(point, segment1, true; atol=atol)
    on_segment2 = on_segment(point, segment2, true; atol=atol)
    if on_segment1 && on_segment2
        return point 
    end
    nothing        
end

function classify_intersection(segment::Segment2D, point::Point2D; atol::AbstractFloat=1e-6)
    # assumes point is on segment
    at_start = is_same_point(segment[1], point; atol=atol)
    at_end = is_same_point(segment[2], point; atol=atol)
    along = !(at_start || at_end)
    (at_start, at_end, along)
end

"""
    intersect_geometry(line1::Line2D, line2::Line2D; atol=1e-6)

Returns the intersection point if it exists or nothing if they are parallel or coincident.

Equation of line is `ax + by = c`.

Intersection is then the solution of:
```
|a1 b1 | | x | = | c1 |
|a2 b2 | | y |   | c2 |
```
"""
function intersect_geometry(line1::Line2D, line2::Line2D; atol::AbstractFloat=1e-6)
    a1, b1, c1 = line1.a, line1.b, line1.c
    a2, b2, c2 = line2.a, line2.b, line2.c
    determinant = a1 * b2 - a2 * b1
    if abs(determinant) < atol
        return nothing # parallel lines or coincident
    end
    x = (b2 * c1 - b1 * c2) / determinant
    y = (a1 * c2 - c1 * a2) / determinant
    (x, y)
end

"""
    intersect_edges(polygon1::Vector{<:Point2D}, polygon2::Vector{<:Point2D})

Find all points which lie on the intersection of the edges of the vertices given by `polygon1` and `polygon2`.

Time complexity is `O(nm)` where `n` and `m` are the number of vertices of polygon 1 and 2 respectively.
"""
function intersect_edges(
    polygon1::Polygon2D{T}, polygon2::Polygon2D{T}
    ; atol::AbstractFloat=1e-6
    ) where T
    points = Point2D{T}[]
    n = length(polygon1)
    m = length(polygon2)
    for i in 1:n
        edge1 = (polygon1[i], polygon1[i % n + 1])
        for j in 1:m
            edge2 = (polygon2[j], polygon2[j % m + 1])
            p = intersect_geometry(edge1, edge2; atol=atol)
            if !isnothing(p)
                push!(points, (p[1], p[2]))
            end
        end
    end
    points
end

using PolygonAlgorithms: Polygon, fully_contains, validate_polygon
using PolygonAlgorithms: x_coords, y_coords, translate, rotate

@testset "Polygon data structure" begin

@testset "area-centroid holes" begin
    polygon = Polygon(
        [(0.0, 0.0), (20.0, 0.0), (10.0, 10.0), (0.0, 10.0)],
        [[(1.0, 8.0), (7.0, 8.0), (7.0, 3.0), (1.0, 3.0)]]
    )
    @test first_moment(polygon) == 120
    @test area_polygon(polygon) == 120

    @test centroid_polygon(polygon) == (8.722222222222223, 4.180555555555556)

    @test bounds(polygon) == (0.0, 0.0, 20.0, 10.0)

    @test !is_clockwise(polygon)
    @test is_counter_clockwise(polygon)
    @test is_clockwise(polygon.holes[1])

    # swap hole and exterior
    polygon = Polygon(
        [(1.0, 8.0), (7.0, 8.0), (7.0, 3.0), (1.0, 3.0)],
        [[(0.0, 0.0), (20.0, 0.0), (10.0, 10.0), (0.0, 10.0)]],
    ) # skips validation
    @test area_polygon(polygon) == -120
    @test centroid_polygon(polygon) == (8.722222222222223, 4.180555555555556)

    # exterior == hole
    polygon = Polygon(
        [(0.0, 0.0), (20.0, 0.0), (10.0, 10.0), (0.0, 10.0)],
        [[(0.0, 0.0), (20.0, 0.0), (10.0, 10.0), (0.0, 10.0)]],
    ) # skips validation
    @test area_polygon(polygon) == 0.0
    @test all(isnan.(centroid_polygon(polygon)))
end

@testset "coordinates" begin
    polygon = Polygon(
        [(0.0, 0.0), (20.0, 0.0), (10.0, 10.0), (0.0, 10.0)],
        [[(1.0, 8.0), (7.0, 8.0), (7.0, 3.0), (1.0, 3.0)]]
    )
    expected = [
        [0.0, 20.0, 10.0, 0.0], [1.0, 7.0, 7.0, 1.0]
    ]
    @test x_coords(polygon) == expected
    expected = [
        [0.0, 0.0, 10.0, 10.0], [8.0, 8.0, 3.0, 3.0]
    ]
    @test y_coords(polygon) == expected
end

@testset "translate and rotate" begin
    polygon = Polygon(
        [(0.0, 0.0), (20.0, 0.0), (10.0, 10.0), (0.0, 10.0)],
        [[(1.0, 8.0), (7.0, 8.0), (7.0, 3.0), (1.0, 3.0)]]
    )
    
    poly2 = translate(polygon, (1.0, 2.5))
    expected = Polygon(
        [(1.0, 2.5), (21.0, 2.5), (11.0, 12.5), (1.0, 12.5)],
        [[(2.0, 10.5), (8.0, 10.5), (8.0, 5.5), (2.0, 5.5)]]
    )
    @test poly2 == expected

    poly2 = rotate(polygon, pi/2)
    expected = [
        (0.0, 0.0), (0.0, 20.0), (-10.0, 10.0), (-10.0, 0.0),
        (-8.0, 1.0), (-8.0, 7.0), (-3.0, 7.0), (-3.0, 1.0),
    ]
    points = vcat(poly2.exterior, poly2.holes...)
    @test all([all(isapprox.(p1, p2, atol=1e-6)) for (p1, p2) in zip(points, expected)])

    poly2 = rotate(polygon, pi/2)
    expected = [
        (0.0, 0.0), (0.0, 20.0), (-10.0, 10.0), (-10.0, 0.0),
        (-8.0, 1.0), (-8.0, 7.0), (-3.0, 7.0), (-3.0, 1.0),
    ]
    points = vcat(poly2.exterior, poly2.holes...)
    @test all([all(isapprox.(p1, p2, atol=1e-6)) for (p1, p2) in zip(points, expected)])

    poly2 = rotate(polygon, pi/3, (20.0, 0.0))
    expected = [
        (10.0, -17.320508), (20.0, 0.0), (6.339746, -3.660254), (1.339745, -12.320508),
        (3.571797, -12.454483), (6.571797, -7.2583302), (10.901923, -9.758330), (7.901924, -14.954483),
    ]
    points = vcat(poly2.exterior, poly2.holes...)
    @test all([all(isapprox.(p1, p2, atol=1e-6)) for (p1, p2) in zip(points, expected)])
end


@testset "point in polygon - holes" begin
    polygon = Polygon(
        [(0.0, 0.0), (20.0, 0.0), (10.0, 10.0), (0.0, 10.0)],
        [[(1.0, 3.0), (7.0, 3.0), (7.0, 8.0), (1.0, 8.0)]]
    )
    @test contains(polygon, (10.0, 5.0)) # inside
    @test !contains(polygon, (15.0, 10.0)) # outside
    @test !contains(polygon, (5.0, 5.0)) # in hole
    @test contains(polygon, (5.0, 3.0)) # on hole border
    @test !contains(polygon, (5.0, 3.0); on_border_is_inside=false) # on hole border
end

@testset "polygon in polygon" begin
    exterior = [(0.0, 0.0), (20.0, 0.0), (10.0, 10.0), (0.0, 10.0)]
    hole = [(1.0, 3.0), (7.0, 3.0), (7.0, 8.0), (1.0, 8.0)]
    @test fully_contains(exterior, hole) # inside
    # inside on boundary
    polygon2 = translate(hole, (-1.0, 0.0))
    @test fully_contains(exterior, polygon2)
    # intersects
    polygon2 = translate(hole, (-2.0, 0.0))
    @test !fully_contains(exterior, polygon2)
    # outside on boundary
    polygon2 = translate(hole, (-7.0, 0.0))
    @test !fully_contains(exterior, polygon2)
    polygon2 = [(0.0, 3.0), (0.0, 8.0), (-6.0, 8.0)]
    @test !fully_contains(exterior, polygon2)
    # outside
    polygon2 = translate(hole, (-9.0, 0.0))
    @test !fully_contains(exterior, polygon2)
    # inside near boundary
    polygon2 = translate(hole, (4.999, 0.0))
    @test fully_contains(exterior, polygon2)
    # inside touch boundary
    polygon2 = translate(hole, (5.0, 0.0))
    @test fully_contains(exterior, polygon2)
    # outside intersects
    polygon2 = translate(hole, (9.0, 0.0))
    @test !fully_contains(exterior, polygon2)
    # outside
    polygon2 = translate(hole, (10.0, 10.0))
    @test !fully_contains(exterior, polygon2)
end

@testset "polygon in polygon - edge case" begin
    hour_glass = [(0.0, 0.0), (4.0, 5.0), (0.0, 10.0), (10.0, 10.0), (6.0, 5.0), (10.0, 0.0)]
    rectangle = [(2.0, 1.0),(2.0, 8.0), (8.0, 8.0), (8.0, 1.0)]
    @test all(p -> contains(hour_glass, p), rectangle)
    @test !fully_contains(hour_glass, rectangle)
end


@testset "polygon in polygon - self-intersect" begin
    pentagon = [
        (-0.8, 0.0), (0.0, 0.6), (0.8, 0.0), (0.5, -1.0), (-0.5, -1.0)
    ]
    pentagram = pentagon[[1, 3, 5, 2, 4]]
    # touches vertices
    @test_broken fully_contains(pentagon, pentagram) # cannot handle self-intersecting polygons
    pieces = [ # but after dividing into simple polygons
        [(0.0, -0.615384), (-0.5, -1.0), (-0.306201, -0.379844), (-0.8, 0.0), (-0.1875, 0.0), (-0.1875, 0.0), (-0.306201, -0.379844)],
        [(0.0, 0.6), (0.1875, 0.0), (-0.1875, 0.0)],
        [(0.306201, -0.379845), (0.5, -1.0), (0.0, -0.615384), (0.306201, -0.379845), (0.1875, 0.0), (0.8, 0.0)],
    ]
    @test all(p -> fully_contains(pentagon, p), pieces) 
    pentagram2 = [p .* 0.9 for p in pentagram]
    @test_broken fully_contains(pentagon, pentagram2) # cannot handle self-intersecting polygons
    pieces2 = [[p .* 0.9 for p in piece] for piece in pieces]
    @test all(p -> fully_contains(pentagon, p), pieces2) 
end

@testset "validate polygon" begin
    # single point
    @test_throws "exterior requires at least 3 points" validate_polygon([(1.0, 2.0)])
    @test Polygon([(1.0, 2.0)]) isa Polygon # skips validation checks
    # Validation checks
    exterior = [(0.0, 0.0), (20.0, 0.0), (10.0, 10.0), (0.0, 10.0)]
    holes = [[(1.0, 8.0), (7.0, 8.0), (7.0, 3.0), (1.0, 3.0)]]
    @test validate_polygon(exterior, holes=holes)
    @test_throws "Invalid hole 1: requires at least 3 points." validate_polygon(exterior, holes=[[(1.0, 2.0)]])
    polygon2 = translate(holes[1], (-2.0, 0.0))
    @test_throws "Hole 1 intersects with the exterior." validate_polygon(exterior; holes=[polygon2])
    polygon2 = translate(holes[1], (-10.0, 0.0))
    @test_throws "Hole 1 is outside the polygon." validate_polygon(exterior; holes=[polygon2])
    # worst case: no segments intersect and all points on polygon
    @test_throws "Hole 1 is outside the polygon." validate_polygon(exterior; holes=[exterior])
    # self intersect
    self_intersect = [
        (2.0, 3.0), (4.0, 5.0), (8.0, 1.0), (13.0, 5.0), (13.0, 3.0)
    ]
    @test_throws "Invalid exterior: edges self-intersect." validate_polygon(self_intersect; holes=holes)
    @test_throws "Invalid hole 1: edges self-intersect." validate_polygon(exterior; holes=[self_intersect])
end

end

using PolygonAlgorithms: translate, PointSet
using PolygonAlgorithms: PointSearchAlg, ChasingEdgesAlg, WeilerAthertonAlg, MartinezRuedaAlg

@testset "intersections convex - $alg" for alg in [
    PointSearchAlg(),
    ChasingEdgesAlg(),
    WeilerAthertonAlg(),
    MartinezRuedaAlg(), # Some results are different
]

@testset "one inside the other" begin
    poly1 = [
        (0.0, 0.0), (0.0, 3.0), (3.0, 3.0), (3.0, 0.0)
    ]
    poly2 = [
        (1.0, 1.0), (1.0, 2.0), (2.0, 2.0), (2.0, 1.0)
    ]
    points = intersect_convex(poly1, poly2, alg)
    @test PointSet(points) == PointSet(poly2)
    points = intersect_convex(poly2, poly1, alg)
    @test PointSet(points) == PointSet(poly2)
end

@testset "rectangles" begin
    poly1 = [
        (0.0, 0.0), (0.0, 2.0), (2.0, 2.0), (2.0, 0.0)
    ]
    points = intersect_convex(poly1, poly1, alg)
    @test PointSet(points) == PointSet(poly1)

    # overlap
    poly2 = translate(poly1, (1.0, 1.0))
    expected = [
        (1.0, 1.0), (1.0, 2.0), (2.0, 2.0), (2.0, 1.0), 
    ]
    points = intersect_convex(poly1, poly2, alg)
    @test PointSet(points) == PointSet(expected)

    # no intersection
    poly2 = translate(poly1, (4.0, 3.0))
    expected = []
    points = intersect_convex(poly1, poly2, alg)
    @test isempty(points)
end

@testset "rectangles - edge overlap" begin
    poly1 = [
        (0.0, 0.0), (0.0, 2.0), (2.0, 2.0), (2.0, 0.0)
    ]

    poly2 = translate(poly1, (2.0, 1.0))
    expected = [
        (2.0, 1.0), (2.0, 2.0)
    ]
    points = intersect_convex(poly1, poly2, alg)
    @test PointSet(points) == PointSet(expected)
    points = intersect_convex(poly2, poly1, alg)
    @test PointSet(points) == PointSet(expected)

    poly2 = [
        (2.0, -1.0), (2.0, 3.0), (4.0, 3.0), (4.0, -1.0)
    ]
    expected = [
        (2.0, 0.0), (2.0, 2.0)
    ]
    points = intersect_convex(poly1, poly2, alg)
    @test PointSet(points) == PointSet(expected)
    points = intersect_convex(poly2, poly1, alg)
    @test PointSet(points) == PointSet(expected)

    # edge + vertex overlap
    poly2 = translate(poly1, (1.0, 0.0))
    expected = [
        (1.0, 2.0), (2.0, 2.0), (2.0, 0.0), (1.0, 0.0)
        ]
    points = intersect_convex(poly1, poly2, alg)
    @test PointSet(points) == PointSet(expected)
    points = intersect_convex(poly2, poly1, alg)
    @test PointSet(points) == PointSet(expected)
end

@testset "rectangles - vertex overlap" begin
    poly1 = [
        (0.0, 0.0), (0.0, 2.0), (2.0, 2.0), (2.0, 0.0)
    ]
    # single point of itersection
    poly2 = translate(poly1, (2.0, 2.0))
    expected = (typeof(alg) == PolygonAlgorithms.MartinezRuedaAlg) ?
        Tuple{Float64, Float64}[] : [(2.0, 2.0)]
    points = intersect_convex(poly1, poly2, alg)
    @test PointSet(points) == PointSet(expected)

    points = intersect_convex(poly2, poly1, alg)
    @test PointSet(points) == PointSet(expected)
end

@testset "edge intersect vertex inner" begin 
    poly1 = [
        (0.0, 0.0), (0.0, 3.0), (2.0, 5.0), (5.0, 0.0)
    ]
    poly2 = [
        (0.0, 2.0), (2.0, 3.0), (6.0, 1.0)
    ];
    expected = [
        (0.0, 2.0),
        (3.714286, 2.142857),
        (2.0, 3.0),
        (4.222222, 1.296296),
    ]
    points = intersect_convex(poly1, poly2, alg)
    @test PointSet(points) == PointSet(expected)

    points = intersect_convex(poly2, poly1, alg)
    @test PointSet(points) == PointSet(expected)
end

@testset "edge-vertex pass through" begin 
    poly1 = [
        (0.0, 0.4),
        (0.3, 0.2),
        (0.7, 0.3),
        (0.9, 0.7),
        (0.4, 0.7),
    ]
    poly2 = [
        (0.3, 0.4),
        (0.7, 0.4),
        (0.2, 0.9),
        (0.1, 0.6),
    ];
    expected = [
        (0.3, 0.4),
        (0.4, 0.7),
        (0.171429, 0.528571),
        (0.7, 0.4),
    ]
    points = intersect_convex(poly1, poly2, alg)
    answer = Set([round.(p, digits=6) for p in points])
    @test issetequal(answer, expected)

    points = intersect_convex(poly2, poly1, alg)
    answer = Set([round.(p, digits=6) for p in points])
    @test issetequal(answer, expected)
end

@testset "vertex intersect vertex" begin 
    poly1 = [
        (0.0, 0.0), (0.0, 3.0), (2.0, 5.0), (5.0, 0.0)
    ]
    poly2 = [
        (0.0, 0.0), (2.0, 3.0), (6.0, 1.0)
    ];
    expected = [
        (0.0, 0.0),
        (3.714286, 2.142857),
        (2.0, 3.0),
        (4.545455, 0.757576),
    ]
    points = intersect_convex(poly1, poly2, alg)
    @test PointSet(points) == PointSet(expected)

    points = intersect_convex(poly2, poly1, alg)
    @test PointSet(points) == PointSet(expected)
end

@testset "vertex intersections" begin 
    poly1 = [
        (0.0, 0.0), (0.5, 1.0), (1.0, 0.0)
    ]
    poly2 = [
        (0.0, 1.0), (0.0, 3.0), (1.0, 3.0), (1.0, 1.0)
    ]

    # single point
    expected = (typeof(alg) == PolygonAlgorithms.MartinezRuedaAlg) ?
        Tuple{Float64, Float64}[] : [(0.5, 1.0)]
    points = intersect_convex(poly1, poly2, alg)
    @test PointSet(points) == PointSet(expected)
    points = intersect_convex(poly2, poly1, alg)
    @test PointSet(points) == PointSet(expected)

    # 2 points inside
    poly1_ = translate(poly1, ((0.0), (1.5)))
    expected = poly1_
    points = intersect_convex(poly1_, poly2, alg)
    @test PointSet(points) == PointSet(expected)
    points = intersect_convex(poly2, poly1_, alg)
    @test PointSet(points) == PointSet(expected)

    # 3 points inside
    poly1_ = translate(poly1, ((0.0), (2.0)))
    expected = poly1_
    points = intersect_convex(poly1_, poly2, alg)
    @test PointSet(points) == PointSet(expected)
    points = intersect_convex(poly2, poly1_, alg)
    @test PointSet(points) == PointSet(expected)
end

@testset "quads single vertex intersect" begin 
    poly1 = [
        (1.0, 1.0), (2.0, 4.0), (5.0, 5.0), (4.0, 2.0)
    ]
    poly2 = [
        (4.0, 2.0), (3.0, 4.0), (6.0, 4.0), (7.0, 1.0)
    ]

    expected = [(4.0, 2.0), (3.0, 4.0), (4.666666666666667, 4.0)]
    points = intersect_convex(poly1, poly2, alg)
    @test PointSet(points) == PointSet(expected)
    points = intersect_convex(poly2, poly1, alg)
    @test PointSet(points) == PointSet(expected)
end

@testset "share lines" begin 
    poly1 = [
        (5.0, 8.0), (9.0, 4.0), (1.0, 4.0),
    ]
    poly2 = [
        (5.0, 1.0), (1.0, 4.0), (9.0, 4.0)
    ]
    expected = [(1.0, 4.0), (9.0, 4.0)]
    points = intersect_convex(poly1, poly2, alg)
    @test PointSet(points) == PointSet(expected)
    points = intersect_convex(poly2, poly1, alg)
    @test PointSet(points) == PointSet(expected)

    # shared point
    poly1 = [
        (5.0, 8.0), (9.0, 4.0), (5.0, 4.0), (1.0, 4.0),
    ]
    poly2 = [
        (5.0, 1.0), (1.0, 4.0), (5.0, 4.0), (9.0, 4.0)
    ]
    expected = [(1.0, 4.0), (5.0, 4.0), (9.0, 4.0), (5.0, 4.0),]
    points = intersect_convex(poly1, poly2, alg)
    @test PointSet(points) == PointSet(expected)
    points = intersect_convex(poly2, poly1, alg)
    @test PointSet(points) == PointSet(expected)
end

@testset "cross" begin
    poly1 = [
        (0.0, 0.0), (0.0, 2.0), (1.0, 2.0), (1.0, 0.0)
    ]
    poly2 = [
        (-1.0, 1.5), (2.0, 1.5), (2.0, 0.5), (-1.0, 0.5)
    ]
    expected = [
        (0.0, 1.5), (0.0, 0.5), (1.0, 1.5), (1.0, 0.5)
    ]
    points = intersect_convex(poly1, poly2, alg)
    @test PointSet(points) == PointSet(expected)

    points = intersect_convex(poly2, poly1, alg)
    @test PointSet(points) == PointSet(expected)
end

@testset "star of david" begin
    h = sqrt(3)
    poly1 = translate([
        (-1.0, 0.0), (0.0, h), (1.0, 0.0)
        ], (0.0, -h/3)
    )
    poly2 = translate([
        (-1.0, 0.0), (0.0, -h), (1.0, 0.0)
        ], (0.0, h/3)
    )
    expected = [
        (-2/3, 0.0), (2/3, 0.0), 
        (-1/3, h/3), (+1/3, h/3), 
        (-1/3, -h/3), (+1/3, -h/3), 
    ]
    points = intersect_convex(poly1, poly2, alg)
    @test PointSet(points) == PointSet(expected)

    points = intersect_convex(poly2, poly1, alg)
    @test PointSet(points) == PointSet(expected)
end

@testset "multiple pockets + edge-vertex" begin 
    poly1 = [
        (1.0, 3.0),
        (1.0, 5.5),
        (2.0, 6.0),
        (5.0, 8.0),
        (6.0, 7.0),
        (8.0, 5.5),
        (8.0, 3.0),
        (6.0, 1.0),
    ]
    poly2 = [
        (0.0, 6.0),
        (5.2, 7.5),
        (7.0, 7.5),
        (9.0, 6.0),
        (8.0, 4.0),
        (4.0, 1.0),
    ];
    expected = [
        (4.695652, 1.521739),
        (3.058824, 2.176471),
        (8.0, 4.0),
        (2.0, 6.0),
        (3.525424, 7.016949),
        (5.2, 7.5),
        (5.5, 7.5),
        (8.0, 5.5),
        (1.0, 5.5),
        (6.0, 7.0),
        (1.0, 4.75),
    ]
    points = intersect_convex(poly1, poly2, alg)
    answer = Set([round.(p, digits=6) for p in points])
    @test PointSet(points) == PointSet(expected)

    points = intersect_convex(poly2, poly1, alg)
    answer = Set([round.(p, digits=6) for p in points])
    @test PointSet(points) == PointSet(expected)
end

end

using Plots
using PolygonAlgorithms
using PolygonAlgorithms: x_coords, y_coords

function hilbert_curve(
    point::Tuple{T, T},
    horiz::Tuple{T, T},
    vert::Tuple{T, T},
    level::Int
    ) where T <: AbstractFloat
    # Algorithm from http://www.fundza.com/algorithmic/space_filling/hilbert/basics/
    if level <= 0
        next = ((point[1] + (horiz[1] + vert[1])/2), (point[2] + (horiz[2] + vert[2])/2))
        return [next]
    end
    points = [
        hilbert_curve(point, (horiz[2]/2, vert[2]/2), (horiz[1]/2, vert[1]/2), level-1)...,
        hilbert_curve((point[1] + horiz[1]/2, point[2] + horiz[2]/2), (horiz[1]/2, horiz[2]/2), (vert[1]/2, vert[2]/2), level-1)...,
        hilbert_curve((point[1] + horiz[1]/2+vert[1]/2, point[2] + horiz[2]/2+vert[2]/2), (horiz[1]/2, horiz[2]/2), (vert[1]/2, vert[2]/2), level-1)...,
        hilbert_curve((point[1] + horiz[1]/2+vert[1], point[2] + horiz[2]/2+vert[2]), (-vert[1]/2, -vert[2]/2), (-horiz[1]/2, -horiz[2]/2), level-1)...
    ]
    points
end

function plot_regions!(canvas, regions)
    for region in regions
        if length(region) == 1
            scatter!(canvas, x_coords(region), y_coords(region), color=:black, marker=:xcross, label="")
        else
            idxs = vcat(1:length(region), 1)
            plot!(canvas, x_coords(region[idxs]), y_coords(region[idxs]), fill=(0, 0.4, :green), label="", color=:black)
        end
    end
end

order = 4
points = hilbert_curve((0.0, 0.0), (1.0, 0.0), (0.0, 1.0), order);
tail = points[end]
head = points[1]
## fill inner
push!(points, (-tail[1], tail[2]))
push!(points, (-head[1], head[2]))

poly1 = reverse(points);
poly2 = PolygonAlgorithms.rotate(poly1, π/2.0, (0.5, 0.5))

idxs1 = vcat(1:length(poly1), 1)
idxs2 = vcat(1:length(poly2), 1)
canvas_base = plot(x_coords(poly1[idxs1]), y_coords(poly1[idxs1]), fill=(0, 0.5), aspectratio=:equal, legend=:none)

canvas_both = deepcopy(canvas_base)
plot!(canvas_both, x_coords(poly2[idxs2]), y_coords(poly2[idxs2]), fill=(0, 0.3))

regions_intersect = intersect_geometry(poly1, poly2, PolygonAlgorithms.WeilerAthertonAlg())
canvas_intersect = deepcopy(canvas_both)
plot_regions!(canvas_intersect, regions_intersect)

plot(canvas_base, canvas_both, canvas_intersect,
    layout = (1, 3), 
    xlims=(-0.1, 1.1),
    ylims=(-0.1, 1.1), 
    size=(900, 400)
)

include("boolean/weiler_atherton.jl")
include("boolean/chasing_edges.jl")
include("boolean/martinez_rueda.jl")

abstract type PolygonIntersectionAlgorithm end

"""
    PointSearchAlg()
- Time complexity: `O(nm)` where `n` and `m` vertices on polygon 1 and 2 respectively.
- Should only be used for convex polygons with a single region of intersection.
    Not guaranteed to give correct results.
- Description:
    1. Intersect all edge pairs.
    2. Selected all points in the other polygon.
    3. Sort results counter-clockwise. 
- For general non-intersecting polygons, the intersection points are valid but the order is not.
"""
struct PointSearchAlg <: PolygonIntersectionAlgorithm end

"""
    ChasingEdgesAlg():
- Time complexity: `O(n+m)` where `n` and `m` vertices on polygon 1 and 2 respectively.
- Only gives correct results for convex polygons with one region of intersection.
- Description: this algorithm rotates two pointers, one around each polygon. Each iteration it only
    advances one pointer based on a set of "advance rules". After two cycles around the polygons 
    it is guaranteed to have found all (zero, one or both) intersection points and 
    all the points in between.
- Algorithm is from "A New Linear Algorithm for Intersecting Convex Polygons" (1981) by Joseph O'Rourke et. al.
- Reference: https://www.cs.jhu.edu/~misha/Spring16/ORourke82.pdf
"""
struct ChasingEdgesAlg <: PolygonIntersectionAlgorithm end

"""
    WeilerAthertonAlg()
- Time complexity: `O(nm)` where `n` and `m` vertices on polygon 1 and 2 respectively.
- Returns regions, edges and single points of intersection. Only returns the larger type if one is within another e.g. an edge is also part of a region.
- Description: operates at a point level. Walks from point to point along `polygon2`. 
    It starts recording loops at "entry points" - crossings from `polygon2` to `polygon1` - and 
    stops recording when it gets back to the same entry point. So it continues walking along `polygon2`
    until it reaches the start point.
- Limitations
    1. This version does not cater for holes.
    2. It can fail completely for self-intersecting polygons.
"""
struct WeilerAthertonAlg <: PolygonIntersectionAlgorithm end

"""
    MartinezRuedaAlg()

- Time complexity: `O((n+m+k)log(n+m))` where `n` and `m` vertices on polygon 1 and 2 respectively
    and `k` is the total number of intersections between all segments.
- Returns regions and edges of interest. Does not return single points.
- Works for convex and concave polygons including with holes and self-intersections.
- Description: operates at a segment level and is an extension of the Bentley-Ottman line intersection algorithm.
    - Segments are scanned from left to right, bottom to top. 
    - The key assumption is that only the segments immediately above and below the current segment need to be inspected for intersections.
    This makes the algorithm fast but also sensitive to determining these segments correctly.
    - The segment that is immediately below (or empty space) is used to determine the fill annotations for the current segment.
    - Once all annotations are done, the desired segments can be selected that match a given criteria.
- Limitations:
    1. It can fail for improper polygons: polygons with lines sticking out.
    2. It is sensitive to numeric inaccuracies e.g. a line that is almost vertical or 
    tiny regions of intersection.
"""
struct MartinezRuedaAlg <: PolygonIntersectionAlgorithm end

# General

"""
    intersect_geometry(polygon1::Vector{<:Point2D}, polygon2::Vector{<:Point2D}, alg=MartinezRuedaAlg())

General case of polygon intersection. 

`alg` can either be `MartinezRuedaAlg()` or `WeilerAthertonAlg()`.
There are slight differences in the result depending on the algorithm.
The `WeilerAthertonAlg` tends to be more robust to numeric inaccuracies.

Use `intersect_convex` for convex polygons for an `O(n+m)` algorithm.
"""
intersect_geometry(polygon1::Polygon2D, polygon2::Polygon2D; options...) = 
    intersect_geometry(polygon1, polygon2, MartinezRuedaAlg(); options...)

function intersect_geometry(
    polygon1::Polygon2D, polygon2::Polygon2D, alg::WeilerAthertonAlg
    ; options...
    )
    weiler_atherton_algorithm(polygon1, polygon2; options...)
end

function intersect_geometry(
    polygon1::Polygon2D, polygon2::Polygon2D, alg::MartinezRuedaAlg
    ; options...
    )
    martinez_rueda_algorithm(polygon1, polygon2, INTERSECTION_CRITERIA; options...)
end

"""
    difference_geometry(polygon1::Vector{<:Point2D}, polygon2::Vector{<:Point2D}, alg=MartinezRuedaAlg())

General case of polygon difference: points in `polygon1` that are not in `polygon2`.

`alg` can only be `MartinezRuedaAlg()`.
"""
function difference_geometry(
    polygon1::Polygon2D, polygon2::Polygon2D, alg::MartinezRuedaAlg=MartinezRuedaAlg()
    ; options...
    )
    martinez_rueda_algorithm(polygon1, polygon2, DIFFERENCE_CRITERIA)
end

"""
    union_geometry(polygon1::Vector{<:Point2D}, polygon2::Vector{<:Point2D}, alg=MartinezRuedaAlg())

General case of polygon union: in both polygons. 
Possibly returns holes but does not classify them as holes.

`alg` can only be `MartinezRuedaAlg()`.
"""
function union_geometry(
    polygon1::Polygon2D, polygon2::Polygon2D, alg::MartinezRuedaAlg=MartinezRuedaAlg()
    ; options...
    )
    martinez_rueda_algorithm(polygon1, polygon2, UNION_CRITERIA; options...)
end

"""
    xor_geometry(polygon1::Vector{<:Point2D}, polygon2::Vector{<:Point2D}, alg=MartinezRuedaAlg())

General case of polygon xor: in one polygon or the other but not both.
Possibly returns holes but does not classify them as holes.

`alg` can only be `MartinezRuedaAlg()`.
"""
function xor_geometry(
    polygon1::Polygon2D, polygon2::Polygon2D, alg::MartinezRuedaAlg=MartinezRuedaAlg()
    ; options...
    )
    martinez_rueda_algorithm(polygon1, polygon2, XOR_CRITERIA; options...)
end

#### Convex
"""
    intersect_convex(polygon1::Vector{<:Point2D}, polygon2::Vector{<:Point2D}, alg=ChasingEdgesAlg())

Find the intersection points of convex polygons `polygon1` and `polygon2`.
They are not guaranteed to be unique.

A major assumption is that convex polygons only have one area of intersection.
This fails in the general case with non-convex polygons. 
See `intersect_geometry` for a more general `O(nm)` algorithm.

`alg` can either be `ChasingEdgesAlg()`, `MartinezRuedaAlg()`, `PointSearchAlg()` or `WeilerAthertonAlg()`.
The two general algorithms `MartinezRuedaAlg` and `WeilerAthertonAlg` will throw an error if more
than one area of intersection is found.
"""
intersect_convex(polygon1::Polygon2D, polygon2::Polygon2D; options...) = 
    intersect_convex(polygon1, polygon2, ChasingEdgesAlg(); options...)

function intersect_convex(polygon1::Polygon2D, polygon2::Polygon2D, ::ChasingEdgesAlg; options...)
    chasing_edges_algorithm(polygon1, polygon2; options...)
end

function intersect_convex(
    polygon1::Polygon2D{T}, polygon2::Polygon2D{T}, ::WeilerAthertonAlg
    ; options...
    ) where T
    regions = weiler_atherton_algorithm(polygon1, polygon2; options...)
    if isempty(regions)
        return Point2D{T}[]
    end
    @assert length(regions) == 1 "Convex polygons can only have one region of intersection; $(length(regions)) found"
    regions[1]
end

function intersect_convex(
    polygon1::Polygon2D{T}, polygon2::Polygon2D{T}, ::MartinezRuedaAlg
    ; options...
    ) where T
    regions = martinez_rueda_algorithm(polygon1, polygon2, INTERSECTION_CRITERIA; options...)
    if isempty(regions)
        return Point2D{T}[]
    end
    @assert length(regions) == 1 "Convex polygons can only have one region of intersection; $(length(regions)) found"
    regions[1]
end

function intersect_convex(
    polygon1::Polygon2D, polygon2::Polygon2D, ::PointSearchAlg
    ; atol::AbstractFloat=1e-6
    )
    #https://www.swtestacademy.com/intersection-convex-polygons-algorithm/
    intersection_points = intersect_edges(polygon1, polygon2; atol=atol)
    
    i1_in_2 = [contains(polygon2, p) for p in polygon1]
    p1_in_2 = polygon1[i1_in_2]
    i2_in_1 = [contains(polygon1, p) for p in polygon2]
    p2_in_1 = polygon2[i2_in_1]

    if isempty(intersection_points) && isempty(p1_in_2) && isempty(p2_in_1)
        return intersection_points
    end

    points = vcat(intersection_points, p1_in_2, p2_in_1)
    points = sort_counter_clockwise(points)
    points
end

@testset "area-centroids" begin

@testset "area rectangle" begin
    h, w = 2.0, 3.0
    poly = [
        (0.0, 0.0), (0.0, h), (w, h), (w, 0.0)
    ]
    area = area_polygon(poly)
    expected = h * w
    @test area == expected

    centroid = centroid_polygon(poly)
    expected = (w/2, h/2)
    @test centroid == expected
end;

@testset "area triangle" begin
    h, b1, b2 = 3.0, 2.0, 1.5
    b = b1 + b2
    poly = [
        (0.0, 0.0), (b1, h), (b, 0.0)
    ]
    area = area_polygon(poly)
    expected = 0.5 * h * b
    @test area == expected

    centroid = centroid_polygon(poly)
    expected = ((b1 + b)/3, h/3)
    @test centroid == expected
end;

@testset "area H" begin
    poly = [
        (2.0, 10.0), (4.0, 10.0), (4.0, 6.0), (6.0, 6.0), (6.0, 10.0), (8.0, 10.0), 
        (8.0, 1.0), (6.0, 1.0), (6.0, 4.0), (4.0, 4.0), (4.0, 1.0), (2.0, 1.0)
    ]
    area = area_polygon(poly)
    expected = 2 * 9 + 2 * 2 + 2 * 9
    @test area == expected

    centroid = centroid_polygon(poly)
    expected = (5.0, 5.45)
    @test centroid == expected
end;

end

using Plots
using PolygonAlgorithms
using PolygonAlgorithms: Polygon, x_coords, y_coords

function plot_polygons!(canvas, polygons::AbstractVector{<:Polygon}; options...)
    for polygon in polygons
        if length(polygon.exterior) == 1
            scatter!(canvas, x_coords(polygon.exterior), y_coords(polygon.exterior), marker=:xcross, label="")
        else 
            plot_polygon!(canvas, polygon; label="", options...)
        end
    end
    canvas
end

function plot_polygon!(canvas, polygon::Polygon; options...)
    region = polygon.exterior
    idxs = vcat(1:length(region), 1)
    plot!(canvas, x_coords(region[idxs]), y_coords(region[idxs]); fill=(0, 0.5, :green), color=:black, options...)
    for hole in polygon.holes
        idxs = vcat(1:length(hole), 1)
        plot!(canvas, x_coords(hole[idxs]), y_coords(hole[idxs]); fill=(0, 0.7, :grey70), color=:black, label="")
    end
    canvas
end

θs = 0.0:0.01:6π
rs = θs
spiral = [(r * cos(θ), r * sin(θ)) for (r, θ) in zip(rs, θs)] 
spiral = vcat(spiral, reverse([0.8 .* p for p in spiral[3:end]]))
star = [
    (0.0, 18.0), (3.0, 5.0), (15.0, 5.0), (5.0, 0.0), (10.0, -12.0), (0.0, -2.0),
    (-10.0, -12.0), (-5.0, 0.0), (-15.0, 5.0), (-3.0, 5.0)
]
polygon1 = Polygon(spiral)
polygon2 = Polygon(star)

colors = palette(:default)
canvas_base = plot_polygon!(plot(), polygon1, aspectratio=:equal, xlabel="base", legend=:none, fill=(0, 0.5), color=colors[1])
plot_polygon!(canvas_base, polygon2; fill=(0, 0.5), color=colors[2])

regions_difference12 = difference_geometry(polygon1, polygon2);
regions_difference21 = difference_geometry(polygon2, polygon1);
regions_intersect = intersect_geometry(polygon1, polygon2);
regions_union = union_geometry(polygon1, polygon2);
regions_xor = xor_geometry(polygon1, polygon2);

canvas_difference12 = plot_polygons!(
    plot(aspectratio=:equal, xlabel="difference 1-2", xlims=xlims(canvas_base), ylims=ylims(canvas_base)),
    regions_difference12
)
canvas_difference21 = plot_polygons!(
    plot(aspectratio=:equal, xlabel="difference 2-1", xlims=xlims(canvas_base), ylims=ylims(canvas_base)),
    regions_difference21
)
canvas_intersect = deepcopy(canvas_base)
plot!(canvas_intersect, xlabel="intersection", xlims=xlims(canvas_base), ylims=ylims(canvas_base))
plot_polygons!(canvas_intersect, regions_intersect)
canvas_union = plot_polygons!(
    plot(aspectratio=:equal, xlabel="union", xlims=xlims(canvas_base), ylims=ylims(canvas_base)),
    regions_union
)
canvas_xor = plot_polygons!(
    plot(aspectratio=:equal, xlabel="xor", xlims=xlims(canvas_base), ylims=ylims(canvas_base)),
    regions_xor
)

plot(canvas_base, canvas_difference12, canvas_difference21, canvas_intersect, canvas_union, canvas_xor,
    layout = (2, 3), 
    size=(900, 600),
    margin=5Plots.mm,
)
plot!()

#############################################################
##                  Initialise Events                      ##
#############################################################

function convert_to_event_queue(
    polygon::Path2D{T}; options...
    ) where T
    # The event list reads all segments from left to right, end to start, bottom to top
    convert_to_event_queue!(SegmentEvent{T}[], polygon; options...)
end

function convert_to_event_queue!(
    queue::Vector{<:SegmentEvent}, polygon::Path2D;
    primary::Bool=true, atol::AbstractFloat=default_atol
    )
    pt2 = polygon[end]
    for i in eachindex(polygon)
        pt1 = pt2
        pt2 = polygon[i]
        forward = _compare_points(pt1, pt2; atol=atol)
        if forward == 0
            continue # zero length segment
        end
        start = forward < 0 ? pt1 : pt2
        end_ = forward < 0 ? pt2 : pt1
        segment = (start, end_)
        add_segment_event!(queue, segment, primary)
    end
    queue
end

function add_segment_event!(
    queue::Vector{<:SegmentEvent},
    segment::Segment2D,
    primary::Bool,
    shared_self_annotations::SegmentAnnotations=SegmentAnnotations(),
    shared_other_annotations::SegmentAnnotations=SegmentAnnotations(),
    )
    start_event = SegmentEvent(segment, true, primary, shared_self_annotations, shared_other_annotations)
    end_event = SegmentEvent(segment, false, primary, shared_self_annotations, shared_other_annotations)
    start_event.other = end_event
    end_event.other = start_event   
    insert_in_order!(queue, start_event; lt=compare_events)
    insert_in_order!(queue, end_event; lt=compare_events)
end

"""
    _compare_points(pt1, pt2; atol=default_atol)
Return:
- -1 if pt1 is smaller
- 0 if the same
- 1 if pt2 is smaller
"""
function _compare_points(pt1::Point2D{T}, pt2::Point2D{T}; atol::AbstractFloat=default_atol) where T # pointsCompare
    if abs(pt1[1] - pt2[1]) < atol # on a vertical line
        if abs(pt1[2] - pt2[2]) < atol # same point
            return 0
        end
        return pt1[2] < pt2[2] ? -1 : 1; # compare Y values
    end
    return pt1[1] < pt2[1] ? -1 : 1; # compare X values
end

"""
    compare_events(event, here)

Smaller events are to the left or bottom. Otherwise, end events come before the start.
Returns true if smaller.
"""
function compare_events(event::SegmentEvent, here::SegmentEvent; atol::AbstractFloat=default_atol) # eventCompare
    # Assumes events are left to right
    comp = _compare_points(event.point, here.point)
    if comp != 0
        return comp < 0
    end
    # Selected points are the same -> events on top of each other.
    comp = _compare_points(event.other_point, here.other_point)
    if comp === 0
        return false # equal segments
    end
    # Two events on top of each other.
    if event.is_start != here.is_start
        # favor the one that isn't the start
        return event.is_start ? false : true
    end
    # share a common start point ⋅< or a common end point >⋅
    # Manually calculate if the other point is above
    if abs(here.segment[1][1] - here.segment[2][1]) < atol # vertical
        # projecting the point won't work.
        # instead, assume smaller segment leans towards the right
        return event.other_point[1] > here.segment[1][1]
    end
    is_above_or_on(event.other_point, here.segment; atol=atol) ? false : true
end

#############################################################
##                  Above                                  ##
#############################################################

"""
    is_above(event, other, [atol])


!!!!! Critical function. May be source of errors that only emerge later.

Return `true` if `event` is strictly above `other`.

A segment is considered above another if:
    1. It is to the left of the other segment.
    2. And the start point of the other segment is orientated clockwise from it.
Or symmetrically:
    1. It is in line or to the right of the other segment.
    2. And its start point is orientated counter-clockwise from the other segment.

Assumes segments always go left to right.
"""
function is_above(
    ev::SegmentEvent, other::SegmentEvent
    ; atol::AbstractFloat=default_atol
    ) # statusCompare
    seg1 = ev.segment
    seg2 = other.segment
    if (seg1[1][1] < seg2[1][1])
        orient = get_orientation(seg1[1], seg1[2], seg2[1]; atol=atol)
        if orient == COLINEAR
            orient = get_orientation(seg1[1], seg1[2], seg2[2]; atol=atol)
        end
        return orient == CLOCKWISE
    else
        orient = get_orientation(seg2[1], seg2[2], seg1[1]; atol=atol)
        if orient == COLINEAR
            orient = get_orientation(seg2[1], seg2[2], seg1[2]; atol=atol)
        end
        return orient == COUNTER_CLOCKWISE
    end
end

function find_transition(
    list::Vector{<:SegmentEvent}, event::SegmentEvent
    ; atol::AbstractFloat=default_atol
    )
    searchsortedfirst(list, event; lt=(x, y) -> is_above(x, y; atol=atol))
end

function is_vertex_intersection(segment1::Segment2D, segment2::Segment2D; atol::AbstractFloat=default_atol)
    on_segment(segment1[1], segment2; atol=atol) || 
        on_segment(segment1[2], segment2; atol=atol) ||
        on_segment(segment2[1], segment1; atol=atol) ||
        on_segment(segment2[2], segment1; atol=atol)
end

#############################################################
##                  Line Sweep                             ##
#############################################################

"""
    any_intersect(segment::Segment2D, ...; atol=default_atol, include_vertices=true)
    any_intersect(queue::Vector{SegmentEvent}}; atol=default_atol, include_vertices=true)

A line sweep algorithm for determining if any segment intersects with any other segment.

Shamos-Hoey algorithm. It runs in `O(n*log(n))` time where `n` is the length of the segments.

Reference:
- http://euro.ecom.cmu.edu/people/faculty/mshamos/1976GeometricIntersection.pdf
"""
function any_intersect(
    queue::Vector{SegmentEvent{T}}
    ; atol::AbstractFloat=default_atol, include_vertices::Bool=true
    ) where T
    sweep_status = SegmentEvent{T}[] # current events in a vertical line, top to bottom.
    for head in queue
        queue_length = length(queue)
        status_length = length(sweep_status)
        @debug("[do_intersect] ($(queue_length), $(status_length)): $(head)")
        if head.is_start # then check for intersections and add to sweep status
            idx = find_transition(sweep_status, head; atol=atol)
            above = idx == 1 ? nothing : sweep_status[idx - 1]
            below = (idx > length(sweep_status)) ? nothing : sweep_status[idx]
            @debug("[event_loop!] transition idx=$idx")
            @debug("[event_loop!] above=$above")
            @debug("[event_loop!] below=$below")
            if !isnothing(above) && do_intersect(head.segment, above.segment; atol=atol) &&
                (include_vertices || !is_vertex_intersection(head.segment, above.segment; atol=atol))
                return true
            elseif !isnothing(below) && do_intersect(head.segment, below.segment; atol=atol) &&
                (include_vertices || !is_vertex_intersection(head.segment, below.segment; atol=atol))
                return true
            end
            insert!(sweep_status, idx, head)
        else # event is ending, so remove it from the status
            idx = find_transition(sweep_status, head.other; atol=atol)
            if !(0 < idx <= length(sweep_status) && sweep_status[idx] === head.other)
                @warn "$(head.other) was not in the expected location in the sweep status. " * 
                    "Falling back to linear search. Results might not be reliable."
                idx = findfirst(x -> x === head.other, sweep_status)
                @assert(
                    !isnothing(idx),
                    "$(head.other) is missing from the sweep_status. The start event should always be processed before the end event."
                )
            end
            if (idx != 1) && (idx != length(sweep_status))
                # there will be 2 new adjacent edges, so check the intersection between them
                above = sweep_status[idx - 1]
                below = sweep_status[idx + 1]
                if do_intersect(above.segment, below.segment; atol=atol) && 
                    (include_vertices || !is_vertex_intersection(above.segment, below.segment; atol=atol))
                    return true
                end
            end
            popat!(sweep_status, idx)
        end
    end
    false
end

function any_intersect(segments::Vararg{Segment2D{T}}; atol::AbstractFloat=default_atol, options...) where T
    queue = SegmentEvent{T}[]
    for segment in segments
        forward = _compare_points(segment[1], segment[2]; atol=atol)
        segment_ = forward < 0 ? (segment[1], segment[2]) : (segment[2], segment[1])
        add_segment_event!(queue, segment_, true)
    end
    any_intersect(queue; atol=atol, options...)
end

import Base: length, show, isempty, iterate, KeySet, union!, push!, show_vector, in, Set

"""
    PointSet([itr]; digits=6)

A specialised set based off `Base.Set`. It is used to compensate for minor numeric errors.
Each co-ordinate of the point is rounded to `digits` decimal places before being inserted in the set.
Likewise, the `in` operation rounds points before checking if they are in the set.
It also treats `-0.0` and `0.0` as equivalent unlike `Set([-0.0]) != Set([0.0])`.

For example:
```
s = PointSet([(1e-7, 0.0), (1.0, π)])
(0.0, 0.0) in s # true
(1.0, 3.141593) in s # true
(-0.0, -0.0) in s # true
```
"""
struct PointSet{T} <: AbstractSet{T}
    dict::Dict{Tuple{T, T},Nothing}
    digits::Int
    function PointSet(dict::Dict{Tuple{T, T},Nothing}, digits) where T
        point_set = new{T}(dict, digits)
        return point_set
    end
end

PointSet(;digits::Int=6) = PointSet(Dict{Tuple{Float64, Float64},Nothing}(), digits)
PointSet(itr::AbstractVector{<:Tuple}; digits::Int=6) = union!(PointSet(digits=digits), itr)
isempty(s::PointSet) = isempty(s.dict)
length(s::PointSet)  = length(s.dict)
iterate(s::PointSet, i...)  = iterate(KeySet(s.dict), i...)
in(x, s::PointSet) = haskey(s.dict, fudge(x, s.digits))

Set(s::PointSet) = Set(KeySet(s.dict))
PointSet(s::Set{T}) where T = PointSet(collect(KeySet(s.dict)))

function union!(s::PointSet, itr)
    for x in itr
        push!(s, x)
    end
    return s
end

function push!(s::PointSet, x::Tuple)
    s.dict[fudge(x, s.digits)] = nothing
    s
end

function fudge(point::Tuple, digits::Int)
    point = round.(point, digits=digits)
    if (point[1] == -0 || point[2] == -0)
        x, y = point
        point = (x == -0 ? zero(x) : x, y == -0 ? zero(y) : y)
    end
    point
end

function show(io::IO, s::PointSet)
    if isempty(s)
        show(io, typeof(s))
        print(io, "(digits=$(s.digits),)")
    else
        print(io, typeof(s), "(")
        print(io, "digits=$(s.digits),")
        show_vector(io, s)
        print(io, ')')
    end
end

using Test
using PolygonAlgorithms: SegmentEvent, SegmentAnnotations
using PolygonAlgorithms: add_annotated_segment!, compare_events, convert_to_event_queue
using PolygonAlgorithms: check_and_divide_intersection!, event_loop!, find_transition
using PolygonAlgorithms: chain_segments
using PolygonAlgorithms: BLANK

@testset "Martinez-Rueda algorithm" verbose=true begin

    @testset "queueing" begin
        @testset "rectangle" begin
            rectangle = [
                (3.0, 3.0), (7.0, -1.0), (4.0, -4.0), (0.0, 0.0)
            ]
            event_queue = convert_to_event_queue(rectangle)
            expected = [
                SegmentEvent(((0.0, 0.0), (4.0, -4.0)), true),
                SegmentEvent(((0.0, 0.0), (3.0, 3.0)), true),
                SegmentEvent(((0.0, 0.0), (3.0, 3.0)), false),
                SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true),
                SegmentEvent(((0.0, 0.0), (4.0, -4.0)), false),
                SegmentEvent(((4.0, -4.0), (7.0, -1.0)), true),
                SegmentEvent(((4.0, -4.0), (7.0, -1.0)), false),
                SegmentEvent(((3.0, 3.0), (7.0, -1.0)), false),
            ]
            @test event_queue == expected
        end

        @testset "vertical line" begin
            triangle = [
                (3.0, 3.0), (3.0, -4.0), (0.0, 0.0)
            ]
            event_queue = convert_to_event_queue(triangle)
            expected = [
                SegmentEvent(((0.0, 0.0), (3.0, -4.0)), true),
                SegmentEvent(((0.0, 0.0), (3.0, 3.0)), true),
                SegmentEvent(((0.0, 0.0), (3.0, -4.0)), false),
                SegmentEvent(((3.0, -4.0), (3.0, 3.0)), true),
                SegmentEvent(((3.0, -4.0), (3.0, 3.0)), false),
                SegmentEvent(((0.0, 0.0), (3.0, 3.0)), false),        
            ]
            @test event_queue == expected

            lowered_triangle = [
                (3.0, 3.0), (3.0, -4.0), (0.0, -5.0)
            ]
            event_queue = convert_to_event_queue(lowered_triangle)
            expected = [
                SegmentEvent(((0.0, -5.0), (3.0, -4.0)), true),
                SegmentEvent(((0.0, -5.0), (3.0, 3.0)), true),
                SegmentEvent(((0.0, -5.0), (3.0, -4.0)), false),
                SegmentEvent(((3.0, -4.0), (3.0, 3.0)), true),
                SegmentEvent(((3.0, -4.0), (3.0, 3.0)), false),
                SegmentEvent(((0.0, -5.0), (3.0, 3.0)), false),        
            ]
            @test event_queue == expected

            mirror_triangle = [
                (0.0, -4.0), (0.0, 3.0), (3.0, -5.0)
            ]
            event_queue = convert_to_event_queue(mirror_triangle)
            expected = [
                SegmentEvent(((0.0, -4.0), (3.0, -5.0)), true),   
                SegmentEvent(((0.0, -4.0), (0.0, 3.0)), true),    
                SegmentEvent(((0.0, -4.0), (0.0, 3.0)), false),   
                SegmentEvent(((0.0, 3.0), (3.0, -5.0)), true),
                SegmentEvent(((0.0, -4.0), (3.0, -5.0)), false),  
                SegmentEvent(((0.0, 3.0), (3.0, -5.0)), false),        
            ]
            @test event_queue == expected
        end

        @testset "almost vertical" begin
            # the original segment was ((0.5345889348336309, 0.9626445530693036), (0.5346819812512368, 0.7153822809806809))
            # it was not vertical, but the two intersecting lines make a tiny vertical segment
            event_queue = [
                SegmentEvent(((0.5346362515873916, 0.8369046444971744), (0.5346819812512368, 0.7153822809806809)), true),
                SegmentEvent(((0.5346362515873916, 0.8369046444971744), (0.702057739662388, 0.63591526606886130)), true),
                SegmentEvent(((0.5346358170779485, 0.8380593132624886), (0.5346362515873916, 0.8369046444971744)), true),
                SegmentEvent(((0.5346358170779485, 0.8380593132624886), (0.6336845198791616, 0.7251516629897194)), true),
            ]
            # the event_loop! modified event_queue[3] with update_end!
            # now, the tail should be inserted after it.
            tail = SegmentEvent(event_queue[3].segment, false)
            idx = searchsortedfirst(event_queue, tail; lt=compare_events)
            @test_broken idx == 5
        end
    end

    @testset "find_transitions" begin
        @testset "horizontal lines" begin
            # setup
            status = [
                SegmentEvent(((0.0, 5.0), (5.0, 5.0)), true),
                SegmentEvent(((0.0, 3.0), (5.0, 3.0)), true),
                SegmentEvent(((0.0, 1.0), (5.0, 1.0)), true),
            ]
            # test
            ev6 = SegmentEvent(((0.0, 6.0), (5.0, 6.0)), true)
            idx = find_transition(status, ev6)
            @test idx == 1
            ev34 = SegmentEvent(((0.0, 3.0), (5.0, 4.0)), true)
            idx = find_transition(status, ev34)
            @test idx == 2
            ev32 = SegmentEvent(((0.0, 3.0), (5.0, 2.0)), true)
            idx = find_transition(status, ev32)
            @test idx == 3
            ev2 = SegmentEvent(((0.0, 2.0), (5.0, 2.0)), true)
            idx = find_transition(status, ev2)
            @test idx == 3
            ev0 = SegmentEvent(((0.0, 0.0), (5.0, 0.0)), true)
            idx = find_transition(status, ev0)
            @test idx == 4
        end

        @testset "sweep status head" begin
            # setup
            status = [SegmentEvent(((0.0, 5.0), (5.0, 5.0)), true)]
            # test
            ev6 = SegmentEvent(((0.0, 6.0), (5.0, 6.0)), true)
            idx = find_transition(status, ev6)
            @test idx == 1
            ev2 = SegmentEvent(((0.0, 2.0), (5.0, 2.0)), true)
            idx = find_transition(status, ev2)
            @test idx == 2
        end

        @testset "size discrepancy" begin
            # from spiral-star example. 
            status = [
                SegmentEvent(((-10.0, -12.0), (0.0, -2.0)), true) # star leg
            ]
            # test
            ev = SegmentEvent(((-8.338, -10.337), (-8.239, -10.426)), true) # tiny segment of spiral
            idx = find_transition(status, ev)
            @test idx == 1
        end
    end

    @testset "order sweep status" begin
        @testset "sweep status rand lines" begin
            # lines originally from the intersection of two randomly generated spiky polygon
            segments = [
                SegmentEvent(((0.5824, 0.5157), (0.9235, 0.39180)), true)
                SegmentEvent(((0.5824, 0.5157), (0.9756, 0.3288)), true)
                SegmentEvent(((0.5732, 0.7060), (0.7169, 0.6187)), true)
                SegmentEvent(((0.5658, 0.6475), (0.6321, 0.6197)), true)
                SegmentEvent(((0.5658, 0.6475), (0.7169, 0.6187)), true)
                SegmentEvent(((0.5480, 0.9443), (0.7438, 0.6878)), true)
                SegmentEvent(((0.5480, 0.9443), (0.7455, 0.8477)), true)
                SegmentEvent(((0.5334, 0.9450), (0.7438, 0.6878)), true)
                SegmentEvent(((0.5218, 0.2095), (0.5839, 0.1114)), true)
                SegmentEvent(((0.5122, 0.9013), (0.6366, 0.9417)), true)
                SegmentEvent(((0.4867, 0.5998), (0.6095, 0.6079)), true)
                SegmentEvent(((0.4771, 0.4543), (0.5913, 0.4110)), true)
                SegmentEvent(((0.4767, 0.5368), (0.6615, 0.5250)), true)
                SegmentEvent(((0.4544, 0.0837), (0.6762, 0.4073)), true)
                SegmentEvent(((0.4544, 0.0837), (0.7364, 0.3326)), true)
                SegmentEvent(((0.4127, 0.4774), (0.6615, 0.5250)), true)
            ]
            sweep_status = SegmentEvent{Float64}[]
            for event in segments
                idx = find_transition(sweep_status, event)
                insert!(sweep_status, idx, event)
            end
            expected = [
                SegmentEvent(((0.5480, 0.9443), (0.7455, 0.8477)), true),
                SegmentEvent(((0.5480, 0.9443), (0.7438, 0.6878)), true),
                SegmentEvent(((0.5334, 0.9450), (0.7438, 0.6878)), true),
                SegmentEvent(((0.5122, 0.9013), (0.6366, 0.9417)), true),
                SegmentEvent(((0.5732, 0.7060), (0.7169, 0.6187)), true),
                SegmentEvent(((0.5658, 0.6475), (0.7169, 0.6187)), true),
                SegmentEvent(((0.5658, 0.6475), (0.6321, 0.6197)), true),
                SegmentEvent(((0.4867, 0.5998), (0.6095, 0.6079)), true),
                SegmentEvent(((0.4767, 0.5368), (0.6615, 0.525)), true),
                SegmentEvent(((0.5824, 0.5157), (0.9235, 0.3918)), true),
                SegmentEvent(((0.5824, 0.5157), (0.9756, 0.3288)), true),
                SegmentEvent(((0.4127, 0.4774), (0.6615, 0.525)), true),
                SegmentEvent(((0.4771, 0.4543), (0.5913, 0.411)), true),
                SegmentEvent(((0.5218, 0.2095), (0.5839, 0.1114)), true),
                SegmentEvent(((0.4544, 0.0837), (0.6762, 0.4073)), true),
                SegmentEvent(((0.4544, 0.0837), (0.7364, 0.3326)), true),
            ]
            @test sweep_status == expected
        end

        @testset "sweep status rand lines 2" begin
            segments = [
                SegmentEvent(((0.01190, 0.9843), (0.2696, 0.7221)), true),
                SegmentEvent(((0.02439, 0.6210), (0.1274, 0.6140)), true),
                SegmentEvent(((0.01190, 0.9843), (0.1166, 0.9564)), true),
                SegmentEvent(((0.02706, 0.3861), (0.0599, 0.4676)), true),
                SegmentEvent(((0.00284, 0.3700), (0.0727, 0.1129)), true),
                SegmentEvent(((0.02201, 0.5214), (0.3929, 0.5001)), true),
            ]
            sweep_status = SegmentEvent{Float64}[]
            for event in segments
                idx = find_transition(sweep_status, event)
                insert!(sweep_status, idx, event)
            end
            expected =[
                SegmentEvent(((0.0119, 0.9843), (0.1166, 0.9564)), true),
                SegmentEvent(((0.0119, 0.9843), (0.2696, 0.7221)), true),
                SegmentEvent(((0.02439, 0.621), (0.1274, 0.614)), true),
                SegmentEvent(((0.02201, 0.5214), (0.3929, 0.5001)), true),
                SegmentEvent(((0.02706, 0.3861), (0.0599, 0.4676)), true),
                SegmentEvent(((0.00284, 0.37), (0.0727, 0.1129)), true),
            ]
            @test sweep_status == expected
        end

        @testset "sweep status almost colinear" begin
            sweep_status =[
                SegmentEvent(((0.7481773880710287, 0.2525213105681051), (0.891378804016348, 0.0914800094089202)), true),
                SegmentEvent(((0.7674956225378292, 0.19603318345420395), (0.93007516434479, 0.04850368886951295)), true),
                SegmentEvent(((0.7307442328548945, 0.22237367849003833), (0.879152990839225, 0.03969376626137666)), true),
                SegmentEvent(((0.7456555133038324, 0.17560361123176102), (0.879152990839225, 0.03969376626137666)), true)
            ]
            ev = SegmentEvent(((0.7692174020749689, 0.1749860342238233), (0.8076322984621129, 0.25945610393589347)), true)
            # with rtol=1e-3, this is linear
            idx = find_transition(sweep_status, ev)
            @test idx == 4
        end

        @testset "sweep status steps" begin
            # lines originally from the intersection of two randomly generated spiky polygon
            segments = [
                SegmentEvent(((0.0, 4.0), (3.0, 4.0)), true),
                SegmentEvent(((0.0, 2.0), (3.0, 2.0)), true),
                SegmentEvent(((3.0, 2.0), (3.0, -2.0)), true),
                SegmentEvent(((3.0, -2.0), (6.0, -2.0)), true),
                SegmentEvent(((3.0, -4.0), (6.0, -4.0)), true),
            ]
            sweep_status = SegmentEvent{Float64}[]
            for event in segments
                idx = find_transition(sweep_status, event)
                insert!(sweep_status, idx, event)
            end
            expected = [
                SegmentEvent(((0.0, 4.0), (3.0, 4.0)), true),
                SegmentEvent(((0.0, 2.0), (3.0, 2.0)), true),
                SegmentEvent(((3.0, 2.0), (3.0, -2.0)), true),
                SegmentEvent(((3.0, -2.0), (6.0, -2.0)), true),
                SegmentEvent(((3.0, -4.0), (6.0, -4.0)), true),
            ]
            @test sweep_status == expected
        end
    end

    @testset "divide" begin
        @testset "divide no intersection" begin
            # setup
            ev1_start = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true)
            ev1_end = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), false)
            ev1_start.other = ev1_end
            ev1_end.other = ev1_start
            ev2_start = SegmentEvent(((4.0, 5.0), (8.0, 3.0)), true)
            ev2_end = SegmentEvent(((4.0, 5.0), (8.0, 3.0)), false)
            ev2_start.other = ev2_end
            ev2_end.other = ev2_start
            queue = [ev1_start, ev2_start, ev1_end, ev2_end]
            # test
            check_and_divide_intersection!(queue, ev1_start, ev2_start, false)
            @test length(queue) == 4
        end

        @testset "divide intersection" begin
            # setup
            ev1_start = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true)
            ev1_end = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), false)
            ev1_start.other = ev1_end
            ev1_end.other = ev1_start
            ev2_start = SegmentEvent(((4.0, 0.0), (7.0, 3.0)), true)
            ev2_end = SegmentEvent(((4.0, 0.0), (7.0, 3.0)), false)
            ev2_start.other = ev2_end
            ev2_end.other = ev2_start
            queue = [ev1_start, ev2_start, ev1_end, ev2_end]
            # test
            check_and_divide_intersection!(queue, ev1_start, ev2_start, false)
            expected = [
                ev1_start,
                ev2_start,
                ev2_end,
                ev1_end,
                SegmentEvent(((5.0, 1.0), (7.0, -1.0)), true),
                SegmentEvent(((5.0, 1.0), (7.0, 3.0)), true),
                SegmentEvent(((5.0, 1.0), (7.0, -1.0)), false),
                SegmentEvent(((5.0, 1.0), (7.0, 3.0)), false),
            ]
            @test queue == expected
        end

        @testset "divide along1" begin
            # setup
            ev1_start = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true)
            ev1_end = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), false)
            ev1_start.other = ev1_end
            ev1_end.other = ev1_start
            ev2_start = SegmentEvent(((4.0, 2.0), (7.0, 5.0)), true)
            ev2_end = SegmentEvent(((4.0, 2.0), (7.0, 5.0)), false)
            ev2_start.other = ev2_end
            ev2_end.other = ev2_start
            queue = [ev1_start, ev2_start, ev1_end, ev2_end]
            # test
            check_and_divide_intersection!(queue, ev1_start, ev2_start, false)
            expected = [
                ev1_start,
                ev1_end,
                SegmentEvent(((4.0, 2.0), (7.0, -1.0)), true), 
                ev2_start,
                SegmentEvent(((4.0, 2.0), (7.0, -1.0)), false), 
                ev2_end
            ]
            @test queue == expected
        end

        @testset "divide coincident" begin
            # setup
            ev1_start = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), true)
            ev1_end = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), false)
            ev1_start.other = ev1_end
            ev1_end.other = ev1_start
            ev2_start = SegmentEvent(((4.0, 2.0), (7.0, -1.0)), true)
            ev2_end = SegmentEvent(((4.0, 2.0), (7.0, -1.0)), false)
            ev2_start.other = ev2_end
            ev2_end.other = ev2_start
            queue = [ev1_start, ev2_start, ev1_end, ev2_end]
            # test
            check_and_divide_intersection!(queue, ev1_start, ev2_start, false)
            @test length(queue) == 4 # no change because ev1 is processed before ev2
            check_and_divide_intersection!(queue, ev2_start, ev1_start, false)
            expected = [
                ev1_start,
                ev1_end,
                SegmentEvent(((4.0, 2.0), (5.0, 1.0)), true),
                ev2_start,
                SegmentEvent(((4.0, 2.0), (5.0, 1.0)), false),
                ev2_end,
                SegmentEvent(((5.0, 1.0), (7.0, -1.0)), true),
                SegmentEvent(((5.0, 1.0), (7.0, -1.0)), false),
            ]
            @test queue == expected
        end

        @testset "divide coincident same start" begin
            # setup
            ev1_start = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), true)
            ev1_end = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), false)
            ev1_start.other = ev1_end
            ev1_end.other = ev1_start
            primary = true
            self_annotations = SegmentAnnotations(true, false)
            ev2_start = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true, primary, self_annotations)
            ev2_end = SegmentEvent(((3.0, 3.0), (7.0, -1.0)), false, primary, self_annotations)
            ev2_start.other = ev2_end
            ev2_end.other = ev2_start
            queue = [ev1_start, ev2_start, ev1_end, ev2_end]
            # test
            check_and_divide_intersection!(queue, ev1_start, ev2_start, true)
            expected = [
                ev2_start,
                ev2_end,
                SegmentEvent(((5.0, 1.0), (7.0, -1.0)), true, true, self_annotations),
                SegmentEvent(((5.0, 1.0), (7.0, -1.0)), false, true, self_annotations),
            ]
            @test queue == expected
        end

        @testset "divide same intersection" begin
            # setup
            ev1_start = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), true)
            ev1_end = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), false)
            ev1_start.other = ev1_end
            ev1_end.other = ev1_start
            primary = true
            self_annotations = SegmentAnnotations(true, false)
            ev2_start = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), true, primary, self_annotations)
            ev2_end = SegmentEvent(((3.0, 3.0), (5.0, 1.0)), false, primary, self_annotations)
            ev2_start.other = ev2_end
            ev2_end.other = ev2_start
            queue = [ev1_start, ev2_start, ev1_end, ev2_end]
            # test
            check_and_divide_intersection!(queue, ev1_start, ev2_start, true)
            @test queue == [ev2_start, ev2_end]
        end
    end

    @testset "annotations" begin
        @testset "rectangle self annotations" begin
            rectangle = [
                (3.0, 3.0), (7.0, -1.0), (4.0, -4.0), (0.0, 0.0)
            ];
            event_queue = convert_to_event_queue(rectangle)
            annotated_segments = event_loop!(event_queue; self_intersection=true)
            expected = [
                SegmentEvent(((0.0, 0.0), (3.0, 3.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((0.0, 0.0), (4.0, -4.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((4.0, -4.0), (7.0, -1.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true, true, SegmentAnnotations(false, true)),
            ]
            @test annotated_segments == expected
        end

        @testset "rectangle horiz self annotations" begin
            rectangle_horiz = [
                (-1.0, 0.0), (-1.0, 3.0), (12.0, 3.0), (12.0, 0.0)
            ];
            event_queue = convert_to_event_queue(rectangle_horiz)
            annotated_segments = event_loop!(event_queue; self_intersection=true)
            expected = [
                SegmentEvent(((-1.0, 0.0), (-1.0, 3.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((-1.0, 0.0), (12.0, 0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((12.0, 0.0), (12.0, 3.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((-1.0, 3.0), (12.0, 3.0)), true, true, SegmentAnnotations(false, true)),
            
            ]
            @test annotated_segments == expected
        end

        @testset "self-intersect self annotations" begin
            self_intersect = [
                (0.0, 0.0), (2.0, 2.0), (6.0, -2.0), (11.0, 2.0), (11.0, 0.0)
            ]
            event_queue = convert_to_event_queue(self_intersect)
            annotated_segments = event_loop!(event_queue; self_intersection=true)
            expected = [
                SegmentEvent(((0.0, 0.0), (2.0, 2.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((0.0, 0.0), (4.0, 0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((2.0, 2.0), (4.0, 0.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((4.0, 0.0), (6.0, -2.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((6.0, -2.0), (8.5, -0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((4.0, 0.0), (8.5, -0.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((8.5, -0.0), (11.0, 0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((11.0, 0.0), (11.0, 2.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((8.5, -0.0), (11.0, 2.0)), true, true, SegmentAnnotations(false, true)),
            ]
            @test annotated_segments == expected
        end

        @testset "pentagram self annotations" begin
            pentagon = [
                (-0.8, 0.0), (0.0, 0.6), (0.8, 0.0), (0.5, -1.0), (-0.5, -1.0)
            ]
            pentagram = pentagon[[1, 3, 5, 2, 4]]
            event_queue = convert_to_event_queue(pentagram)
            annotated_segments = event_loop!(event_queue; self_intersection=true)
            expected = [
                SegmentEvent(((-0.5, -1.0), (-0.3062015503875969, -0.3798449612403101)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((-0.8, 0.0), (-0.3062015503875969, -0.3798449612403101)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((-0.3062015503875969, -0.3798449612403101), (-0.18750000000000003, 0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((-0.8, 0.0), (-0.18750000000000003, 0.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((-0.5, -1.0), (-0.0, -0.6153846153846154)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((-0.3062015503875969, -0.3798449612403101), (-0.0, -0.6153846153846154)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((-0.18750000000000003, 0.0), (0.0, 0.6)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((-0.18750000000000003, 0.0), (0.1875, 0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((0.0, 0.6), (0.1875, 0.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((-0.0, -0.6153846153846154), (0.30620155038759694, -0.3798449612403101)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((0.1875, 0.0), (0.30620155038759694, -0.3798449612403101)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((-0.0, -0.6153846153846154), (0.5, -1.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((0.30620155038759694, -0.3798449612403101), (0.5, -1.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((0.30620155038759694, -0.3798449612403101), (0.8, 0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((0.1875, 0.0), (0.8, 0.0)), true, true, SegmentAnnotations(false, true)),
            ]
            @test annotated_segments == expected
        end

        @testset "rectangles intersect annotations" begin
            rectangle = [
                SegmentEvent(((0.0, 0.0), (3.0, 3.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((0.0, 0.0), (4.0, -4.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((4.0, -4.0), (7.0, -1.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true, true, SegmentAnnotations(false, true)),
            ]
            rectangle_horiz = [
                SegmentEvent(((-1.0, 0.0), (-1.0, 3.0)), true, false, SegmentAnnotations(false, true)),
                SegmentEvent(((-1.0, 0.0), (12.0, 0.0)), true, false, SegmentAnnotations(true, false)),
                SegmentEvent(((12.0, 0.0), (12.0, 3.0)), true, false, SegmentAnnotations(true, false)),
                SegmentEvent(((-1.0, 3.0), (12.0, 3.0)), true, false, SegmentAnnotations(false, true)),
            ]
            queue = SegmentEvent{Float64}[]
            for ev in vcat(rectangle, rectangle_horiz)
                add_annotated_segment!(queue, ev)
            end
            annotated_segments = event_loop!(queue; self_intersection=false)
            expected = [
                SegmentEvent(((-1.0, 0.0), (-1.0, 3.0)), true, false, SegmentAnnotations(false, true), SegmentAnnotations(false, false)),
                SegmentEvent(((-1.0, 0.0), (0.0, 0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((0.0, 0.0), (3.0, 3.0)), true, true, SegmentAnnotations(false, true), SegmentAnnotations(true, true)),
                SegmentEvent(((-1.0, 3.0), (3.0, 3.0)), true, false, SegmentAnnotations(false, true), SegmentAnnotations(false, false)),
                SegmentEvent(((0.0, 0.0), (4.0, -4.0)), true, true, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((0.0, 0.0), (6.0, 0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(true, true)),
                SegmentEvent(((3.0, 3.0), (6.0, 0.0)), true, true, SegmentAnnotations(false, true), SegmentAnnotations(true, true)),
                SegmentEvent(((4.0, -4.0), (7.0, -1.0)), true, true, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((6.0, 0.0), (7.0, -1.0)), true, true, SegmentAnnotations(false, true), SegmentAnnotations(false, false)),
                SegmentEvent(((6.0, 0.0), (12.0, 0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((12.0, 0.0), (12.0, 3.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((3.0, 3.0), (12.0, 3.0)), true, false, SegmentAnnotations(false, true), SegmentAnnotations(false, false)),
            ]
            @test annotated_segments == expected
        end

        @testset "rectangle self-intersect annotations" begin
            self_intersect = [
                SegmentEvent(((0.0, 0.0), (2.0, 2.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((0.0, 0.0), (4.0, 0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((2.0, 2.0), (4.0, 0.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((4.0, 0.0), (6.0, -2.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((6.0, -2.0), (8.5, -0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((4.0, 0.0), (8.5, -0.0)), true, true, SegmentAnnotations(false, true)),
                SegmentEvent(((8.5, -0.0), (11.0, 0.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((11.0, 0.0), (11.0, 2.0)), true, true, SegmentAnnotations(true, false)),
                SegmentEvent(((8.5, -0.0), (11.0, 2.0)), true, true, SegmentAnnotations(false, true)),
            ]
            rectangle_horiz = [
                SegmentEvent(((-1.0, 0.0), (-1.0, 3.0)), true, false, SegmentAnnotations(false, true)),
                SegmentEvent(((-1.0, 0.0), (12.0, 0.0)), true, false, SegmentAnnotations(true, false)),
                SegmentEvent(((12.0, 0.0), (12.0, 3.0)), true, false, SegmentAnnotations(true, false)),
                SegmentEvent(((-1.0, 3.0), (12.0, 3.0)), true, false, SegmentAnnotations(false, true)),
            ]
            queue = SegmentEvent{Float64}[]
            for ev in vcat(self_intersect, rectangle_horiz)
                add_annotated_segment!(queue, ev)
            end
            annotated_segments = event_loop!(queue; self_intersection=false)
            expected = [
                SegmentEvent(((-1.0, 0.0), (-1.0, 3.0)), true, false, SegmentAnnotations(false, true), SegmentAnnotations(false, false)),
                SegmentEvent(((-1.0, 0.0), (0.0, 0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((0.0, 0.0), (2.0, 2.0)), true, true, SegmentAnnotations(false, true), SegmentAnnotations(true, true)),
                SegmentEvent(((0.0, 0.0), (4.0, 0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(true, false)),
                SegmentEvent(((2.0, 2.0), (4.0, 0.0)), true, true, SegmentAnnotations(false, true), SegmentAnnotations(true, true)),
                SegmentEvent(((4.0, 0.0), (6.0, -2.0)), true, true, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((6.0, -2.0), (8.5, -0.0)), true, true, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((4.0, 0.0), (8.5, -0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(false, true)),
                SegmentEvent(((8.5, -0.0), (11.0, 0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(true, false)),
                SegmentEvent(((11.0, 0.0), (11.0, 2.0)), true, true, SegmentAnnotations(true, false), SegmentAnnotations(true, true)),
                SegmentEvent(((8.5, -0.0), (11.0, 2.0)), true, true, SegmentAnnotations(false, true), SegmentAnnotations(true, true)),
                SegmentEvent(((11.0, 0.0), (12.0, 0.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((12.0, 0.0), (12.0, 3.0)), true, false, SegmentAnnotations(true, false), SegmentAnnotations(false, false)),
                SegmentEvent(((-1.0, 3.0), (12.0, 3.0)), true, false, SegmentAnnotations(false, true), SegmentAnnotations(false, false)),
            ]
            @test annotated_segments == expected
        end
    end

    @testset "selection criteria" begin
        function check_selection_criteria(calc_criteria, criteria::Vector)
            for idx in 0:15
                above1 = idx > 7
                below1 = (idx % 8) > 3
                above2 = (idx % 4) > 1
                below2 = (idx % 2) > 0
                expect_filled = calc_criteria(above1, below1, above2, below2)
                #println(idx + 1, " $above1 $below1 $above2 $below2 - ", expect_filled)
                @assert expect_filled ? criteria[idx + 1] != BLANK : criteria[idx + 1] == BLANK
            end
            true
        end

        @testset "intersection" begin
            function is_intersect(above1, below1, above2, below2)
                is_intersect = ((above1 & above2) ⊻ (below1 & below2))
                is_intersect_segments = (above1 & below2) ⊻ (below1 & above2)
                (is_intersect || is_intersect_segments)
            end

            @test check_selection_criteria(
                is_intersect,
                PolygonAlgorithms.INTERSECTION_CRITERIA
            )
        end
        @testset "union" begin
            @test check_selection_criteria(
                (above1, below1, above2, below2) -> (above1 | above2) ⊻ (below1 | below2),
                PolygonAlgorithms.UNION_CRITERIA
            )
        end

        @testset "difference" begin
            @test check_selection_criteria(
                (above1, below1, above2, below2) -> (above1 & !above2) ⊻ (below1 & !below2),
                PolygonAlgorithms.DIFFERENCE_CRITERIA
            )
        end

        @testset "xor" begin
            @test check_selection_criteria(
                (above1, below1, above2, below2) -> (above1 ⊻ above2) ⊻ (below1 ⊻ below2),
                PolygonAlgorithms.XOR_CRITERIA
            )
        end
    end

    @testset "chain segments" begin
        @testset "chain segments - rectangle" begin
            segments = [
                SegmentEvent(((0.0, 0.0), (4.0, -4.0)), true),
                SegmentEvent(((0.0, 0.0), (3.0, 3.0)), true),
                SegmentEvent(((3.0, 3.0), (7.0, -1.0)), true),
                SegmentEvent(((4.0, -4.0), (7.0, -1.0)), true),
            ]
            regions = chain_segments(segments)
            expected = [[(7.0, -1.0), (3.0, 3.0), (0.0, 0.0), (4.0, -4.0)]]
            @test regions == expected
        end

        @testset "chain segments - improper" begin
            segments = [
                SegmentEvent(((0.0, 0.0), (2.0, 2.0)), true),
                SegmentEvent(((0.0, 0.0), (2.0, 2.0)), true),
                SegmentEvent(((2.0, 2.0), (5.0, 1.0)), true),
                SegmentEvent(((2.0, 2.0), (3.0, 5.0)), true),
                SegmentEvent(((3.0, 5.0), (5.0, 1.0)), true),
            ]
            expected = [(0.0, 0.0), (2.0, 2.0), (3.0, 5.0), (5.0, 1.0), (2.0, 2.0)]
            @test_throws AssertionError chain_segments(segments)
        end
    end
end

mutable struct SegmentAnnotations
    fill_above::Union{Nothing, Bool}
    fill_below::Union{Nothing, Bool}
end

SegmentAnnotations() = SegmentAnnotations(nothing, nothing)

==(ann1::SegmentAnnotations, ann2::SegmentAnnotations) = 
    (ann1.fill_above == ann2.fill_above) && (ann1.fill_below == ann2.fill_below)

mutable struct SegmentEvent{T}
    segment::Segment2D{T}
    is_start::Bool
    # Martinez-Rueda properties
    primary::Bool # primary or secondary polygon
    self_annotations::SegmentAnnotations # this polygon
    other_annotations::SegmentAnnotations # other polygon
    # convenience properties
    other::Union{Nothing,SegmentEvent{T}} # links to opposite event
    point::Point2D{T} # is_start ? segment[1] : segment[2]
    other_point::Point2D{T} # is_start ? segment[2] : segment[1]
end

function SegmentEvent(
    segment::Segment2D,
    is_start::Bool,
    primary::Bool=true,
    self_annotations::SegmentAnnotations=SegmentAnnotations(),
    other_annotations::SegmentAnnotations=SegmentAnnotations(),
    )
    point = is_start ? segment[1] : segment[2]
    other_point = is_start ? segment[2] : segment[1]
    SegmentEvent(segment, is_start, primary, self_annotations, other_annotations, nothing, point, other_point)
end

function copy_segment(event::SegmentEvent, is_primary::Bool) 
    # make a copy independent of the original event.
    SegmentEvent(
        deepcopy(event.segment), event.is_start, is_primary, deepcopy(event.self_annotations), deepcopy(event.other_annotations)
    )
end

"""
    ==(ev1::SegmentEvent, ev2::SegmentEvent)

Test equality by comparing attributes but excluding the `other` link.
Use `===` instead if the `other` link is required.
"""
==(ev1::SegmentEvent, ev2::SegmentEvent) = 
    (ev1.segment == ev2.segment) && (ev1.is_start == ev2.is_start) &&
    (ev1.primary == ev2.primary) &&
    (ev1.self_annotations == ev2.self_annotations) && (ev1.other_annotations == ev2.other_annotations)

function Base.show(io::IO, event::SegmentEvent)
    #print(io, typeof(event), "(")
    print(io, "SegmentEvent(")
    print(io, event.segment)
    print(io, ", ", event.is_start)
    print(io, ", ", event.primary)
    print(io, ", ", event.self_annotations)
    print(io, ", ", event.other_annotations)
    #print(io, ", ", event.other)
    #print(io, ", ", event.point)
    #print(io, ", ", event.other_point)
    print(io, ")")
end
